2.67 (2024-11-11)
Application:
- Translations updated: Czech, Russian.

Libraries:
- libgwyddion: ACF and PSDF fitting preset initial guesses were improved.
- libgwyddion: Function for checking for a regular lattice was added, able to
  handle rotation and some moderate defects.
- libgwyddion: gwy_raw_data_size() was updated for the new types added since
  2.65 and gwy_raw_data_size_bits() was added, useful for fractional sizes.
- libgwyddion: gwy_convert_raw_data() can handle 10byte x86 ‘extended’ floating
  point numbers.
- libgwyddion: Functions for filling an array with arithmetic progression and
  accumulation/rewind of array of counts were added.
- libgwyprocess: Function for the entire facet levelling procedure was added.
- libgwyprocess: Function for facet distribution computation was added.
- libgwyprocess: Function for polynomial scan line levelling was added.
- libgwyapp: Workaround was added for data browser drag'n'drop dropping wrong
  data in KDE Plasma in Wayland (and possibly other environments).
- libgwyapp: Log message handling can be modified using a new function.

Modules:
- Curve map fit (new): Fits general functions to curve map curves.
- Curve map volumize (new): Converts regular curve map data to volume data.
- XYZ Reduce (new): Reduces number of points in a XYZ data array. 
- XYZ 1D FFT filter (new): Performs FFT filtering in the XYZ data array,
  treating it as time series of equidistant values.
- PFM (new): Performs processing of vector Piezoresponse Force Microscopy
  data consisting of measurements in two perpendicular directions.
- Periodic translate (new): Translate image in the XY plane, treating it as
  periodic.
- Residue synthesis (new): Simulates surfaces resembling film residue after
  partial dissolution.
- HDF5: Support for Nanosurf NHF file format was added. Missing data units
  in EPFL files were corrected.
- Keyence: Wrong physical data scales and metadata in imported VK3 files were
  corrected.
- Nanoscope: Uses FV Lines for the number of scan lines in force volume data.
- Image export: Fonts with attributes like ‘Bold’ or ‘Italics’ are correctly
  loaded back from settings (instead of the font being reset to default).
  Round interpolation should make images in exported SVGs pixelated and masks
  should always be pixelated in SVG (as they are in PDF).
- Correlation length tool: Rewritten using the new self-consistent ACF paper.
  It also displays ACF and PSDF plots and lots of other improvements.
- Volume equiplane, Z-pos level: Crash for data with Z-calibration was fixed.
- Volume Crop: Missing coordinate units were corrected.
- Mutual Crop: Has a preview, can create new images and allows method
  selection.
- Statistical functions tool: Radial ACF subtracts the mean value
  automatically. Result not being always updated upon masking mode changes was
  fixed.
- Volume slice: Clear selection button was added. Fixed previews not
  correctly updating according to changing selection in some cases.
- Volume plane level: Zero mean value function was added.
- Lattice synthesis: Incorrect lattice scaling was fixed.
- Volume facet level: The progress bar actually works and the computation
  is cancellable.
- Fit terraces (image and graph) and volume and graph ASCII export: Output
  files are written with native EOLs, not always Unix.
- Facet analysis: Manual rotation of points works correctly again.
- Frequency split: A PSDF and filter shape plot was added.
- Grain filter: It now actually reads the ranges file with remembered ranges
  the for various quantities when run non-interactively.

Others:
- Compilation: configure now aborts when basic C99 maths functions like cbrt(),
  hypot() or erf() are not available. Gwyddion code has been using erf()
  unconditionally for many years so the change just makes it manifest.
- Compilation: Various auxiliary Python build scripts, generally used in builds
  from subversion, work with any Python version (2.7 or 3.x). Python checks
  were split into pygwy and interpreter for the scripts. Pygwy compiler and
  linker variables are now prefixed PYTHON2_ instead of PYTHON_.
- Plug-in proxy: Configuring with --disable-plugin-proxy now also prevents the
  installation of all plug-in support files.
- Python: Standalone Python module gwy initialises GTK+ more carefully, making
  it work at least to some degree without a display.


2.66 (2024-05-24)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyprocess: Slow Laplace interpolation for huge amounts of small grains
  was corrected (or at least a workaround added).
- libgwyprocess: HHCF-based fractal dimension estimation method was added.
- libgwyprocess: Crash in smooth 4-pyramid shape fitting preset was fixed.
- libgwydraw: GwyGradients truncated on save were fixed.
- libgwydgets: Format of exported Igor Pro text was corrected.
- libgwyapp: Pasting into GwyParamTable numeric entries was improved. In
  particular too precise numbers can be pasted; they will just be rounded.

Modules:
- ZMG (new): Imports KLA Zeta ZMG profilometry files.
- SCA (new): Imports old SCA data files (somewhat experimental).
- Cyber SCAN (new): Imports Cyber profilometry files.
- SMM calibration (new): Obtains SMM calibration coefficients using a known
  sample.
- Apply SMM (new): Applies SMM calibration coefficients to data.
- HDF5: Support for DATX, NSID and EPFL files was added. Ergo files with
  incomplete measurements can be loaded.
- Igor: Initial support for PXP files was added.
- Shimadzu: ‘Short’ raw data are again correctly read as unsigned.
- Nanoscope: Should be able to read InSight data as a set of profiles. No longer
  rebases TUNA curves to have ZSensor abscissa.
- WSxM: Files which state (lie) the header has a zero length can be imported.
  Value scale of floating point data was corrected.
- Surf: All images are correctly loaded (from single-object files) and
  compressed data are loaded. Exported files should be better compatible with
  other software.
- MI file: Multicolumn ASCII image data can be loaded, for both EOL types.
- Raw graph: Possible crash when file parsing failed was fixed.
- Read Value: Fixed pseudocolour range in zoom sometimes being initially
  adapted even when disabled.
- Mark by threshold: Mark by rank option was added, marking given fraction of
  image pixels.
- Volume flatten base: Maximum polynomial degree can be controlled, height
  inversion option was added and the subtracted background can be extracted.
- Volumize layers: Can now extract offsets to a graph.
- Arithmetic modules: Crash when specifying units manually was fixed.
- Calibrate, Volume calibrate, Curve map calibrate: Match pixel size actually
  matches pixel size, not entire data size. It also sets the units correctly.
- Fractal: Structure function (HHCF) method was added.

Others:
- Build from svn: Parallel rendering of PNG icons was disabled to work around
  Inkscape bug 4716.
- Dependencies: Building with libjxl for JPEG XL support is no longer possible
  because the library does not preserve compatibility and is breaking builds.
  It was disabled.


2.65 (2024-01-04)
Application:
- Menus: Synthetic data function menu was reorganised to hierarchical.
- Translations updated: Czech, Russian.

Libraries:
- libgwyddion: Double-free bug in GwyExpr, possibly crashing Arithmetic
  modules, was fixed.
- libwyddion: gwy_convert_raw_data() now supports also 1, 4, 12 and 24bit
  integer data.
- libgwyprocess: Stability of RMS computation for images with a small
  variation was improved.
- libgwyprocess: Various functions filling or filtering parts of a GwyDataField
  no longer consider zero-sized areas a critical error. Consequently, the
  mask editor should not longer cause them.
- libgwydgets: Wrong images being exported when multiple 3D views were open
  was fixed, hopefully.
- libgwymodule: File modules can now mark themselves as unfinished/broken.

Modules:
- Block step correction (new): Correction of Z steps artefacts occurring during
  scanning, without any line correction.
- Volume XY stitch (new): Merges all XY planes of volume data to XYZ data.
- Andor SIF (new): Imports Andor SIF files, at present only raw data and only
  some file format versions.
- Read Value: Detail image in the tool can optionally show the mask.
- Coupled PDE synthesis: Second type of diffusion reaction model was added.
- HDR image/GwyTIFF: Support for less common features (tiles, planar config,
  bit depths) was improved. TIFF files with any number of channels can be
  imported.
- Object synthesis: Two new shapes, exponential spike and semi-pyramid, were
  added.
- Affine correction: Fixed wild window size changes when vectors were entered
  numerically while displaying the corrected data.
- Line noise synthesis: Steps and Ridges have scanning direction option
  determining orientation of the defects in scan lines.
- Scale: Console warnings about out of range parameters were fixed.


2.64 (2023-10-29)
Application:
- Translations updated: Czech, Russian.

Libraries:
- libgwyddion: New helper for parsing the text representation of a block of
  floating point data.
- libgwyddion: GwyContainer function to pass an object with its reference
  to the container was added.
- libgwyddion: Convenience g_convert() wrapper for the common conversion to
  UTF-8 was added.
- libgwyprocess: A function for mean normal vector with masking was added.
- libgwyprocess: gwy_lawn_set_segments() actually sets the segmentation
  even when the number of segments does not change.
- libgwyprocess: Functions for linear transformations of GwySurface data.
- libgwyapp: New GwyParamTable controls for a generic colour.
- libgwyapp: A helper function to set a colour gradient for fit residuals.
- libgwyapp: GwyDialog function to check if preview was explicitly requested
  by user clicking the Update button.
- libgwyapp: Thumbnails of tiny images are scaled up to the standard size.
- libgwyapp: Brick preview can show the new preview immediately in the data
  window.

Modules:
- Plateaus (new): Stacked plateaus synthetic data generator.
- ZON (new): Imports Keyence ZON files.
- ARDF (new): Imports Asylum Research ARDF files.
- NPY (new): Imports 2D data from Numpy binary serialised arrays and
  exports images to NPY files.
- MAT (new): Imports 2D data from Matlab MAT level 5 files.
- Volume mean plane level (new): Levels all XY planes using the same mean
  plane coefficients.
- Volume 1D FFT filter (new): One dimensional FFT filter in XY planes,
  similar to the image 1D FFT filter.
- Volume mean plane levelling (new): Levels all XY planes in volume data
  using mean plane coefficients from entire data.
- XYZ t-cut (new): Cuts XYZ data as a time series.
- Graph merge (new): Merges/averages all graph curves into one.
- Volume XY arithmetic (new): Arithmetics between volume and image data.
- Volume XY stitch (new): Stitching overlapping XY frames in volume data.
- Volume crop (new): Crop volume data in XY direction.
- Volume flatten base (new): Runs Flatten Base algorithm on all XY planes
- Volume localisation merge (new): Localisation super-resolution algoritm 
  based on work of G. Heath et al., https://doi.org/10.1038/s41586-021-03551-x
- XYZ Z drift (new): Corrects z drift in time series XYZ data
- XYZ crop (new): Crops XYZ data by mouse selection on rasterized preview.
- Volume Drift: Rotation options were added and several bugs fixed.
- Pixmap: JPEG XL support was added (if the corresponding gdk-pixbuf loader
  is found at run time).
- Image export: Choosing arbitrary colours (not just black and white) works
  again. Legacy parameter "outline_width" is no longer read from settings
  and presets; use "inset_outline_width" and "sel_outline_width".  It can
  export to JPEG XL if libjxl is available.
- HDF5: Support for non-image data in Shilps Sciences Lucent files was added.
  Image data can be imported from generic and Matlab 7.x HDF5 files.
- Olympus OIR: Pixel size calibration factors are taken into account,
  correcting small physical size discrepancies.
- HDR image: Uniform multi-page TIFFs can be imported as volume data.
- JPK: Force maps (QI data) are imported as a curve map, replacing the crude
  rasterisation to volume data.
- XYZ Rasterize: It is possible to go back to previous selected area. The
  Field representation has a tunable power parameter.
- XYZ Split: top-down, left-right directions clarified.
- Dimensions and Units: Now also exists for XYZ data.
- Crop tool: Option to crop all compatible images was added.
- Spot remove tool: Offset of actually interpolated area from the selection
  for small images was fixed.
- Statistical quantities tool: Inclination is computed also for masked data.
- Volume equiplane: A few more elementary scanning options were added.
- Volume Z-pos level: Can average over several XY planes.
- Transfer function estimate, volume transfer function: Can show difference
  image with adapted colour mapping.
- Volume transfer function: Uninitialised memory use, causing occasional
  outliers in difference norm plots was fixed.
- Volume stray field: Can show XY slices of both input and calculated data.
  Crashes were fixed and GUI cleaned up.
- Measure lattice: Images with fixed colour mapping are shown correctly in the
  preview instead of (frequently) blank.
- NMM file: Data can be filtered using an error channel and images shown with
  physical aspect ratio by default.
- Sensolytics: Support for 3.x file formats was added, including some complex
  data sources.
- ASCII export: Can read back its own output, mostly. An option to keep the
  informational header untranslated was added.
- 3D formats STL, WSxM: Files are written in binary mode, correcting broken
  files exported in MS Windows.

Others:
- Resources: XKCD Painbow false colour gradient was added. Please do not
  actually use it.


2.63 (2023-06-13)
Application:
- Translations updated: Czech, French, Russian.
- Menus: Volume function menu was reorganised to hierarchical.

Libraries:
- libgwyddion: Bug in rank and median function, sometimes giving incorrect
  value/partial sorting, introduced in 2.62, was fixed.
- libgwyddion: New helper functions for locale floating point number formats.
- libgwyprocess: Fixed bug in gwy_data_line_zoom_fft() accessing an out of
  bound array element.
- libgwyprocess: New GwyDataLine function to calculate slopes (derivatives).
- libgwyprocess: GwyResults floating point values can have minimum number of
  significant digits set.
- libgwyprocess: Rank filter function for GwyDataLine was added.
- libgwyprocess: Wrong real size of gwy_data_field_area_row_psd() by factor of
  2 was corrected.
- libgwyprocess: gwy_data_field_correlation_search() can also compute
  phase-only correlation score.
- libgwyapp: Selection holding support functions in the GwyParams framework and
  GwyPlainTool.
- libgwyapp: New function for merging settings from a string.
- libgwyapp: New GwyParamTable control representing a range. Fixed possible
  crash when trying to assing NULL to a GString.
- libgwyapp: Helper functions for keeping sync graph X-selections with numeric
  range controls.
- libgwyapp: Message logging is OpenMP thread safe; gwy_debug() can be used
  from OpenMP parallel code.

Modules:
- Dunes (new): Sand dunes synthetic data generator.
- Graph Measure Period (new): Measurement of period of 1D periodic data.
- Volume add frame (new): Insertion of XY planes to volume data.
- Volume remove frame (new): Removal of XY planes from volume data.
- Volume plane level (new): Plane levelling of all XY planes of volume data.
- Volume facet level (new): Facet levelling of all XY planes of volume data.
- Volume line level (new): Line correction in all XY planes of volume data.
- Volume drift (new): Drift estimation from a stack of high-speed SPM frames.
- Volume step line correction (new): Step line correction in all XY planes
  of volume data.
- Volume scars (new): Removal of scars in all XY planes of volume data.
- Volume outliers (new): Outlier removal in all XY planes of volume data.
- Statistical quantities, Correlation length and Roughness tools: Buttons
  for copying results to clipboard and saving them to file work again.
- Tools: Most tools can optionally hold the selection and transfer it to the
  other image upon switching, instead of using the selection present there.
- Spot remove tool: Detail can use colour mapping of the image instead
  always adapting it to the zoomed area.
- Mask editor tool: Thin lines can be 4-connected (instead of 8-connected).
- Statistical functions tool: Interface distribution function was added.
- Mask operations: Function extracting grain numbers to an image was added.
- Colour Range tool: New button for shifting data zero to the minimum of
  colour range mapping range. Range adjustment to selected rectangle can
  be disabled.
- Volume 3D view: Occasional crashes and broken visualisations were fixed.
- Volume swap axes: Crash for reversed axes was fixed.
- Olympus OIR: Image properties are matched using UUIDs, fixing sometimes
  mismatched Height/Intensity/Invalid channels. Support for files with an extra
  XML chunk was added and UTF-8 encoded XML chunks are correctly recognised.
- NetCDF: Physical unit support for newer GXSM files was improved.
- OPD: Integer type checking is more lenient, loading some files which were
  previously rejected as invalid.
- HDF5: Mismatched x and y resolutions and physical sizes in Ergo files were
  corrected. String handling, which causes problems with some HDF5 versions,
  was improved. Initial support for Shilps Sciences Lucent files was added.
- MI file: Loading curve maps was implemented and loading of binary single
  curves fixed to actually work.
- Nanoscope: Some single force curve files are no longed misdetected as
  images.
- Correlation search: A preview of the score image was added.

Others:
- Gwyutils: The multidimensional numpy array creation helpers actually create
  data with the correct shape now.
- Dependencies: If nothing else is available, the Zziplib ZIP file handling
  library can be also used to read ZIP-based file formats.


2.62 (2022-11-03)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: GwyResource functions helping with saving them to files.
- libgwyddion: UTF-8 friendly alternative to g_strescape() was added.
- libgwyprocess: Functions for windowing of GwyDataLine and GwyDataField.
- libgwyprocess: A Zoom FFT function was added for GwyDataField.
- libgwyprocess: Use after free in GwyPeaks was fixed.
- libgwyprocess: Crashing deserialisation of GwyLawn with unset array-like
  attributes was fixed.
- libgwyprocess: gwy_data_field_get_local_maxima_list() sometimes returning
  strange maxima lists was fixed.
- libgwydgets: Function for emitting "row-changed" for a range of GwyNullStore
  rows was added.
- libgwyapp: GwyParamDef parameter name and label can be queried.
- libgwyapp: File open dialogue no longer shows ‘???’ as the file type for
  ‘Automatically detected’ when first used.
- libgwyapp: GwyParamTable supports enablers for entries and can fill itself
  from a GwyParams object. Several setup functions for slider alternative
  values were added.
- libgwyapp: GwyPlainTool has a rudimentary GwyParamTable support.
- libgwyapp: GwyResultsExport can handle Copy and Save buttons using user
  provided formatting function.
- libgwyapp: GwyParams values can be assigned to another GwyParams object.
- libgwyapp: Fixed graph functions sometimes being runnable (and crashing)
  even if there was no active graph window.
- libgwyapp: Module utility functions for running subdialogs and expander
  handling.
- libgwyapp: Module utility functions for creation and handling of filtered
  inventory treeviews.
- libgwyapp: Possible crash when the gradient or GL material editor was active
  upon program exit was fixed.

Modules:
- Curve Map Find Position (new): Searches for the first or last occurrence of
  a threshold value.
- Curve Map Lock-in (new): Detects oscillations in curves.
- 2D PSDF and Measure Lattice: Off-centre PSDF images (visible at larger zooms)
  were fixed.
- Measure Lattice: Single-vector mode was added for simple frequency space
  measurements.
- Tip blind estimate: Tip reset button works correctly again.
- Statistical functions: Windowing option was added for FFT-based functions.
- Pattern synthesis: Shape option for Pillars was restored.
- Keyence: Support for VK3 and VK7 files was added.
- Color range tool: Full range labels are updated when image data change.
- Three point level tool: Fixed ‘Apply’ button sometimes being clickable with
  no active data (and crashing).
- Roughness tool: Swedish height parameter was added.
- Raw file import: Parsing of some numbers with comma decimal separator was
  corrected.
- NanoObserver: Detection of v1.33 files, which was not correctly recognising
  some files, was improved.
- NRRD: Parsing of quoted sampleunits was corrected.
- Pixmap: HEIF support was added (if the corresponding gdk-pixbuf loader is
  found at run time).
- Volume summarize planes: The z-level can be selected numerically in both
  pixel and real units. Module preview can either show the selected level or
  the original preview.

Other:
- MS Windows: HDF5 was updated to version 1.10.8, fixing import of Ergo files
  which did not work with HDF 1.8.22.
- Compilation: Modules are always explicitly linked with libm to ensure the
  silent implied linking with libmvec occurs when needed.


2.61 (2022-05-02)
Application:
- Translations updated: Czech, French, Russian.
- Command line: New option --convert-to-gwy merges and converts SPM files to
  the Gwyddion file format.
- Command line: Non-GUI operations --identify, --check and --convert-to-gwy
  avoid more carefully GUI initialisation code, fixing some warnings.

Libraries:
- libgwyddion: gwy_check_regular_2d_grid() gives better offsets and steps.
- libgwyddion: GwySIUnit parser handles better Unicode powers like 10³ or m².
- libgwyddion: New gwy_math_curvature_at_origin() curvature function.
- libgwyprocess: GwyLawn deserialisation segment data size check was fixed.
- libgwyprocess: Elliptic area extraction and unextraction, broken in 2.59,
  work correctly again.  This fixes intersection with an elliptic area in Mask
  Editor tool.
- libgwyprocess: Rectangular pyramid shape fitting preset was added.
- libgwyprocess: Shape fitting preset parameters can have descriptions.
- libgwyprocess: gwy_data_field_row_gaussian() no longer limits kernel size
  using the vertical resolution.
- libgwyprocess: Function for changing the number of GwySurface points without
  immediately filling it with new data.
- libgwyprocess: A Zoom FFT function was added for GwyDataLine.
- libgwyprocess: New function for a linear combination of two GwyDataLines.
- libgwyprocess: GwyPeaks should no longer produce NaN peak widths for odd
  peak shapes.
- libgwydgets: Gwy3DView draws correctly the false colour axis for inverted
  gradients and follows better mapping changes made in the false colour tool.
- libgwydgets: gwy_color_axis_set_unit() invokes a redraw even if the same
  object is set again.
- libgwydgets, libgwyapp: GtkTooltips functions were deprecated (use the simple
  GtkWidget functions instead).
- libgwyapp: Incorrect warning about the default value in
  gwy_param_def_add_string() was fixed.
- libgwyapp: Crash in GwyParamTable radio button row construction was fixed.
- libgwyapp: gwy_param_table_reset() no longer tries to reset foreign controls.
- libgwyapp: New predefined parameter type for a set of grain value groups.
- libgwyapp: A helper function for adding a vector layer to a preview.

Modules:
- Nova ASCII (new): Imports NT-MDT Nova exported ASCII data.
- Indentor analyze: Completely rewritten, with useless quantities removed,
  useful added and region marking improved.
- Dimensions and Units: Bug sometimes causing it to forget the dimensions mode
  was fixed.  For Set range and Correct by factor the unit is remembered in
  settings.
- Graph Flip, Graph FZ to FD: Output data order which was causing problems in
  subsequent processing was fixed.
- Corning: Import of Corning Tropel UltraSort TTF files works now too.
- Nanonics: Raw data conversion factors were improved; some data may still be
  imported wrong.
- Nanoscope: Single force curve rebasing was made more robust.
- Curve Map Nanomechanical Fit, Fit FD Curve: Miscellaneous model improvements.
- GwyTIFF: Byte counts and offsets are read correctly when of type short.
- WRUST: Support for Liczba Kolumn parameter was added. Extra empty lines in
  header are ignored.
- 3D formats: Fixed import of STL files which was reading only some points and
  some multiple times.
- Anfatec: Also imports FV matrix data (as curve maps).  Metadata are created
  from the header file.
- Pixmap, HDR image: Option to simply use the pixel dimensions as the lateral
  dimensions was added.
- Wrap value: Option to keep the current data range unchanged was added.
- Grain correlations: Quantities available for abscissa are updated correctly
  when it is calculated from a different image.
- Measure lattice: Masking support was added.  Vector numbers can be displayed.
  The FFT image is refined.
- Tip model: Can enforce square tip image.
- Fit Shape: Pressing OK again consistently produces output images, whether
  they originate from fitting or just setting parameters manually.  Most
  parameters have tooltips with descriptions.
- Perspective correction: Correction can be applied to all compatible images
  and it can modify the current image (instead of creating a new one).
- Projective selection: Supports crop and move and can be distributed by the
  selection manager tool.


2.60 (2021-11-12)
Application:
- Translations updated: Czech, Russian.
- Menus: Graph function menu was reorganised to hierarchical.
- Command line: Program exit status is now correctly 0/1 when --check finds no
  problems/some problems, instead of the opposite.
- Command line: New option --identify identifies and prints the detected type
  of SPM files.

Libraries:
- libgwyddion: gwy_container_transfer() handles empty prefixes correctly
  (instead of crashing).
- libgwyddion: SI unit decomposition producing wrong decomposed units was
  corrected; it also corrects comparisons with decomposable units like N.
- libgwyddion: GwySIUnit parses correctly units with numbers in denominators
  like ‘nm/100V’.
- libgwyddion: Helper function for UTF-16 to UTF-8 conversions.
- libgwyprocess: New GwyLawn data object representing regular map of irregular
  curve tuples.
- libgwyprocess: Holes fit shape derived quantity R calculation was corrected.
- libgwyprocess: Cross-correlation iteration ranges were corrected for
  odd-sized windows, in particular 1 pixel wide or high.  It was also sped up.
- libgwyprocess: Snednon conical, DMT spherical and Hertz spherical with film
  models were added to FD curve fitting presets.
- libgwydgets: Convenience combo constructor for GwyLawn curve selection.
- libgwydgets: Fixed odd behaviour and possible crashes in graph window measure
  dialog when curves are deleted from the graph.
- libgwymodule: New functions for handling curve map modules and functions.
- libgwyapp: Missing data item sync function for XYZ data was added.
- libgwyapp: Support for GwyLawn curve map data was added to data browser,
  menus, toolbox, file previews, and other data management.
- libgwyapp: Fix of various GwyDialog and GwyParamTable labels showing always
  in English despite being translated.
- libgwyapp: Graph and lawn curve number parameters were added to GwyParams.
- libgwyapp: GwyParamTable supports plain text entries for numbers and strings.
- libgwyapp: Possible division by zero in gwy_synth_sanitise_params() was
  fixed.
- libgwyapp: New menu sensitivity flag indicating that a graph is non-empty.

Modules:
- Curve Map Basic operations (new): Basic operations with curve map data.
- Curve Map Crop (new): Cropping of curve map data.
- Curve Map Extract Curves (new): Extract curves from curve map data.
- Curve Map Summarise Curves (new): Statistics on curves in curve map data.
- Curve Map Cut to Segments (new): Cuts curves in curve map data to approach/
  contact/retract segments.
- Curve Map Align (new): Aligns curves in curve map data to match key points
  (maximum, minimum or zero crossing).
- Curve Map Sine Background (new): Sine background removal from curve maps.
- Curve Map Polynomial Background (new): Polynomial background removal from
  curve maps.
- Curve Map FZ to FD (new): Force-Z to Force-distance curve recalculation for
  curve maps.
- Curve Map Nanomechanical Fit (new): Simple evaluation of Force-distance
  curves for curve maps.
- Curve Map Fit FD Curve (new): Force-distance curve fitting for curve maps.
- Graph Sine Background (new): Sine background removal from curves.
- Graph Flip (new): Graph curve flipping.
- Graph Invert (new): Graph curve inversion.
- Graph FZ to FD (new): Force-Z to Force-distance curve recalculation.
- Quazar NPIC (new): Import Quarzar STM NPIC data files (experimental).
- WRUST (new): Imports AFM data files from Department of Nanometrology, WRUST.
- Wetting (new): Simple wetting front synthetic data generator.
- Dimensions and Units: Reworked to make clear the intent of the changes and
  reapply them without confusion.  Also now provides a similar curve map
  function.
- Fix zero, Zero maximum value: Masking support was added.
- Keyence: Support for VK6 files was added (by reading the embedded VK4 file).
- DM3: Detection was made a bit less strict, helping with some files being
  misdetected as AIST.
- PS-PPT: Rewritten to import data as curve maps.
- Nanoscope: Volume data import was rewritten to import them as curve maps.
  Support for Deep Trench unevenly sampled profile data was added.
- Igor: Units of ‘NapSomething’ images should be correct now.
- Rawfile: Reading files to the very end works even with non-zero skips.
- Omicron MATRIX: Incorrect subgrid calculation, affecting some volume data,
  was fixed.
- Image export: Incorrect coordinates or even crash when drawing a cross
  selection was fixed.
- Particle synthesis: Simulation speed was greatly improved.  A random number
  generation bug was fixed; the same random seed will not generate identical
  image as in previous versions.
- Straighten path: Output orientation can now be chosen.
- Graph modules: No longer executable for empty graphs with no curves,
  meaning they also do not crash in such case.
- Graph statistical functions: Windowing used for PSDF computation is now
  user-controllable.
- Graph export bitmap: Saves also to JPEG/TIFF/BMP according to image file
  extension.  An error is shown if file saving fails.

Other:
- Compilation: Minizip header inclusion should work also with version 3.x.
- Compilation: Failure to compile with OpenEXR 3.x was fixed.


2.59 (2021-06-28)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: gwy_check_regular_2d_grid() for more or less collinear points
  no longer fails with CRITICAL message.
- libgwyddion: Random generator set can fill an array with random numbers,
  generating blocks of them in parallel.
- libgwyddion: Possible buffer overflow in GwySIUnit unit parsing was fixed.
- libgwyprocess: Value-inverted output of local normalisation filter was fixed.
- libgwyprocess: Lateral scale of row-wise PSDF was fixed for area sizes
  smaller than the full data field.
- libgwyprocess: New brick function for in-place flipping.
- libgwyprocess: Elliptic area functions work with ellipses not fully contained
  in the data field.
- libgwyprocess: New Lunette and Exponential shape fit presets were added.
- libgwyprocess: Functions for general linear combination of two GwyDataFields
  was added.
- libgwyprocess: Lattice refinement gives more weight to larger peaks.
- libgwydgets: GwyAdjustBar is redrawn upon value reset to zero, which did not
  always work correctly.
- libgwyapp: GwyParamDef object for definition of module parameters.
- libgwyapp: GwyParams object holding sets of parameter values.
- libgwyapp: GwyParamTable module user interface helper handling most common
  types of settings more or less automatically.
- libgwyapp: GwyDialog dialog subclass with GwyParamTable integration and
  support for the typical data processing module main loop.
- libgwyapp: Several data processing module helper functions were added for
  preview or same-unit checking.
- libgwyapp: Merging files now ensures volume data previews exist.  Empty
  volume data previews in file open dialogue were corrected.
- libgwyapp: Data browser no longer leaks preview image pixbufs.
- libgwyapp: Occasional spurious warning that target log must not exist was
  fixed.
- libgwyapp: GwyDataChooser tries to avoid refiltering tree models of live
  combo boxes since it seems to cause problems in some GTK+ versions.
- libgwyapp: Several new module helper functions, mainly to simplify synthetic
  data modules.

Modules:
- PS-PPT (new): Import of Park Systems PS-PPT spectra files (experimental).
- JEOL TEM (new): Import JEOL TEM images (experimental).
- NanoScan: Crash for some multicurve data files was fixed.
- Perspective correction: Pixel dimensions of the output can be set manually.
- Pattern synthesis: Siemens star now has a slope parameter. Wrong displayed
  physical value of Siemens star edge shift was corrected.
- Lattice synthesis: Silicon 7x7 surface reconstruction lattice was corrected.
- Statistical quantities: Misplaced ‘Other’ label was corrected.
- Omicron MATRIX: Possible crash with mismatched data file names was fixed.
  Scanning directions should now be correct, with no more blank images created
  for non-existent scanning direction.  Subgridding is recognised for volume
  data.  Approach/retract is recognised.  Most spectra files should load
  correctly now.
- RHK SM4: Images are vertically flipped according to the sign of y scale.
  More metadata were added.
- Unisoku: Files with missing log flags in the headers can be loaded now.
- Cross-correlation: Critical warning when running in the simple mode was
  fixed.
- Align rows: The Matching method no longer uses uninitialised memory when
  masking is applied.
- Unrotate: Has all the resizing, masking and grid options of Rotate.
- 1D FFT Filter: Leaking curve models objects were fixed.
- Logistic regression: Was sped up using OpenMP.
- Fit terraces: Stopped writing forgotten debugging file ‘terraces.gwy’ to the
  current directory.  Sensitivity of survey controls was corrected.
- Revolve arc, Revolve sphere: Option to invert height (revolve on the top
  side) was added and behaviour for non-square data fixed in arc revolution.
  Functions were separated to two modules.
- PSIA: Images with swapped slow and fast axes are no longer physically
  transposed upon import.  Physical aspect ratio is enabled by default.
- Select Inscribed Discs, Select Circumscribed Circles: Work correctly for
  images with top-left corner different from (0,0).
- Facet measurement: Facets can be optionally marked instantly.
- Mutual crop: Faster FFT-based correlation search is used.  Undo works
  correctly for images coming from two different files.
- Rank filter: Failed assertion when using 100% percentile was fixed.
- XY denoise: Option to average the two possible outputs was added.
- Coerce: The lowest level in uniform discrete levels actually consists of the
  corresponding height range now.
- DWT: Inverse transform option was added.
- Alicona: Recognition of invalid values was improved.  RGB channels are read
  correcly instead of replicating Red three times.  RGB pseudocolour maps are
  used for the RGB channels.
- Immerse: Drawing of the detail on the large image can be switched on and off.
- PID: Non-reproducible results due to uninitialised memory use were corrected.
  Computation was considerably sped up.
- Grain summary: Numerical density was added.
- Binning, Extend, Mask distance transform, Median level, PID, Revolve arc,
  Revolve sphere, Tilt: Have a preview now.
- Various modules: User interface was reworked and may parameters can now be
  entered both in pixels and real units.
- Area function: Area and uncertainty curves have different colours now.
  Target graph option was added.
- Indentor analyse: Possible crash due to failed levelling was fixed..
- Hertz: Temporary data fields are no longer leaking upon preview.
- Noise synthesis: A density parameter now allows perturbing only some of the
  values.  Salt and pepper noise type was added.
- Line noise: Hum generator was added.
- Phases synthesis: Starting from the current image actually does something
  now – it uses the FFT phase of the source image for initialisation.
- Domain synthesis: Presets for a few interesting patterns were added.
- Diffusion synthesis: Schwoebel barrier option is controlled by a checkbox.
  The simulation runs a bit faster.
- Columnar synthesis: Simulation speed was improved, namely for large coverage
  values.  Z-scaling of input surfaces is more logical.  The same random seed
  will not generate identical image as in previous versions.
- Disc synthesis: Pattern changes more continuously with parameter changes.
  Generator speed was improved.
- Synthetic data modules: Setting keys for image dimensions have been moved
  to a subkey "/dims" and units are now full including any power of 10 prefix.

Other:
- Dependencies: New optional dependency JANSSON for PS-PPT import.


2.58 (2021-02-09)
Application:
- New translation: Japanese.
- Translations updated: Czech, Russian.

Libraries:
- libgwyprocess: Masked plane levelling works again.
- libgwyprocess: Root mean square slope function data field function was added.

Modules:
- Perspective correction (new): Correction of perspective distortion.
- Projective layer (new): Vector layer for selection of perspective rectangles.
- Pattern synthesis: Substantially rewritten with more patterns and more
  controllable parameters.  Pattern parameters are not backward-compatible
  with previous versions.
- Statistical quantities: Root mean square slope (Sdq) was added.
- Selection manager tool: Machine-readable number format is always used in
  exported selections.  Support for projective selections was added.
- Renishaw: z-scans mapping is loaded now as separate graphs. Metadata 
  loading from pset is slightly fixed.


2.57 (2020-12-28)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: Fourth and fifth order polynomials NLFit presets were added.
- libgwyddion: Wrong heights fitted by Smooth slanted step model (by factor
  2/π) were corrected.
- libgwyprocess: Artefacts in results of multithread min-max based filters
  (erosion, dilation, opening, closing, etc.) were corrected.
- libgwyprocess: Occasional completely empty borders produced by
  gwy_data_field_new_rotated() were corrected.
- libgwyprocess: Gaussian smoothed cone and pyramid shape fit preset models
  were added.
- libgwydgets: GwyDataView avoids trying to create zero-sized pixbufs, which
  could lead to rare crashes for large aspect ratio images.
- libgwydgets: gwy_graph_model_set_units_from_data_field() now emits
  notification that units have changed as it should.
- libgwyapp: Tool window properties no longer clutter the data processing log.

Modules:
- Evovis XML (new): Import of Evovis XML profilometry data.
- Classify (new): Classification based on neural networks trained on examples.
- Mask shift (new): Shifts mask horizontally and/or vertically.
- Multiprofile (new): Displays simultaneously equivalent scan lines from
  several images.
- Good mean profile (new): Finds good representative profile from images of
  repeated scanning of the same feature.
- GSF: NaNs and Infs are filtered out upon import.
- Nanonis DAT spectra: Files with ‘Save Date’ instead of ‘Date’ in the header
  are recognised.  The first column is always used as the abscissa.
- MicroProf: Support for v1.01 files was added.  Metadata support was improved.
- Anasys XML: Rotated images are no longer created with insanely large
  pixel dimensions, possibly exhausting memory.
- Indentor analyze: Swapped A_d and A_p were corrected.
- Neural network training: Difference preview was corrected to actually show
  the difference between signal and neural network output.
- Mask morph: Preview was added.
- Domain synthesis: Animated preview of the continuous inhibitor field works
  again.
- HDR image: Enabled support for LZW and PackBits compressions, relevant for
  Win64 where the internal GwyTIFF reader is used for generic TIFF images.
- WSxM: Data type ‘short’ is now recognised.  Import support for curve (.cur)
  files was added.
- Olympus OIR: The import no longer expects a specific order of file parts;
  images can be imported from files with any part order.
- Anfatec: Broken import of non-square images due to mixed up xPixels and
  yPixels was fixed.

Other:
- Clang: Detection of which warning options the compiler knows should now work
  with clang.


2.56 (2020-06-30)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: Misparsing of long unit names starting with ‘Nan’ was fixed.
- libgwyddion: The broken and misguided geometric fit option of GwyNLFitter
  was made no-op.
- libgwyprocess: Power-exponential ACF fitting function was added.
- libgwyprocess: Function for conversion from 2D PSDF to angular spectrum was
  added.
- libgwyprocess: Unmasked gwy_data_field_area_dh() using data from the wrong
  place in the data field was corrected.
- libgwyprocess: ACF and HHCF functions with levelling argument now support
  value 2 (tilt removal).
- libgwyprocess: Functions for getting 1D minima and maxima positions with
  masking.
- libgwyprocess: Basic GwyDataLine arithmetic functions were added.
- libgwyprocess: Critical dimension circle functions work again.
- libgwyprocess: Half-sphere fitting shape was added.
- libgwyprocess: Local maxima refinement no longer needlessly fails when there
  are just a small total number of maxima.
- libgwyprocess: Vertical data field windowing using horizontal resolution as
  the size was fixed.  Windowing was changed from periodic to symmetric.
- libgwydgets: GwyDataWindow function for settings the zoom to fit the window
  reasonably to the screen was added.
- libgwyapp: Random crashes when showing graph thumbnails/previews due to
  double-free were fixed.
- libgwyapp: Occasional wrong real rectangular selection coordinates due to
  X and Y mix-up were fixed.
- libgwyapp: Workaround was added for occasional creation of huge windows when
  physically square display is enabled.

Modules:
- HDF5 (new): Imports HDF5-based SPM formats, currently Asylum Research Ergo.
- Correlation length tool (new): Simple quick correlation length estimation.
- 3D formats (new): Exports data as 3D geometry definition files STL, PLY, OBJ
  and VTK; also imports point clouds.  It replaced the VTK export module and
  raw XYZ data import module.  XYZ can be rasterised directly upon import.
- VTK export, Raw XYZ import: Were removed and replaced by 3D formats.
- Nanoscope: 32bit files starting ‘EC File list’ are correctly read as 32bit.
  Trailing zero-filled segments are removed from single force curves.  Force
  curves should finally be imported with correct physical scales.
- WSxM: Data type ‘integer’ is recognised.
- Olympus OIR: Calculation of physical dimensions was corrected.
- WSF file: The Units header field is recognised and used for Z units.
- DM3 and DM4: Metadata support was added.
- Graph terraces: Can scan over a range of polynomial degrees and/or edge
  broadenings and save the table with results for all combinations to a file.
- GDEF: Support for boolean value type was added.
- Affine correction: Refine button broken by an ACF vs. PSDF mix-up was fixed.
- Cross profile tool: Possible crash when switching to image which already has
  a selection was fixed.
- Align rows: Pure tilt correction method, similar to Facet level, was added.
- Line noise synthesis: New ‘Tilt’ noise type tilts scan lines randomly.
- Image export: Font name handling was changed, hopefully fixing inability to
  change the font on some systems.  Outline drawing was improved.
- Statistical functions: Angular spectrum function type was added.
- Row/Column statistics tool: Minimum and maximum position were added.
- 2D ACF: Reciprocal value of Str parameter was corrected.
- 2D PSDF: Parameters Std and Stdi were added.
- Step line correction: Image mean value is preserved.

Other:
- Build from svn: Test for Inkscape version was added and the correct command
  line options are used accordingly.


2.55 (2019-11-04)
Application:
- Keyboard shortcuts: F3 shows/hides current tool window.
- Translations updated: Czech, Russian.

Libraries:
- libgwyprocess: Functions to add data field to all brick xy-planes and data
  line to all z-lines were added.
- libgwyprocess: Function for binning into an existing data field was added.
- libgwyapp: Common initialisation function for batch-style programs utilising
  Gwyddion libraries was added: gwy_app_init_nongui().
- libgwyapp: Critical warning in gwy_app_wait_finish() when waiting is disabled
  was fixed.
- libgwyapp: It is no longer necessary to create GwyBrick preview images
  manually; an average value image is added on the fly if necessary.

Modules:
- Resample (new): Resamples image to specified pixel size or to match pixel
  size of another image.
- Volume rephase (new): Cyclically shifts data blocks to correct erroneous
  volume data files.
- Volume equiplane (new): Creates images from isosurfaces in volume data.
- Volume Z-pos level (new): Shifts values in z curves to be zero at defined
  position.
- Pixmap: Hue mapping type was added.
- Rotate: Mask handling was made more consistent.
- FFT synthesis: Generalised Gaussian multiplier (arbitrary power) was added.
- Pattern synthesis: New Siemens star shape generator was added.
- Tescan: Can load images split into -png.hdr and .png files.
- SPIP ASC: Import support for profile (1D) data was implemented.
- Surfstand SDF: Can read binary ISO-1.0 version files, with bad value
  handling and tries to recognise Olympus binary files with longer headers.
- Olympus OIR: Physical dimensions and metadata were implemented.  File
  structure is recognised a bit better.  An attempt was made to unmix mixed up
  LSM channels.
- Leica: Can read 12bit images.  Volume data z range was fixed to always
  positive.
- MicroProf: All images in a file should be imported now.  More files can be
  imported thanks to improved file parsing.  Outside pixels are masked.
- LEXT: Calibration parameters are read and applied.  Metadata support was
  added.
- Nanoscope: Force curve pairs are merged to have ZSensor data on the abscissa,
  as for force volume data.
- Dimensions & Units: Reset button no longer resets to inconsistent state when
  units that will be actually set differ from displayed units.
- Grain remove and Spot remove tools: Option to fill data with zero was added.
- Laplace: Function for simply filling masked data with zero was added.
- XYZ Rasterize: Can create mask over empty regions for Average interpolation.
- Fit terraces, Graph terraces: Fit results can be exported.
- Correlation Search: Mask can be used in object mark mode.

Other:
- Dependencies: GLib 2.32 and GTK+ 2.18 are now required.
- MS Windows: Packages were built with ZIP support again.
- Compilation: Detection of ZIP libraries works again (version 2.54 always
  reported them as available, but did not actually use them).
- Plug-in proxy: Plug-in examples are now only installed as documentation in
  source code form, not executable into libexec.


2.54 (2019-08-27)
Application:
- Remote control: When Gwyddion is given files to open and is not run from
  terminal, it behaves as if --remote-new was the default to make setting up
  file associations easier.
- Menus: New submenu Measure Features was added to Data Process and several
  functions moved there.
- Toolbox: A critical warning upon keypress when Gwyddion starts with the Tools
  part of the toolbox collapsed was fixed.
- Toolbox: About dialogue shows correct build date in non-English locales for
  builds directly from svn.
- Command line: Option --version prints build/release date in parentheses and
  adds +SVN for builds directly from svn, similar as in the About dialogue.
- Translations updated: Czech, French, German, Russian.

Libraries:
- libgwyddion: Use of uninitialised memory on Mac when constructing data paths,
  causing Gwyddion not to find its data, was fixed.
- libgwyddion: Deadlock when more than two GwyNLFitter objects exist
  simultaneously was fixed (introduced in 2.53).
- libgwyddion: GwyNLFitter initial residuum calculation in approximately
  geometric fits was corrected, fixing their occasional instability.  Possible
  inconsistency in returned best rss and best parameters was fixed.
- libgwyddion: Memory leak in gwy_fprintf() in MS Windows was fixed.
- libgwyddion: GwyResults function for formatting table rows with mixed value
  types was added.  Formatted error no longer persists after a value with error
  is set to N.A.
- libgwyprocess: 2D FFT functions ignoring windowing and levelling arguments
  (by using original GwyDataFields for FFT) were fixed.
- libgwyprocess: Slighty wrong row-wise PSDF output GwyDataLine real size
  (usually by factor 1+2/N) was corrected.
- libgwyprocess: Sign convention of raw C2R GwyDataField transform was fixed.
- libgwyprocess: An assertion possibly failing in gwy_spline_sample_uniformly()
  was corrected.
- libgwyprocess: A plain FFT-based data field convolution function was added.
- libgwyprocess: New Gaussian step filter function was added.
- libgwyprocess: GwyDataLine ACF and HHCF functions set output units correctly
  and were sped up using FFT.
- libgwyprocess: Mirror extension for GwyDataField, broken in 2.53, was fixed.
- libgwyprocess: MFM perpendicular stray field calculation function with
  cantilever tilt correction was added.
- libgwyprocess: Extra factor √π in GwyShapeFitPreset step fitting functions
  parameter h was correcred.
- libgwyprocess: Fixed gwy_fft_simple() possibly overwriting input arrays.
- libgwyprocess: Possible crash in multithreaded tip blind estimation was
  fixed.
- libgwydgets: Gwy3DView supports export of pixbufs with sort of transparency.
- libgwydgets: GwyDataView can take keyboard focus.
- libgwyapp: Rectangular selection width and height displayed by GwyPlainTool
  were corrected; 2.52 and 2.53 showed the opposite corner coordinates instead.
- libgwyapp: Support for transparent PNG export of 3D view was added.
- libgwyapp: Support for extra widget in wait dialogues was added.
- libgwyapp: Workaround was added for GwyDataChooser updates sometimes
  producing a Critical warning ‘assertion 'left_attach < right_attach' failed’.

Modules:
- Wrap value (new): Rewraps values periodic in z to a different split point.
- Fit terraces (new): Fits step height from terrace structure measurement.
- Graph terraces (new): Fits step height from terrace structure measurement.
- Graph statistical functions (new): One-dimensional statistics from curves.
- Olympus OIR (new): Imports of OIR and POIR files (experimental).
- Gaussian step (new): Step detection by convolution with a Gaussian step.
- Zero crossing (new): Split from Edge to a separate module.
- Corning CSV (new): Imports Corning Tropel UltraSort exported CSV data.
- Annealing synthesis (new): Generates images by simulated annealing of a
  two- or three-component lattice gas model.
- Coupled PDE synthesis (new): Generates images using coupled non-linear
  partial differential equations.
- Radial smoothing (new): Radially averages image around its centre by
  smoothing in polar coordinates.
- Displacement field (new): Distorts scan lines or images in plane using either
  a generated random displacement field or another image.
- Nanonis: Import of incomplete scans was corrected.
- Omicron Matrix: Support for volume spectroscopy data was added.  Data with
  two ‘--’ in the file name are imported correctly.
- Grain correlations: Each grain quantity can be calculated from a different
  image.
- Transfer function (PSF) guess: Zoom was removed; instead the transfer
  function can be cut to arbitrary size.
- Anasys XML: Support for compressed files (AXZ) was added, also no longer
  creates empty spectra sets and imports all spectra channels.
- Area function: A specific range can be now selected.
- NMM file: Alignment of profiles to X axis is optional.  Rotation of
  everything by 180 degrees was corrected.
- Volume summarize planes: Output graph units are set correctly.  Selected
  target graph is actually remembered to next invocation.
- Nanoscope: Operating mode detection (image/force/force volume) was improved.
- Row/Column statistics tool: Useless interpolation option was removed.
- Convolve: Kernel size can be up to image size when output size is not ‘Cut to
  interior’.
- Deconvolve: Added L-curve based search for optimum regularization parameter.
- Domain synthesis: Was sped up using OpenMP, but the same random seed now
  produces a different image than in previous versions.
- Domain, Diffusion, Ballistic deposition and Columnar synthesis: Wait
  dialogues show progressive preview (if enabled).
- Cross profile tool: Curve doubling in vertical mode was corrected.  Wrong
  vertical selection in images with non-square pixels was corrected.
- 2D ACF, 2D PSDF: Profile graph always has at least some minimum height.
- Mark by Segmentation: Curvature contribution broken for non-square images
  was fixed.
- Radial profile tool: Automatic profile centre refinement method was improved.
- Layers: Selections can be modified using keyboard if the data view has
  keyboard focus.
- MFM Perpendicular Field: Cantilever angle correction was added.
- Pattern synthesis: Amphitheatre pattern was added, generating systems of
  concentric terraces.
- Relate: Wrong displayed units of some parameters were corrected.
- Particle synthesis: Revise parameter is no longer ignored.
- Alicona: Import of depth images broken with GCC's fast-maths was corrected.
- Pixmap: WebP support was added.  Selected mapping type is mostly preserved
  in next invocation, unless the channel is unavailable.
- Image export: White and Black buttons also display white and black swatches.

Other:
- Dependencies: Support for minizip 2.x as ZIP file handling library was added
  and we no longer try to use minizip 2.x in 1.x compatibility mode (broken).
  The ZIP library to use can be controlled by --with-zip= configure option.
- OpenMP: Workaround for GCC 9 compilation failure caused by incompatible
  changes in OpenMP specs was added.
- OpenMP: Gwyddion links with OpenMP-enabled FFTW if it is found.
- Appdata: Appdata file was added.


2.53 (2019-02-28)
Application:
- Command line: Option --debug-objects is accepted but has no effect any more.
- Command line: New option --new-instance runs a new instance unconditionally
  (currently only useful for overriding preceding options).
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: Interface for controlling the use of OpenMP in data processing
  functions were added.
- libgwyddion: Broken GwyResults parenthesisation of values with errors in
  Colon style was corrected.
- libgwyddion: Setting values to N.A. in GwyResults invalidates formatted
  results the same way as setting them to a valid number.
- libgwyddion: Integer power function gwy_powi() was added.
- libgwyddion, libgwyprocess: Various local static data were removed or
  guarded by locks to improve thread safety.
- libgwyprocess: Possibly incorrect output of
  gwy_data_field_area_grains_tgnd_range() when min and/or max was inside the
  value range was fixed.
- libgwyprocess: Function for finding maximum-area inscribed rectangles into
  grains was added.
- libgwyprocess: Odd area and width values for small peaks calculated with zero
  background were corrected in GwyPeaks.
- libgwyprocess: gwy_data_field_area_filter_kth_rank() not invalidating cached
  quantities of the field was corrected.
- libgwyprocess: Trimmed mean filter function was added.
- libgwyprocess: Plane, One and double-sided step, Cone and Pyramid (3-sided)
  fitting shapes were added.
- libgwyprocess: gwy_data_field_get_autorange() possible crash on data fields
  with strange data was fixed.
- libgwydgets: GwyAdjustBars scroll at least by one step upon scroll events
  when snapping.
- libgwyapp: Helpers for filling graphs and curves in GwyResults were added.

Modules:
- Relate (new): Finds a linear relation between two images.
- Frequency split (new): Splits image into high and low frequency components.
- Radial profile tool (new): Separate tool for angularly averaged profiles.
- Cross profile tool (new): Reading of scan lines or columns.
- Cross layer (new): Simple vector layer for selection of horizontal, vertical
  or both lines.
- Facet measurement (new): Alternative facet measurement tool, focused more
  on providing a defined output than playing with the facets.
- K-th rank filter (new): General k-th rank image filter.
- Trimmed mean (new): Trimmed mean filter and/or background removal.
- XYZ operations (new): Simple operations with XYZ data, currently merging.
- Profile tool: Radial profiles were moved to a new separate tool.
- Correlation search: Inverted meaning of threshold value was corrected.
- Rawfile: Reading of user-defined data of sizes not multiples of 8 bits was
  corrected.  User-defined data item size can be up to 56 bits now.
- Dektak VCA: Import of files with matrix data type 69 was implemented.  Images
  are shown with physically aspect ratio by default.
- HDF4 file: PSI files with binary header lengths shorter than 202 bytes should
  be also importable now.
- MetroPro: Crash upon reading the header but failing to read data was fixed.
- Read value tool: A zoomed view of neighbourhood of selected point is shown.
  Units are correctly updated when image units change.  Curvature values are
  cleared when no image is active.
- Spot remove tool: The marked area can also be elliptic.
- Spot remove and Read value tools: Maximum area size was slightly increased.
- Spot remove and Grain remove tools: More efficient Laplace interpolation
  function is used.  A fractal-Laplace blend interpolation method was added.
- Find graph peaks: Option to invert data and find valleys instead was added.
- Grain Statistics: Functions Select Inscribed Rectangles and Select Bounding
  Boxes were added.
- Facet Analysis: Reset Rotation button was added to rotation controls.
- Graph Statistics: Wrong units of variation were corrected.  Parameter table
  has standard export controls now.
- Arithmetic: No longer produces NaNs and infinities; they are masked and
  replaced with a fixed filler value or Laplace interpolation.
- Calibration, Volume calibration: No longer gets stuck in an infinite loop if
  negative value range calibration factor was used.  Zero data value range
  remains zero instead of producing NaNs.
- Stitch: Only image with compatible units are offered and units of the result
  are set correctly.

Other:
- OpenMP: Gwyddion can be built with OpenMP parallelisation support and does so
  if OpenMP at least 3.1 is available.  Libraries use single-thread processing
  by default; OpenMP must be switched on explicitly.  Gwyddion, the program,
  does so.
- OSX build: Failure due to the wrong #include in mac_integration.c was fixed.


2.52 (2018-11-14)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: System exp10() is used as backend for our pow10() function when
  the latter (obsolete one) is not provided by the system.
- libgwyddion: gwy_math_find_minimum_1d() termination condition was improved.
- libgwyddion: Function for measuring string width in a fixed font was added.
- libgwyprocess: GwyDataField function for mean square value was added.
- libgwyprocess: Broken Laplace exterior in gwy_data_field_ext_convolve()
  was fixed.  Laplace interpolation producing constant values for data of
  very small absolute magnitude was corrected.
- libgwyprocess: gwy_data_field_find_regularization_sigma_for_psf() was
  improved.
- libgwyprocess: gwy_data_field_deconvolve_regularized() is a bit faster now.
- libgwyprocess: PSF reconstruction using least squares problem solution was
  added, with the corresponding sigma optimisation function.
- libgwyprocess: Rare crash inside gwy_data_field_fill_grain() was fixed.
- libgwyprocess: Row corrections (most of Align Rows) are available as library
  functions.
- libgwyprocess: Functions for measuring dispersion when data field is taken
  as a distribution.
- libgwyprocess: Pixel/voxel size functions for all regular data objects were
  added.
- libgwyprocess: Brick z-axis calibration copying function was added.
- libgwyprocess: gwy_someting_assign() convenience macros were added for all
  basic data objects.
- libgwyprocess: Simpler brick functions working with entire XY planes and
  Z profiles.  Arguments keep_offsets are actually implemented now.  Summary
  functions working in the XZ plane were fixed.
- libgwyprocess: Function for taking data field absolute value was added.
- libgwyprocess: Histogram-like functions possibly trying to create DataLines
  with negative real size in edge cases were fixed.
- libgwydgets: GwyDataWindow shows value under mouse pointer also in base
  (unprefixed) units.
- libgwydgets, libgwyapp: Off-screen graph rendering uses screen's default
  visual instead of best which might not work.
- libgwyapp: Items in data browser can be renamed by plain double-click.
- libgwyapp: gwy_rect_selection_labels_fill() shows consistent real dimensions
  and gives consistently the same isel for entire field and no selection
  present.
- libgwyapp: Inverted assertion in gwy_app_wait_set_enabled() causing a
  Critical warning was corrected.

Modules:
- Anasys XML (new): Imports Analysis studio XML (.axd) files.
- AFM Workshop spectra (new): Imports AFM workshop single point spectra.
- Nanosystemz (new): Imports Nanosystemz profilometry data files.
- Volume plane level (new): Simple levelling of volume data planes.
- Volume outliers (new): Removal of outliers in volume data planes.
- Deconvolve (new): Simple regularised deconvolution.
- Transfer function guess: Windowing option was added.  Zoomed central part of
  TF can be displayed and extracted.  A second guess method was added, least
  squares problem solution.  Sigma fitting was improved.  Various GUI
  improvements.
- Volume transfer function: Improvements from the image module were integrated.
  Regularisation parameter can be estimated per plane.
- Extend: New extended image dimensions are displayed.   Masks and
  presentations are extended correctly.
- Dimensions and Units (image and volume): New units are remembered and unit
  change is applied when function is re-run non-interactively.
- VTK export: Z-scaling can be specified manually.
- Crop: Selection dimensions are always editable when a data window is active.
- Grain statistics: The grain statistics table can be exported.
- Pygwy: Missing reference in gwy_app_file_load() was corrected.
- Line correct: Marking of rows with inverted sign (Mark Inverted Rows) added.
- Volume and image MFM recalculation: Warnings upon pressing Reset were fixed.
  They can modify an existing image/volume data.
- Surffile: Micron symbols written using old MS DOS code pages are recognised.
- Volume Cut'n'Slice: Multiple-plane selection actually extracts several
  different planes now.
- ACF 2D, PSDF 2D: Lines selected in the dialogue for profiles are also
  selected in the output image.
- Nanoscope: Reading of text files, broken in 2.51, was fixed.
- Volumize layers: Preview image has actually the same dimensions as brick
  XY plane now.
- Statistical quantities: Entropy was removed as too slow (use the separate
  Entropy function), scan line discrepancy was added.
- Nanonis: Vertical flipping can be controlled via a settings value.
- Cross-correlation: The OK button is insensitive when no image to correlate
  with is selected, fixing a crash when it was run with no second image.
- Measure lattice: Vector a₁ being printed second time as a₂ in exported
  reports was corrected.

Other:
- Compilation: False positives in tests for supported gcc warning options were
  hopefully fixed.
- Python: Python scripts were changed to explicitly say python2 in the shbang
  lines instead of python.  Standalone gwy module disables progress bars by
  default.
- GConf: The obsolete GConf-based thumbnailer support was removed and its
  schemas are no longer installed.
- Source code: Source files for gwyddion, the program, were moved from app to
  separate directory gwyddion.


2.51 (2018-06-26)
Application:
- Translations updated: Brazilian Portuguese, Czech, French, Russian.
- Toolbox editor: Possible crash when adding a new group was fixed.

Libraries:
- libgwyddion: New functions available in GwyExpr: step, spow (signed pow),
  exp2, log2, sinc.  If the system maths library provides them, the following
  are also available: erf, erfc, lGamma, Gamma, J0, J1, Y0, Y1.
- libgwyddion: gwy_sinc function was added for the cardinal sine function.
- libgwyddion: New GwyResource methods for resource deleting and renaming,
  including corresponding on-disk operations.
- libgwyddion: Function for decomposing GwySIUnit to base units was added.
  More degree variants and a few other odd units are recognised.
- libgwyddion: One-dimensional minimum search function was added.
- libgwyprocess: Functions for magnetic force microscopy data modelling and
  handling were added.
- libgwyprocess: New tip model, ball at the end of cylinder, was added.
- libgwyprocess: New GwyBrick functions: copy, transposition, compatibility
  checking, setting a plane.
- libgwyprocess: Speed of various GwyBrick summary operations such as
  gwy_brick_mean_plane() was considerably improved.
- libgwyprocess: Function for bounding boxes of periodic grains was added.
- libgwyprocess: RMS grain quantity was added.
- libgwyprocess: Simple regularised deconvolution function was added.
- libgwyprocess: New k-th rank filter with arbitrarily shaped kernel function.
- libgwyprocess: New function for calculation of 2D PSDF from masked data.
- libgwydgets: Helper functions for managing a group of check boxes which
  correspond to a set of bit flags (gwycheckboxes) were added.
- libgwydgets: GwyGraphModel has new functions for deriving units from a
  GwyDataField and replacing a curve model at given index.
- libgwyapp: Helper functions for managing module data in the user directory.
- libgwyapp: Failed assertion message when restoring file open dialogue file
  name filter from settings was corrected.
- libgwyapp: Critical warning when deleting XYZ data channel was fixed.

Modules:
- Ambios profile (new): Imports 1D profilometry data (both XML and DAT).
- Volume ASCII export (new): Export of volume data to various text formats.
- Volume Arithmetic (new): Arithmetic operations with volume data.
- Volume summarize planes (new): Plots graphs of dependencies of volume data
  plane statistics over z.
- Volume stray field (new): Checks consistency of volume MFM data.
- Volume and image MFM recalculation (new): Converts MFM data to force
  gradient.
- Volume transfer function (new): Plane-by-plane estimation of point spread
  functions in volume data planes corresponding to different levels.
- Area function (new): Calculates the tip area function.
- Hertz (new): Calculates the apparent Young's modulus of a rough surface
  according to Hertzian contact theory.
- Phoenix (new): Imports AFM data files from NASA Phoenix Mars mission.
- Disc synthesis (new): Generates surface randomly covered by discs or tiles.
- XYZ Channels (new): Create XYZ data from three images (values and precise
  X and Y coordinates).
- DM3: Raw data are no longer scaled by inverse maximum representable value.
- Coerce: Skew-normal distribution was added.
- Volume Show and Extract: Cleanup; functions superseded by Cut'n'Slice were
  removed, visualisation and stability improved.
- MFM modules: Cleanup; a few wrong numerical factors were corrected.
- Volume Z calibration: Calibration can be also taken from another volume data.
- Volume Swap Axes: Preview image units correspond to the transformed data.
- NMM file: Sometimes incorrect import when a only subset of channels is
  selected was fixed.
- NRRD file: Import from text-encoded files was corrected.  Endian is no longer
  required for text data.
- PNI file: Support for v2.0 files was added, at least for a subset of data
  types.
- Volume slice: Mislabelled axes on output graphs were corrected.
- Transfer function (PSF) guess and fit: The set of output images can be
  controlled
- Transfer function fit: Frequency-space exponential model was added.
- Transfer function guess: The sigma estimation algorithm was improved.
- Nanoscope: Force volume file reading was standardised to follow format
  specification.
- WSxM: File headers with ‘UAM’ copyright are recognised.
- Nanonis DAT spectra: All files matching the same fooNNN.dat pattern are
  merged, not just with names starting from 1.  When files do not seem
  numbered at all, the single selected file is loaded instead of failing.
- Basic operations: Function for flipping around the diagonal was added.
- Pattern synthesis: Holes are placed with respect to image centre instead
  of some defined but unhelpful origin of coordinates.  This means generated
  images also changed and match previous versions only statistically.
- Graph logscale: Logarithm base mishandling was fixed.  Base-2 logarithm and
  negative abscissa handling options were added.
- Statistical quantities: Volume was added as a new quantity.
- FFT profile: Renamed to 2D PSDF.  It can now both extract profiles and create
  the entire 2D PSDF image.
- Image export: Font selection having sometimes no effect on the exported
  image was, hopefully, fixed.  It no longer crashes when there is no image
  to export.
- Filters tool: The median filter now uses circular kernel.
- 2D ACF: Creation of the output image is optional.  The image can be limited
  to the zoomed part.
- Volume summarize profiles: The value for the currently selected profile is
  displayed in the dialogue.
- Dimensions and Units: Crash when reinvoked after selecting Match pixel size
  was fixed.
- Pygwy: Function gwy_app_data_browser_get_containers() no longer leaks
  references to all the returned Containers.  GraphModel supports the sequence
  protocol.

Other:
- Compilation: pygobject2 codegen is no longer required to build pygwy; an
  embedded implementation is used when it is not available.
- Compilation: autogen.sh no longer gets stuck without gettextize; it prints
  an error message.


2.50 (2018-02-02)
Application:
- Translations updated: Czech, French, Russian.
- Toolbox editor: Action names are shown translated.

Libraries:
- libgwyddion: GwyResults, a new helper for formatting sets of scalar values.
- libgwyddion: New GwySIUnit format styles (Unicode, VF TeX).
- libgwyddion: GwySIUnit tries harder to find value formats with prefixed units
  like µm² instead of 10⁻⁹ m².
- libgwyddion: GwyContainer methods for getting lists of keys under given
  prefix.
- libgwyddion: Sorting function for doubles that also returns the permutation
  and sorting function for integers were added.
- libgwyddion: Functions for finding k-th ranked values and percentiles of an
  array were added.
- libgwyddion: A trimmed mean function was added.
- libgwyddion: A function for angle (direction) canonicalization was added.
- libgwyprocess: New FFT-based correlation search function with local
  levelling, score calculation and masking support.
- libgwyprocess: Broken ‘Ring’ shape parameter estimation was fixed.
- libgwyprocess: Functions for calculating various standard peak-based
  quantities from GwyDataLines were added.
- libgwyprocess: 2D autocorrelation function supporting masking was added.
- libgwyprocess: Harris corner filter works correctly for non-square images.
- libgwyprocess: Function for DataField size reduction using binning.
- libgwyprocess: gwy_data_field_new_rotated() actually works correctly for
  data fields with non-square pixels.
- libgwyprocess: New exterior type, Laplace, was added for field extension.
- libgwyprocess: New grain quantities: Minimum and maximum Martin's diameter
  and the corresponding directions.
- libgwyprocess: Triangulation was improved.  It should be much less prone to
  crashing and also able to triangulate more point sets.
- libgwydgets: Mixed up clockwise and anticlockwise rotation icons were fixed.
- libgwyapp: GwyResultsExport GUI helper for result set saving/copying.
- libgwyapp: Window positions are only restored when the monitor configuration
  remains the same.

Modules:
- Binning (new): Reduces image size using binning.
- Rod deposition synthesis (new): Generates (modifies) surfaces by elongated
  particle deposition using a simple dynamic model.
- Pile up synthesis (new): Generates (modify) surfaces by piling up geometrical
  shapes.
- Convolve (new): Convolves two images.
- SPC file (new): Imports Thermo Fisher SPC files.
- Nanonis DAT spectra (new): Imports bias spectroscopy data.
- Dimensions and Units (image): Spurious value changes should not longer occur.
  Current dimensions are also displayed.
- Dimensions and Units (image and volume): Broken Z factor adjustment was
  fixed.  Current dimensions are also displayed.
- Grain statistics: Renamed to Summary in the menu; a new function displaying
  means and variations of grain quantities was added as Statistics.
- Pygwy: A number of optional mask (and other arguments) are really optional
  in Python, allowing None to be passed.
- Nanoscope: Force files in 32bit raw data format used since 9.2 should
  actually be loaded correctly now.
- Mask by Correlation: Renamed to Correlation Search, added support for
  masking, method list was updated.
- FFT profile: Line thickness (averaging) and windowing type can be controlled.
- ACF 2D: Has a GUI now, supports masking, can pre-level the data, extract
  radial ACF profiles and calculate some statistical parameters.
- Filters tool: Mean value filter uses circular kernel instead of square.
- Statistical quantities, Statistical functions and Row/Column statistics
  tools: Apply button is insensitive when there is no curve, some repeated
  recalculations were fixed.
- Statistical quantities: Quantities Sp, Sv and Sz were added.
- Object synthesis: Hexagonal pyramid, full sphere and nuggets shapes were
  added.  Feature up/down direction is now an arbitrary fraction.  There are
  new is now options to avoid stacking and for vertical placement character.
- Roughness tool: Sm and Ry were added.  Rz taking into account peaks twice
  (instead of peaks plus valleys) was fixed.
- Curvature: Result export now includes file name and channel information.
- Fractal dimension: Result table can be saved/copied to clipboard.
- ASCII export: Optionally, all channels can be exported to one text file,
  concatenated.
- Tip operations: Tip selector intersecting with the label was fixed.
- NMM file: Profiles are rotated to lie along the X-axis.
- Sensofar: Updated for newer versions of the PLu file format (up to 2013).
- Align rows: Trimmed mean and trimmed mean difference levelling methods were
  added.  Images are no longer rotated by 180 degrees in vertical mode.
- XYZ Rasterize: Possible crash when the region was longer along X than along Y
  was fixed.
- Limit Range: It is possible to give percentages of data values to remove
  instead of height values.
- JPK: Critical warning when computed data are present in force files was
  fixed.  Pause segments are ignored more thoroughly so they should no longer
  cause file load failure due to non-uniform channel lists.

Other:
- Compilation: Module bundling and configure file format summary were fixed to
  work with BSD sed.
- Compilation: PYTHON_INCLUDES and PYTHON_LDFLAGS can be overriden on all
  systems, not just MS Windows.


2.49 (2017-08-15)
Application:
- Translations updated: Czech, French, Russian.
- Toolbox: Built-in functions such as 3D view can have keyboard shortcuts and
  a few more can be added as toolbox buttons.
- Modules: The program warns on startup if a larger number of modules fail to
  register.

Libraries:
- libgwyddion: New functions for 1D maximum refinement and histogram
  calculation were added.
- libgwyddion: gwy_isinf() and gwy_isnan() work regardless of GCC's fast maths.
  So Gwyddion can be compiled with -Ofast and removal of invalid values from
  imported files still works.
- libgwyprocess: New fitting preset: Boltzmann bent step.
- libgwyprocess: gwy_fft_simple() is now just a thin FFTW wrapper; all FFT
  related code was cleaned up and generally uses FFTW directly.
- libgwyprocess: Functions for calculation of row-wise ACF, HHCF and PSDF from
  masked data were added.
- libgwyprocess: Functions for calculation of distribution of angles and
  cumulative distribution angles from masked data were added.
- libgwyprocess: More efficient functions for data field flipping about the
  diagonal were added.
- libgwyprocess: gwy_data_line_correct_laplace() bug adding value offsets to
  interpolated segments was fixed.
- libgwyprocess: Efficient functions for row-wise and 2D convolution were
  added, with image exterior control.
- libgwyprocess: Function for profile extraction with masking was added.
- libgwyprocess: Function area scale graph was added.
- libgwyprocess: Function for preparation of data field affine transform given
  base vectors was added.
- libgwyprocess: Functions for copying units to another data object of the same
  type were added.
- libgwyprocess: Function for location of local maximum within an elliptic area
  with subpixel refinement was added.
- libgwyprocess: Functions for automated estimation and/or refinement of
  periodic lattice parameters from ACF and PSDF were added.
- libgwydraw: New functions for conversion between GwyRGBA and pixbuf pixels.
- libgwydgets: Stock icons were revised, replaced and redrawn in SVG, resulting
  in a cleaner icon set.
- libgwydgets: New widget GwyAdjustBar, replacing GtkHScale, was added.
- libgwydgets: Convenience constructors for adjustment bars were added, mostly
  allowing drop-in replacement of hscales.
- libgwydgets: The font size of 3D view labels can be set for all labels at
  once.  The size and vertical alignment of false colour scale are adjustable.
- libgwydgets: Table hscale SQRT style works with negative values.
- libgwydgets: Gwy3DView responds to mouse scroll events by zooming or scaling
  the value (when Shift is pressed).
- libgwyapp: Empty borders in 3D view export can be automatically removed.
- libgwyapp: Cancellation of progress dialogues can be explicitly queried.
- libgwyapp: Data processing menu items have icons (if enabled in GTK+).

Modules:
- Graph statistics (new): Calculates simple statistics for graph curves.
- Volume operations (new): Simple volume data operations, currently extraction
  of the preview to an image.
- Volume swap axes (new): Reorganises data to change X, Y, Z axis roles.
- Fibre synthesis (new): Generates images from randomly placed fibres.
- Mask noisify (new): Adds salt and/or pepper noise to the mask.
- Statistical functions: Masked one-dimensional ACF, HHCF, PSDF, DA and CDA are
  available now.  Area scale graph was added.
- JPK: Crash when QI/force map loading was cancelled during ‘Scanning files’
  was fixed.
- Dimensions and Units: A rarely occurring freeze was fixed.
- Mask editor tool: A CRITICAL error when attempting to use bucket-erase on
  data with no mask was fixed.
- PSF estimate, fit: PSF normalisation was corrected to represent sampling
  of the continuous PSF, with image formed by usual continuous convolution.
- Outliers: Undo works properly also when it just removes an existing mask.
- Mark disconnected: Settings are remembered also upon cancellation.
- Mark scars: The mask can be combined with mask already present on the image
  using union or intersection.
- Igor file: Export was implemented.
- Roughness tool: Displays the cut-off wavelength in real-space units.
- Sphere revolution: True 2D sphere revolution was finally implemented.
- NanoScan: Import of unfinished images was implemented.  Invalid values (NaN)
  in the files are handled correctly.
- Align graph: Random behaviour (and usually no alignment at all) for curves
  with moderate number of points was fixed.
- Wave synthesis: Decay parameter was added.  It has a progress bar and is
  cancellable now.
- Curvature: Reported position of centre correctly includes origin offset now.
- Profile tool: Profile directions can be automatically improved to be
  orthogonal to features.
- OPD: ASC files in both wavelength and real units are imported correctly.
- K-means, K-medians: Create curves with normalised abscissa order now.
- Measure lattice, Affine correction: Horizontal ACF can be replaced with
  interpolation if individual scan lines contain too much noise.
- Affine correction: The correction can be applied to all compatible images
  in the file.  Automated estimation was added.
- Volume summarize profiles: Minimum and maximum position were fixed for data
  with z-calibration and their units corrected.

Other:
- Dependencies: FFTW ≥ 3.1 is now required on all platforms.
- Compilation: New configure options --enable/disable-module-bundling controls
  the linking of modules of one type to one shared object for smaller packages
  and faster startup.  Bundling is enabled by default.
- Compilation: A summary of missing maintainer mode tools is printed when
  maintainer mode is enabled.
- Python: Configure tries harder to find a Python 2 (not 3) interpreter.
- Python: On Unix, the gwy module is no longer linked with libpython.
- Resources: Three new false colour gradients were added, Gray-inverted,
  Viridis and Spectral-white.


2.48 (2017-04-29)
Application:
- New translation: Brazilian Portugese.
- Translations updated: Czech, French, Russian.
- Toolbox: Default width was increased to 5 columns (to work around broken MS
  Windows 10 window management).
- Command line: New options --disable-modules prevents loading of specified
  modules.

Libraries:
- libgwyddion: K-correlated PSDF fitting function was added.
- libgwyprocess: Positions of minimum and maximum are now available as data
  field row/column statistics quantities.
- libgwyprocess: GwyShapeFitPreset has a quick-fit function for rough fitting
  with reduced number of data points.
- libgwyprocess: Function for reduction of the number of points in GwySurface
  was added.
- libgwyprocess: Mask thinning function was added.
- libgwydgets: A large number of new stock icons were added.
- libgwydgets: gwy_data_view_coords_xy_cut_line() cuts also vertical and
  horizontal lines to nothing when they do not intersect the area at all.
- libgwymodule: Specific modules can be prevented from registration by
  gwy_module_register_modules().
- libgwyapp: Ascending abscissae point order is enforced in graph curves upon
  file import, with a warning emitted.
- libgwyapp: Progress dialogues shown by the wait functions can be disabled.
- libgwyapp: Misbehaving data window size restoration was corrected.
- libgwyapp: File name filter in the file chooser is now correctly applied only
  to the actual file name instead of the whole path.
- libgwyapp: Helper functions for bad data masking and interpolation now use
  fast Laplace interpolation instead of simple average.
- libgwyapp: GwyAppFileChooser avoids attempting full preview of huge files.

Modules:
- Zeiss LSM (new): Imports Carl Zeiss CLSM data.
- Dektak VCA (new): Import Dektak OPDx (VCA DATA) files.
- MFM perpendicular (new): Calculates stray field above sample with
  perpendicular domains.
- MFM parallel (new): Calculates stray field above sample with parallel
  domains.
- MFM shift (new): Transfers the field from one lift height to another.
- MFM current (new): Calculate stray field above sample with current line.
- MFM estimate shift (new): Estimates lift height difference between two MFM
  images of the same structure.
- PSF estimate (new): Estimates point spread function based on ideal data and
  measured data using deconvolution with regularisation.
- PSF fit (new): Estimates point spread function based on ideal data and
  measured data by fitting an explicit PSF functional form.
- Phases synthesis (new): Simple generator of data resembling two-state
  (two-phase) systems studied for instance in MFM.
- Stitch (new): Merges multiple images based on origin offsets.
- Pygwy: Standard output from modules and the console is captured (so in the
  console print works again as expected).  Python modules have new optional
  registration variables.  Pygwy console remembers recent scripts.  Several
  more function were added to the Python API.
- Renishaw, volume slice: Create graphs with ascending abscissae point order
  now.
- MicroProf: Files with comment at the beginning are imported correctly now.
- Summarize Profiles: Now supports minimum and maximum positions.
- ISO28600: Import of multichannel files was corrected (field separator is
  specified as comma).  Irregular (XYZ) data import was implemented.
- WITec Project: Now supports different x axis units for spectra and spectral
  images.
- NanoObserver: Support for v1.33 files was added (including spectroscopy).
- Spectro tool: CRITICAL error when averaged curves differed in the number of
  points was fixed.  Subsequent spectra are interpolated onto the range of the
  first selected now when averaging.
- Seiko: At least the first image should be imported from XQ?X files now.
- JPK: Initial support for volume force data (QI) was added.  Single point
  spectra import was fixed to ascending abscissae.
- SPMLab: All image layers are now loaded (not just the first one).
- Slice volume: Working with Z-axis calibrations was fixed.  Initial choice of
  possible target graphs was fixed.
- Profile tool: Averaging of thick profiles was fixed (lines close 45 degrees
  were mostly affected).
- AMB: Physical dimensions and scales of the data should be correct now.
- Image export: False colour bar ticks were corrected for inverted mappings.
  Rendering of rulers for images with offsets was fixed.
- Nanoscope: Electrochemistry files are recognised.
- Distance tool: The exported table is tab-separated now.
- Mask editor tool: Spurious extra pixels in occurring free-hand drawing were
  corrected.
- OPD: Import of ASC files written as XYZ was implemented (assuming regular
  grid).  Workaround for import error with ‘ImageModificat~0’ was added.
- Graph function fit, FD curve fit and Shape fit: Fit results can be copied
  to the clipboard.

Other:
- OSX/BSD pygwy build: Build failure due to pygwy-fix-defs.sed containing
  non-standard regexps was fixed (by replacing it with a Python script).
  Several other problems related to compiler and linker flags and library
  naming were corrected.
- Development snapshots: Now display a prominent label ‘Development snapshot’
  in the splash screen so you know you are running a snapshot.


2.47 (2016-11-18)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion, libgwydraw, libgwyapp: Simple structs such as GwyXY and GwyRGBA
  now have on-heap constructors (mostly helping language bindings).
- libgwyprocess: New single-step tip modelling functions, either for fixed
  model size or optimised for a certain height range, with more general
  model parameter handling.
- libgwyprocess: Elliptical parabolic tip model was added.
- libgwyprocess: Fast Laplace interpolation function
  gwy_data_field_laplace_solve() was added.
- libgwyprocess: GwyShapeFitPreset 3D geometrical shape fitting preset class
  was added, making available the functionality of Fit Shape in the library.
- libgwyprocess: Parabolic bump function was added.
- libgwyprocess: Helper function for grain pixel size calculation was added.
- libgwyddion: GwyNLFitter has an option to reduce ordinate value differences
  using the local function derivative, approximating a geometric fit.
- libgwyddion: GwyNLFitter has accessor functions for all the useful data
  so it is no longer necessary to poke inside the struct.
- libgwydraw: gwy_selection_set_data() broken in 2.46 (and affecting selections
  in several modules) was fixed.
- libgwyapp: Data browser data lists scroll to show the selected item.

Modules:
- Graph logscale (new): Physically transforms graph to logarithmic scale.
- Pygwy: Large number of functions were added and fixed, some of the fixes
  involved API changes: redundant list length parameters disappeared, structs
  such as RGBA are now Python classes, silly function names (a_something...)
  were sanitised.  Syntax highlighting in the console should work again in
  MS Windows.
- Image export: Inset scale bar label can be placed either below or above the
  bar.
- Statistical functions: Cumulative height distribution supports masking.
- JPK: Compilation failure when minizip is not available was fixed.
- Fit shape: Module was rebased on the GwyShapeFitPreset library functions.
- Object synthesis: Parabolic bump shape was added.
- Lattice synthesis: Several new lattice types were added: Penrose, Cairo,
  snub square, Si 7x7 reconstruction.
- Nano Measuring Machine: Can handle data larger than 4 GB points total on
  64bit systems (but not more than 2 GB per channel).

Other:
- Dependencies: Configure now warns if FFTW is unavailable or disabled.  The
  library will become a required dependency in a future version.


2.46 (2016-10-14)
Application:
- Translations updated: Czech, French, Italian, Russian.
- Toolbox: Is now editable in the program using Edit → Toolbox.  It is possible
  to specify whether a button runs the function interactively or not.

Libraries:
- libgwyddion: GwySIUnit can parse prefixed spelled out unit names such as
  ‘Millimetre’ or ‘nanoampere’.
- libgwyddion: Gaussian fitting function estimator was improved.
- libgwyddion: GwyRandGenSet function for random shuffled subsets was added.
- libgwyddion: GwyNLFitter can report progress and scales much better.  It
  has new interface for fitting of fully opaque indexed data.
- libgwyddion: Function for inversion of symmetric positive definite matrix
  was added.
- libgwyddion: Macros gwy_assign, GWY_FREE, GWY_SI_VALUE_FORMAT_FREE were
  added, as well as capitalised versions of gwy_object_unref and
  gwy_signal_handler_disconnect.
- libgwyddion: Functions for direct construction and cloning of
  GwySIValueFormats were added.
- libgwyprocess: GwyPeaks, graph curve peak finder with functionality similar
  to the Graph Peaks module, was added.
- libgwyprocess: Functions for field rotation by multiples of 90 and rotation
  in real space with several sizing options were added.
- libgwyprocess: An obscure case of GwyTriangulation failure now fails
  gracefully instead of on a failed assertion.
- libgwyprocess: gwy_data_line_get_psdf() should finally actually work.
- libgwyprocess: GwyDataField line-stats function with proper masking support
  was added.
- libgwyprocess: Convenience functions for copying units between GwySurface
  and GwyDataField were added.
- libgwyprocess: Construction of GwySurface from a GwyDataField with masking
  support was added.
- libgwyprocess: gwy_data_field_mark_scars() was added as a public function.
- libdraw: Memory handling bugs in GwyGradient updates were fixed.
- libgwydgets: Graph ASCII export can create multi-column files with a single
  merged abscissa.  Exported values are always in base units (not power of 10
  multiplies).
- libgwydgets: A large number of new stock icons were added.
- libgwyapp: Critical _gwy_app_log_start_message_capture() error when opening
  files from stand-alone Python scripts was fixed.
- libgwyapp: gwy_app_wait_set_fraction() automatically limits how often the
  Gtk+ main loop is let to run.
- libgwyapp: Data visibility restoration for files containing volume and XYZ
  data was fixed.
- libgwyapp: XYZ data preview is automatically updated when the data change.
- libgwyapp: Helper for previewing GwySurface into a GwyDataField was added.

Modules:
- Dektak XML (new): Imports Dektak XML profilometry data.
- Dimension (new): Imports old Dimension 3100D files (experimental).
- XYZ Level (new): Simple XYZ data levelling: fix zero, zero mean value
  (unweighted), plane levelling by subtraction and true rotation.
- Fit shape (new): Fits various geometrical shapes on entire data.  Available
  both as image and XYZ data processing function.
- Logistic regression (new): Image segmentation based on logistic regression.
- Fit sphere: Was removed, use new Fit shape module instead.
- Row/column statistics tool: Masking support was added.  The misguided fixed
  resolution option was removed.
- Statistical quantities: Automatic selection of units and precision for the
  displayed quantities was improved.
- XYZize: XYZ log is created for the new XYZ data, not volume data log.
- Pygwy: Containers can be directly indexed both by strings and integers
  (quarks).  Overrides for Container methods get_value() and set_value() were
  added.
- Limit Range: Units with exponents are displayed correctly now.
- SPIP ASC: Can also export data to .asc now.
- Image export: Can export to WebP (lossless) now if libwebp is available.
  Units of false colour map scale are somewhat controllable.  The colour of
  lines and text drawn outside the image area is controllable; likewise the
  background colour – and for vector formats and PNG and WebP the background
  can be transparent (for vector formats that used to be the only possibility).
- Diffusion synthesis: Incorrect behaviour for non-square images was fixed.
- Selection manager tool: Can copy selection coordinates to the clipboard or
  export them to a file.
- Find graph peaks: A peak filtering bug resulting in sometimes the module
  not finding any useful peaks was fixed.
- Rotate: Cartesian grid can be optionally displayed over the data.  There
  are more result sizing options.  Rotation is performed in real space, not
  pixel space.
- Grain statistics: The values are displayed with more significant digits.
- Raw XYZ import: No longer loses the first data point in the file.
- Graph cut: The ‘cut all’ setting is remembered, some GUI improvements.
- Cross-correlation: Introduced weighting function, result smoothing and
  extension and back-correction according to the results.
- Nanonis: Mask of invalid values is correctly flipped with the data now.
- JPK: Support for single point spectroscopy was added.
- TIFF-based file modules: Tiled TIFF images are supported now.
- K-means: Outliers threshold for calculation of cluster centres is added.
- Leica: Some kinds of high dimension data (tiles from tilescan) can also be
  imported as volume data.

Other:
- Development: API documentation not being installed with gtk-doc 1.25+ was
  fixed.
- Python: Stand-alone Python module gwy should no longer complain about
  libraries modules are linked with not being found.


2.45 (2016-04-26)
Application:
- New translation: British English (accompanied with unification of the default
  language to US English).
- Translations updated: Czech, French, Russian.
- Program messages: Are written to the log file by default on all platforms,
  on Unix in addition to the console.
- Command line: New options --log-to-console and --no-log-to-console permit
  controlling independently where the messages go (and where they do not).
- Program messages: Can be displayed in the GUI using Info → Program Messages.
- Files: The current file can be closed using Ctrl-W (or File → Close in the
  menu).
- Tips of the day: Were updated and can be displayed on startup if enabled.

Libraries:
- libgwyddion: GwyNLFitter fit returns -1 and NULLs the covariance matrix when
  it gets infinities or NaNs anywhere in the matrix or parameters.
- libgwyddion: New macro gwy_info() emits an INFO-level log message.
- libgwyddion, libgwyprocess: New standard boxed structs GwyXY and GwyXYZ were
  added to gwymath.  GwyTriangulationPointXY and GwyTriangulationPointXYZ are
  now their aliases.
- libgwyprocess: New DataField distortion function that takes explicit list of
  coordinates in the original data field.
- libgwyprocess: GwySurface is a new data object representing XYZ data,
  currently providing just a few basic methods.
- libgwyprocess: GwySpline is a new helper data structure for sampling along
  curves.
- libgwyprocess: Wrong estimated sizes for tip models were corrected.
- libgwyprocess: Two new tip models were added: Parabola and Cone.
- libgwyprocess: Function for filling missing values in GwyDataLine using
  Laplace data correction was added.
- libgwyprocess: GwyDataField line statistics calculates rms using local line
  means, not the global mean.
- libgwyprocess: Raw 2D FFT transform using the SimpleFFT backend (i.e. with
  FFTW unavailable) overwriting the input data field was fixed.
- libgwyprocess: New function gwy_data_field_area_renormalize() transforms
  values in just a part of data field.
- libgwyprocess: Crash in gwy_data_field_area_get_entropy_at_scales() for data
  fields filled with a constant value was fixed.
- libgwyprocess: gwy_data_field_clear() no longer sets cached area to zero.
- libgwyprocess: Resampling of constant valued data fields always produces
  constant valued data fields.  This fixes odd rounding error patterns in
  thumbnails for constant valued fields.
- libgwyprocess: Tip dilation and erosion functions were optimised.
- libgwydgets: A large number of new stock icons were added.
- libgwydgets: The gradient can be unset using data window colour axis menu.
  The colour gradient and GL material can be unset in the 3D window as well.
- libgwydgets: Positions of graph labels are remembered and restored.
- libgwydgets: GwyGraphCurveModel has a method for ensuring data points are
  ordered by abscissa.
- libgwydgets: Convenience combo box constructor for graph curves was added.
- libgwydgets: Editability of graph area selections can be controlled.
- libgwydgets: Function for setting graph curve data from a single interleaved
  array was added.
- libgwydgets: Graph and 3D windows can be resized using keyboard, similarly
  to other data windows.
- libgwydgets: GwyDataView with physical aspect ratio resizes itself now when
  the physical dimensions change but pixel dimensions do not.
- libgwymodule: XYZ data processing module management functions were added.
- libgwyapp: All program messages are gathered by the default logger and
  displayed in a text view.
- libgwyapp: Data browser can show warnings and other messages occurring during
  the opening or merging of specific files.
- libgwyapp: Data browser displays thumbnails for graphs.  A new function for
  graph thumbnail creation was added.
- libgwyapp: Thumbnails are generated from any kind of data found in the image,
  preferring volume, XYZ, channels and then graphs.
- libgwyapp: File open dialogue previews almost all visual data types:
  channels, graphs, volume and xyz.
- libgwyapp: XYZ data support was added to validation, logging, metadata
  browsing, data choosers, enumeration and other places.
- libgwyapp: gwy_app_sync_data_items() only replicates non-empty selections
  now.
- libgwyapp: Functions for enumerating ids of data in a container now work
  also for containers not managed by the data browser.
- libgwyapp: GwyAppFileChooser open dialogue can filter files by name.
- libgwyapp: It is possible to query the current data browser page using
  gwy_app_data_browser_get_current().
- libgwyapp: Data can be duplicated with Ctrl-D, deleted with Ctrl-Delete and
  extracted to a new file with Ctrl-Insert.
- libgwyapp: Zooms and sizes of all kinds data windows are saved and restored
  when the data are displayed again (if they seem sane for the current screen).

Modules:
- Straighten path (new): Extracts image sampled along a spline curve and the
  direction perpendicular to the curve.
- Path layer (new): A single spline curve with arbitrary number of points.
- Extract path selection (new): Extracts positions and tangents of sampled 
  path selections as graph curves.
- Find graph peaks (new): Simple location of peaks on graph curves.
- Rasterize XYZ (new): Renders XYZ data to an image.
- XYZ Correct Drift (new): Corrects drift in timestamped XYZ data.
- Coerce (new): Transforms surfaces to have prescribed statistical properties.
- XYZize (new): Creates XYZ data (with regular point grid) from an image.
- Data processing modules with preview: Data with non-square aspect ratio
  should look like in 2.43 again.
- IntelliWave (new): Imports IntelliWave ESD data files (experimental).
- Nano Measuring Machine: Parameters from the main DSC file are imported as
  metadata.
- Align rows: Median difference method no longer changes the overall data tilt.
- Spectro tool: Always disabled ‘Apply’ button (broken in 2.44) works again.
- Points, Lines layers: Numbering works with more than 999 objects.
- 1D FFT filter: GUI was reorganised and the previews enlarged.
- Image export: Support for path selection drawing was added.
- Level: Zero mean value supports masking.  Individual module functions have
  separate settings now.
- Columnar synthesis: New option to continuously ‘melt’ the film during the
  growth.
- RHK SPM32 and SM4: Imported graph curves are sorted by abscissa, fixing
  some graph functionality being broken.
- WSxM: Files starting ‘WSxM file copyright WSxM solutions’ are also
  recognised now.  Single-precision files are loaded correctly.
- Nanoscantech: Support for files using UTF-8 encoding was added.
- GWYXYZF: Byte order handling was corrected to follow the specification.
- GWYXYZF, Raw XZY: The data are loaded a native XYZ data instead of being
  regularised to image upon import.
- Statistical functions: Local range was added as a new quantity.
- Object synthesis: Coverage parameter was fixed to actually mean what the
  documentation describes.  Multiply old values by 4 to get the same coverage.
- Mark disconnected: The operation is undoable now.
- XYZ export: Can export both channels and XYZ data.
- APE DAX: Complete metadata are imported, miscellaneous other improvements.
- Seiko: Image resolutions should be correct for all files, with no guessing
  involved.
- OME TIFF: Data split to several files can be loaded at least file by file
  now, instead of getting a cryptic error message.
- Volumize layers: Memory handling error causing a crash after closing the
  volumized data was fixed.  Units are set properly and can be controlled
  in the module dialogue.
- Volumize: The created volume data are now 1 under the surface (inside the
  material) and 0 above the surface (outside the material).


2.44 (2016-01-11)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: gwy_debug() adds time stamps to the messages (where available).
- libgwyprocess: Rare incorrect memory reallocation in Delaunay triangulation
  was fixed.
- libgwyprocess: Euclidean distance transform with from_border=FALSE actually
  work for all cases, previously the border-influenced areas had to be limited.
- libgwyprocess: New function for simple regularisation of XYZ data to a data
  field was added.
- libgwyprocess: Bogus value returned by gwy_data_field_area_get_entropy() with
  mask exclusion mode was fixed.
- libgwyprocess: Functions for estimation of the entropy of two-dimensional
  point cloud, and for entropy-from-histogram-at-scale curves were added.
- libgwyprocess: An iterative cancellable version of function
  gwy_triangulation_triangulate() was added.
- libgwyprocess: Functions for filling area under mask with a value and
  simple data-average correction using unmasked data were added.
- libgwydgets: Gwy3DView no longer downsamples data during changes, all
  operations are done with full-resolution surfaces.  Its "reduced-size"
  property was deprecated and it has no effect.
- libgwydgets: Gwy3DView light source distance from the surface no longer
  scales with Value scale, improving views with small Value scale a lot.
- libgwydgets: Graph labels respond to "label-property" changes.  The property
  is also meaningfully updated when user moves the label around.
- libgwydgets: GwyGraphModel and GwyGraphCurveModel clone() methods were
  implemented.
- libgwyapp: gwy_app_channel_remove_bad_data() now ensures the mask field has
  the same lateral dimensions and units as the data field.
- libgwyapp: Potential corruption of recent file list by Save As introduced in
  2.43 was fixed.
- libgwyapp: Data windows hidden and re-shown from the data browser no longer
  lose the window icon showing a data thumbnail.

Modules:
- Entropy (new): Visualises entropy calculation for distributions of values
  and slopes.
- Leica (new): Imports Leica LIF CLSM images.
- Nano Measuring Machine (new): Imports NMM profile sets and regularises them
  to raster data.
- DM3: Support for Digital Micrograph DM4 files was added.
- Image export: The number of digits in false colour axis ticks can be
  controlled explicitly.  Very small negative values are displayed as ‘0.0’,
  never the odd ‘-0.0’.
- Magellan: RGB images are accepted and the channels are averaged upon import.
- APE file: Crash when loading files with fewer actual data than reported by
  the channels bit mask was fixed.
- Limit Range: Setting range from fixed colour mapping range was fixed.
- NanoScanTech: Loading from raw binary data blocks was implemented.
- Keyence: File loading no longer fails when assembly information seems
  missing or too short as the module does not actually need it.
- All tools: Sensitivity of Apply buttons and auxiliary controls was corrected
  so that can be activated only when there is actually an active image.
- Processing modules with selections in the dialogue: Critical messages when
  the dialogues were displayed were fixed.
- Spectral synthesis: Possible critical message when re-running the function
  after deleting a channel was fixed.
- Rawfile: Replacement value for missing data can be given as text for text
  formats, e.g. ‘BAD’ or ‘NODATA’.
- Raw XYZ: A bug in point merging was fixed that sometimes caused infinities to
  appear in the data.  Triangulation is remembered and not recomputed when
  not necessary.  A progress bar is shown for the triangulation process and it
  is possible to cancel it.  New interpolation type ‘Average’ was added, which
  is always fast and produces a result similar to a bit fuzzier ‘Round’
  interpolation.  Button ‘Reset Ranges’ permits resetting the data ranges to
  the initial values obtained from the file data ranges.  Point density can be
  plotted as another field.
- GWYXYZF: The regularisation method was improved to ‘Average’ from Raw XYZ.
- Nanoscope: Support for 32bit raw data format used since 9.2 was added.
- JEOL: Support for Phase channels was added.
- Statistical quantities: Deficit of entropy to Gaussian distribution with the
  same dispersion was added as a new quantity.  Unavailable quantities are no
  longer printed to reports.
- MI file: Loading of graphs in ASCII format was implemented.
- RHK SM4: Loading of graph data with small Y size works now.
- Raw graph: Curve data are sorted upon import.
- Grain filter: Options for unused quantities (B or C) are now hidden instead
  of made insensitive to reduce visual clutter.
- Graph function fit, FD curve fit, critical dimension: Function names are
  translated also in reports.
- Ballistic deposition synthesis: Progressive preview works now.
- Align graph: Crash with curves not sorted by abscissa was fixed.
- Renishaw: Timestamps in metadata were corrected.

Other:
- MS Windows packages: Include OpenEXR support now.
- Linux compilation: Broken configure detection of libpython on Fedora 23 (and
  possibly elsewhere) was fixed.
- MS Windows compilation: A script generating MS Visual Studio solution files
  (and other files) was added as utils/gen-gwyddion-vs-sln.py.


2.43 (2015-11-25)
Application:
- Translations updated: Czech, French, Italian, Russian.

Libraries:
- libgwyddion: GwyContainer items are serialised in lexical order (this is
  not a functional change; the order is still not guaranteed by the format).
- libgwyddion: New functions gwy_fopen() and gwy_fprintf() were added,
  wrapping the C library functions.  As they reside within Gwyddion they are
  always compiled with the same C library on MS Windows (unlike g_fopen()),
  making FILE pointer passing possible.
- libgwyprocess: Functions for erosion, dilation, opening and closing
  morphological operations with arbitrarily shaped flat structuring elements
  were added.
- libgwyprocess: A function for alternating sequential filters with flat
  discs was added.
- libgwyprocess: gwy_data_field_grain_simple_dist_trans() can perform all
  types of distance transforms now, including true Euclidean.
- libgwyprocess: Functions for mask growing and shrinking using any available
  distance measure were added.
- libgwyprocess: A function for mask inversion was added.
- libgwyprocess: A function for trimming empty border rows and columns from
  a mask data field was added.
- libgwydraw: GwySelection has a method for moving it in the plane (may not be
  meaningful or supported for all subclasses).
- libgwydgets: GwySelectionGraphArea and GwySelectionGraphPoint support crop
  and move methods now.
- libgwydgets: Graph selections that are either along x or y have now an
  "orientation" property, similar to GwySelectionAxis.
- libgwydgets: GwyColorAxis updates properly after exact range inversion.
- libgwyapp: Drag'n'drop of selections from Selection Manager tool to
  channels works for images with offset top-left corner.
- libgwyapp: Functions for obtaining quark keys of various common items
  (range, palette, title, meta, ...) in the file were added.

Modules:
- Sensofarx (new): Imports Sensofar PLUx data files.
- Princeton SPE (new): Imports Princeton Instruments camera SPE files.
- Mask morph (new): Elementary morphological operations with masks, possibly
  using another mask as the structuring elements.
- Mask of Disconnected (new): Mark local outliers that have values
  disconnected to the distribution of other values.
- Rawfile: NaN in floating point data are handled by masking and replacement.
  It is possible to specify a raw value representing missing data.  Support
  for two-byte half and six-byte Pascal floating point formats was added.
  Reading of 64bit integer formats was fixed.
- Filters tool: Minimum and maximum filters now use circular neighbourhoods.
  Opening and closing filters and alternating sequential filters with flat
  discs were added.  The filters can be applied only to masked/unmasked parts
  of the image.
- Rank: Local normalisation and value range filter options were added.
- Nanoscantech: Unit and scale reading was updated.
- Mask editor tool: The distance type used for Grow and Shrink is
  controllable now, with true Euclidean distance being the default.  Using
  bucket fill on an image with no mask creates a mask and fills it entirely.
- Profile tool: Possible crash when starting to take a profile with masking
  was fixed.
- Axis, Ellipse, Line, Point and Rectangle layers: Support for the move
  operation was added.
- Selection manager tool: Selections are distributed correctly from and to
  images with offset top-left corner.
- Pygwy: Python 2.4 is now required.  New wrappers for grain numbering and
  grain quantity calculation were added.
- Slice volume, Align rows: It is possible to select a target graph for
  extracted curves.
- Align rows: All the methods consistently keep the mean correction to zero,
  preserving absolute data values.  A Critical warning message in column
  alignment of non-square images when mask was present but ignored was fixed.
- Mark by threshold, Mark by edge detection, Facet analysis: The mask can be
  combined with mask already present on the image using union or intersection.
- Mark by threshold: Reset button now really resets all the settings.
- Colour range tool: Can reverse the mapping for fixed ranges.  Mapping range
  is no longer reset to full upon data change.
- Object synthesis: Features created on the surface can be positive, negative
  or randomly either now.
- NT-MDT: Hybrid mode data are split to upward and downward movement.
- CSM: Image dimensions from Benyuan header are ignored now and BMP
  dimensions are always used.
- Nanoscope: Calculation of dimensions of non-square images was improved
  (hopefully).
- Image export: Smaller pixel-per-inch values are possible for vector formats
  and the values are also no longer rounded to integers.
- WSxM: Horizontally flipped exported channels were fixed.
- Omicron flat: Files with non-standard names are loaded now, with no related
  data loaded alongside.  The original result filename is displayed as the
  filename when possible.
- Critical dimensions: No longer crashes or produces NaNs when the profile
  does not conform to Step profile according to the norm.
- GWYXYZF: Incorrect memory freeing, possibly causing leaks or crashes, was
  fixed.
- 2D FFT: Crash for raw inverse transform without any imaginary part selected
  was fixed.

Other:
- Dependencies: Gwyddion can use either minizip or libzip for opening of
  ZIP-compressed file formats.  The former is used if both are found.
- Unix compilation: Configure checks for gtk-doc at least 1.10, required to
  build the documentation (older versions were actually insufficient even
  before).
- Linux compilation: RPM requires rubypick only on RedHat-based distros.


2.42 (2015-10-06)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyprocess: A function for estimation of the entropy data field values
  was added.
- libgwyprocess: A function for angular averaging of a data field area was
  added.
- libgwyprocess: A function for sub-pixel maximum refinement was added.
- libgwyprocess: New functions to calculate data line total variation, skew,
  kurtosis, mean absolute deviation of values and peak statistics.
- libgwyprocess: Normalisation of tan β₀ data line statistics was corrected.
- libgwyprocess: New functions for obtaining GwyDataLine minimum and maximum
  values simultaneously.
- libgwyprocess: Range and total variation can be now calculated by
  gwy_data_field_area_get_line_stats().
- libgwydgets: Gradient visualisation mode uses the same false colour mapping
  as overlay if overlays are set.
- libgwydgets: 3D view false colour map rendered as a black box when no axes
  are drawn was hopefully fixed.
- libgwydgets: Leaking overlay GwyPixmapLayers in Gwy3DView were fixed.
- libgwydgets: Misaligned Y-grids in graphs exported to bitmap were fixed.
- libgwydgets: 3D view axis and tick line width is controllable now.
- libgwydgets: Graph curve properties dialogue has buttons for switching to
  the next and previous curve in the graph.
- libgwyapp: File thumbnails (for document history) are created from volume
  data when the file does not contain any channels.
- libgwyapp: Data browser displays ‘Z’ for volume data with z-calibration.
- libgwyapp: New function to find window for volume data by id was added.

Modules:
- Align rows (new): Row alignment by various methods, including polynomial
  subtraction, with masking support and background extraction.  It replaces
  the various scattered row correction functions.
- Measure lattice (new): Measures vectors of Bravais lattice using either ACF
  or PSDF image.
- Distribute Mask (new): Distributes a channel mask to other channels.
- Summarize Profiles (new): Create an image from statistical characteristics
  of Z profiles of volume data.
- Z calibration (new): Manages z axis calibration of volume data.
- Keyence (new): Imports Keyence VK4 profilometry images.
- Polynom tool: It was removed, use Align rows instead.
- Line correct: Standard methods were removed (being replaced by Align rows),
  the experimental ones remain in this module.
- Omicron flat: It was rewritten.  All related data are now loaded together
  and support for the various non-topography data types was improved.
- Profile tool: Angularly averaged (radial) profiles can be extracted now,
  with possible automated symmetrisation.  Data masking is supported.
- Image export: Missing #include <locale.h> was fixed.  GIF support was
  disabled as it was available only on Win32 and did not work there anyway.
- Gwyfile: If the program aborts to out-of-memory during saving the existing
  file is kept intact now.
- Raw XYZ: Data values can be separated by commas or semicolons in file lines.
- Profile and Distance tools: Line numbers can be switched on and off.
- WSxM: It is possible to export channels to WSxM files (.stp).
- Colour Range tool: Fixed range values are no longer lost upon switching from
  a non-fixed range data window.
- Slice volume: It is possible to extract multiple images or curves at once.
  Not working graph selection was fixed.  Possibly odd preview sizes and
  graph selection ranges upon base plane switch were corrected.
- Cross-correlation: Invalid low-correlation mask object sharing was fixed.
- NRRD: Detached data files are correctly searched in a path relative to the
  header file now.
- Mark With: Preview now behaves correctly when using mask as the source.
- Distance, Profile, Path Level tools: Moved/edited line is selected in the
  list and the list is scrolled to make it visible.
- Line layer: New property "center-tick" controls drawing of a central tick.
- Line noise synthesis: New ‘Ridges’ noise type creates locally offset blocks
  that do not influence the outside values.
- Raw graph import: Curve type can be chosen directly in the dialogue.  A few
  settings remembering problems were fixed.
- Row/column statistics tool: Range and total variation quantities were
  added.  All parameters are calculated for mean value-corrected profiles.
- Roughness tool: Waviness and texture parameters are actually calculated from
  zero-mean profiles.
- K-means, K-medians: They now have progress bars and are cancellable.
- Grain distributions: Field separator in the header was fixed to tab.

Other:
- MS Windows compilation: The code has been made MSVC-compatible.
- OS X compilation: Python linking on OS X is no longer tied to a specific
  library.


2.41 (2015-05-26)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyprocess: Functions for various simple distance transforms were added.
- libgwyprocess: New fitting presets: Smooth slanted step and Smooth bent
  step.
- libgwydgets: A function for checking the compatibility of units of two
  graph models was added.
- libgwydgets: A function for copying curves appending curves from another
  graph model to a graph model was added.
- libgwydgets: Graph key frame size should better correspond to the content.
- libgwyapp: Data containers corresponding to open files have assigned unique
  numerical ids (within one program invocation) that can be requested from
  the data browser.
- libgwyapp: GwyDataChooser has selection setting and obtaining functions
  that work with numerical ids.
- libgwyapp: New functions for ensuring numerical data identifies identify
  a still existing data object.
- libgwyapp: New helper function for adding graph curves to another graph or
  creaing a new graph if units are incompatible.
- libgwyapp: Undo/redo functions now work with graphs so graph modules can
  save undo information.
- libgwyapp: Data choosers are available for graphs.
- libgwyapp: Data browser has functions for watching graphs.
- libgwyapp: Data choosers respond to the current item disappearing by choosing
  ‘none’ (preferably) or at least something.

Modules:
- Align graph (new): Aligns horizontally graph curves.
- Slice volume (new): Simple extraction of planes and lines from volume data.
- Log-Phi PSDF (new): Calculates 2D PSDF transformed to angle-log(frequency)
  coordinates.
- Ballistic deposition synthesis (new): Simple growth simulation using the
  ballistic deposition model.
- Profiles, Statistical functions, Row/column statistics, Roughness and Spectro
  tools: It is possible to select a target graph for the curves.
- Slope distribution, Grain correlations, Curvature, Fractal dimension, FFT
  profile, Drift correction: It is possible to select a target graph for the
  curves.
- Arithmetic: Data fields 2 to 8 are remembered between invocations.
- Calibrate, Merge, Immerse, Attach Presentation, Cross-correlation, FFT, Mark
  With, Mask by Correlation, Neural network training: Second image is
  remembered between invocations.
- Immerse: Detail positions are remembered.
- Merge: New merge mode ‘Join’ suitable for slowly varying data without
  significant features but well defined absolute Z values was added.
- Pygwy: Python modules have sys.path set up the same way as the console now,
  which namely includes the path to gwyutils.py.
- 2D FFT: It is possible to provide the imaginary part and perform inverse
  transforms.
- 1D FFT filter: Occasional ‘Axis with extreme range!’ error was fixed.
- Image export: Alignment of numbers on false colour map scale was improved.
  Drawing of ‘lattice’ selections was implemented.  The decimal separator
  can be controlled.  A rare insufficient precision of ruler ticks was fixed.
- Filters tool: A simple Gaussian sharpening filter was added.
- Affine distortion: The lattice is remembered and recalled.  ACF image uses
  full colour range, correcting problems when fixed colour range is set.
- Selection manager tool: Lattice selections are shown when chosen in the list.
- Tip blind estimate: A memory freeing error was fixed in the stripes mode.
- Fractal dimension: Graph axis labels are somewhat more descriptive.
- Graph level, Graph filter: They are now undoable.
- Graph fit: A button for copying all fitted parameters to estimates was
  added.
- Graph FD fit: The theoretical curve and difference curve are created also
  from estimates, not just after final fit.
- Zeiss: RGB images are accepted and the channels are averaged upon import.
- Color Range tool: Fixed colour range controls are immediately sensitive when
  this range type is the default.
- XY denoise: Too many data field dereferencing, causing a crash later, was
  fixed.
- Euclidean distance transform: Renamed to Distance transform.  It can
  perform also various simple distance transforms.
- Renishaw: Support for loading some metadata was added.
- Nanonis: Files with unknown multi-line header blocks are loaded correctly.
- Nanonics: It should be possible to open incomplete scans.

Other:
- Python: Standalone Python module gwy is now in the gwyddion-devel package
  instead of the main package (it required the devel package to work anyway).


2.40 (2015-02-07)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: Aborting/crashing on deserialisation of invalid-sized arrays
  was fixed.
- libgwyprocess: GwySpectra has properties specifying the abscissa and
  ordinate labels for the spectra curves.
- libgwyprocess: Pass a NULL error array to gwy_nlfit_preset_fit() works now.
- libgwyprocess: New fitting presets: Two-Gaussian PSDF and parabolic step.
- libgwydgets: In 3D View masked data points can be made completely
  transparent.

Modules:
- Flatten base (new): Flattens the base of a surface with positive features.
- K-medians (new): K-medians clustering for volume data.
- SEM image (new): Presentation resembling SEM image corresponding to given
  topography.
- XYZ export (new): Exports channel values to simple XYZ text file.
- Image export: It is possible do disable the frame if there are no rulers.
  False colour rendering for inverted gradients and default non-full mappings
  was corrected.  Title centring for non-square images was corrected.  A mask
  colour sample can be rendered below the image with a label.  Error message
  saying ‘Success’ when exporting BMP files was fixed.
- APE DAX: Can also import APDT files now.
- NetCDF: The new setpoint variable ‘sranger_mk2_hwi_mix0_set_point’ is used
  for metadata, if found.
- NRRD: 3D data with all three resolutions large are loaded a volume data
  instead of sequences of channels.
- Merge: Can mask pixels in the result that were outside of either image.  It
  is also possible to automatically crop the result to only inside pixels.
  A new merge type ‘Interpolation’ produces smoother transitions than the old
  ‘Smooth’ which was renamed to ‘Average’.
- Spectro tool: Uses abscissa and ordinate labels from the spectra object, if
  present.
- Omicron, Nanoeducator: X and Y spectra axis labels are set according to the
  imported spectrum type.
- Euclidean distance transform: Function for mask thinning was added.
- Mark by threshold: Percentage interpretation for inverted height was
  changed to be less confusing.
- Raw XYZ: The square image option is not enforced on regular grid data when
  it is not available in the dialog.
- WITec Project: WIT_PR06 recognized as another variant of magic header.
- APE DAX, NanoObserver, NanoScanTech, OpenGPS, SPMx: Opening of files with
  non-ASCII names should work better on MS Windows.

Other:
- Unix compilation: Do not attempt to build the hdrimage module with C++
  compiler unavailable.


2.39 (2014-11-14)
Application:
- MS Windows: The program should start with a saner working directory by
  default.
- Translations updated: Czech, French, Russian.
- New translation: Korean.

Libraries:
- libgwyddion: A function for copying GwySIValueFormat was added; the
  structure is also registered as a boxed type now.
- libgwydraw: Adaptive false colour mapping was improved by making it more
  adaptive.
- libgwydraw: It is possible to map user-given values to gradient positions
  using the same mapping as gwy_pixbuf_draw_data_field_adaptive() uses.
- libgwydgets: gwy_axis_get_magnification_string() returns string for the new
  units after gwy_axis_set_si_unit().
- libgwydgets: GwyColorAxis has a new ‘unlabelled’ ticks mode in which the
  interior ticks are drawn without labels.
- libgwydgets: GwyColorAxis permits specifying a non-linear value to gradient
  mapping function.
- libgwydgets: Crash when changing colour maps in Gwy3DView with gtk+ version
  greater 2.29 was fixed.
- libgwyapp: When adaptive false colour mapping is used, the axis is set to
  the new ‘unlabelled’ mode so the mapping non-linearity can be seen.

Modules:
- Image export (new): Replaces image rendering in the pixmap module; can
  export to vector graphics formats: PDF, EPS and SVG.  The corresponding
  file types are called ‘pdfcairo’, ‘pngcairo’, etc.
- NX II (new): Imports EMSYS NX II AFM files.
- FemtoScan (new): Imports FemtoScan SPM files.
- SPMx (new): Imports ACT/FemtoScan SPMxFormat files.
- Fractional Brownian motion (new): Generation of fBm-like artificial
  surfaces.
- Renishaw (new): Imports Renishaw WiRE data files.
- Pixmap: Only used for image import; image rendering functions were removed.
- Statistical quantities: Crash in saving the statistics was fixed (introduced
  in 2.38).
- OpenGPS: Format detection was improved to check not just for the presence
  of main.xml also if it really looks like an ISO 5436-2 XML file.
- MIF: X, Y and Z calibration factors are applied to data upon import and
  a different Z conversion formula is used according to z_linearized.
  Multiplicative factors encoded after the image are applied to the data.
- MetroPro: Z scale in files with PhaseRes value of 2 is correct now.
- Grain distributions: The graph abscissas are bin centres now, as is usual,
  instead of bin left edges.
- Noise and line noise synthesis: Settings are remembered also on Cancel.

Other:
- Dependencies: Pango 1.10 and Cairo 1.2 are now required.


2.38 (2014-09-18)
Application:
- Help: Pressing F1 shows help, i.e. it points a web browser to the relevant
  part of the user guide (in most program windows).  Most dialogues also have
  a Help button now.
- Translations updated: Czech, French, German, Russian, Spanish.

Libraries:
- libgwyprocess: New function to find a height threshold by the Otsu method.
- libgwyprocess: New functions to calculate data field total variation.
- libgwyprocess: Macro gwy_data_field_invalidate() is also provided as
  a function so it is available in pygwy now.
- libgwyprocess: New functions to count regional minima and maxima.
- libgwyprocess: New function for numbering grains assuming the mask is
  periodic and grains can touch across the opposite edges.
- libgwyprocess: New function to update units and dimensions of 2D FFT output.
- libgwydgets: Real scale in 3D view can be set arbitrarily, not just 1:1.
- libgwymodule: New functions to obtain the name of the currently running
  file, proc, volume and graph module functions.
- libgwyapp: New simplified logging functions that do not require passing the
  function name.
- libgwyapp: New functions for help handling.
- libgwyapp: New file module utility function for masking NaNs and infs.

Modules:
- OpenGPS (new): Imports OpenGPS surface data format (ISO 5436-2).
- JEOL JSPM (new): Imports JEOL JSPM data files.
- Diffusion synthesis (new): Artificial surface generation by a diffusion
  limited aggregation simulation.
- K-means (new): K-means clustering for volume data.
- FITS (new): Imports Flexible Image Transport System images.
- FemtoScan TXT (new): Imports FemtoScan exported TXT data files.
- Filters tool: Gaussian smoothing is no longer limited to integer FWHM.
- Columnar synthesis: Can plot the evolution of some statistics during the
  growth.
- APE DAX: Warning about invalid logging function name was fixed.
- NT-MDT: Fixed loading of old spectroscopy from Nanoeducator2 data.
  Search of external data in another possible location is implemented.
- Pygwy: It is possible to write volume data processing modules in Python.
  Brick has a duplicate() method, gwy_app_data_browser_get_current() supports
  brick-related items.  Python error messages are no longer silenced after
  Python modules are run.
- Colour Range tool: The range can be set to the range of masked/unmasked
  values.
- HDR image: NaNs and infinities in floating point images are removed and
  masked upon import.
- Slope distribution: A bad typecast causing Gtk+ warning was fixed.


2.37 (2014-06-27)
Application:
- Translations updated: Czech, French, Italian, Russian.

Libraries:
- libgwyddion: New data type GwyRandGenSet providing a convenient set of random
  number generators and functions for sampling from different distributions.
- libgwyddion: Environment variables such as GWYDDION_LIBDIR override the
  system-default paths on all systems, including OS X now.
- libgwyddion: Module and data paths on OS X are taken from the bundle
  "net.gwyddion" instead of the main bundle, fixing broken paths in the
  stand-alone Python gwy module.
- libgwyprocess: DataField z-value format is now based on autorange instead of
  the full data range.
- libgwyprocess: A function for filling grain voids was added.
- libgwyprocess: A simple x and y derivative filter function was added.
- libgwyprocess: A regional extrema marking function was added.
- libgwyprocess: A classic Vincent watershed algorithm function was added.
- libgwyprocess: Pixel count was added as a new grain quantity.
- libgwyprocess: Crash in gwy_grain_values_calculate() when a quantity was
  requested multiple times was fixed.
- libgwyprocess: New function for performing one step of facet levelling.
- libgwydgets: Several new stock icons were added.

Modules:
- WinSTM (new): Import WinSTM data files.
- Mark by Segmentation (new): Another segmentation/grain marking module, based
  on the classic Vincent algorithm.
- Grain filter (new): Filtering of grains by range criteria and logical
  expressions.
- Slope statistics (new): Statistics were split off Slope distributions, the
  GUI and functionality is the same as before.
- Lattice synthesis (new): Construction of surfaces based on Voronoi
  tessellation of randomized lattices.
- Grain removal by threshold: Removed.  Threshold-based removal is replaced
  by Grain filter (also replacing it the default toolbox).  Removal of grains
  touching image edges is a stand-alone menu function now.
- Mask operations: Function for removal of grains touching image edges was
  added.
- Mask editor tool: Fill voids handles correctly different connectivity of
  grain exterior, noticeable for grains separated only by thin lines.  It is
  also possible to fill only simple-connected grains.
- Pixmap: Vertical and horizontal rulers always use the same number format.
  The gap between image and false colour map can be adjusted, as well as the
  gap between the inset scale bar and image border.  Missing lower left corner
  of the false colour map scale border was fixed.  Text antialiasing can be
  disabled.
- Affine distortion: The ACF image can be zoomed.
- NT-MDT: Double inversion of new spectroscopy data properly checked and fixed.
- Slope distribution: Masking is supported.  Plot of total gradient was added.
- NanoScan: A couple of memory-handling bugs was fixed.
- Grain distributions: Displays a preview graph of the selected quantity.
- Grain correlations: If run interactively and the same-units condition of
  selected quantities is not satisfied, default quantities are selected
  instead of aborting with an error box.
- Slope distributions: Preview of the result was added.
- Dimensions and Units: False colour axis actually starts showing the new
  value units also when you change only the units (not the Z range).
- 2D FFT Filter: FFT output centre of lateral coordinates is at the zero
  frequency now.
- 2D FFT and FFT profile: Slight offset of lateral coordinates for odd-sized
  images was corrected.
- Spectral synthesis: Critical message/crash, occurring when some files were
  loaded but no channel was active while invoking the function, was fixed.
- Cross-correlation: Now allowing use of multiple channels and output of
  all the results together.

Other:
- Python: The stand-alone Python gwy module uses the correct extension for
  dlopening, fixing the failure to load Gwyddion libraries on OS X.


2.36 (2014-04-02)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: A GString in-place substring replacement function was added.
- libgwyddion: A function for conversion of text to native EOLs was added.
- libgwyprocess: Function gwy_data_field_extend() for extending data fields
  with various exterior handling types was added.
- libgwyprocess: A function for Euclidean distance transform of a mask was
  added.
- libgwyprocess: Grain quantities characterising the moment-equivalent
  ellipses of grains (axis lengths and orientation) were added.
- libgwydgets: Igor Pro .itx graph ASCII export option was added.
- libgwymodule: Function for obtaining the file name of a container was
  added (mostly useful for pygwy).
- libgwyapp: gwy_app_wait_start() always creates a progress/cancel dialog,
  even if no parent window is passed.

Modules:
- Columnar synthesis (new): Simulation of columnar film growth.
- Wave synthesis (new): Composes images using interference of waves from a
  number of point sources.
- Euclidean distance transform (new): Creates a data field representing the
  distance transform of given mask.
- Domain synthesis (new): Creates patterns based on a hybrid non-equilibrium
  Ising model.
- MetroPro: Files with header formats 2 and 3 are recognised and imported.
  Almost all header fields are imported to metadata.
- Omicron: Value offsets in grid spectra were corrected.
- Read value: Local curvature at cursor is also calculated and displayed.
- Zeiss: ‘Image Pixel Size’ field is used for real dimensions instead of
  ‘Pixel Size’ if it is present.
- Affine distortion: ACF of one image can be used to correct another image.
  Uncorrected lattice vectors can be entered numerically.
- PSIA: Rotated non-square images are imported correctly.
- Modules with a text output: Outputs are saved to text files with native
  line terminators.
- Pygwy console: Can be hidden by pressing Esc.
- Grain statistics: Text output uses simple human-readable notation for
  powers instead of Pango markup.

Other:
- Resources: A false colour gradient mimicking the MetroPro rainbow palette was
  added.
- Dependencies: Compatibility with Gtk+ 2.8, accidentally broken in 2.35, was
  restored.


2.35 (2014-03-02)
Application:
- Logging: A log of data modification operations is recorded for each channel
  and volume data. A viewer of data processing operation log is available in
  the right-click menus.  Logging can be enabled and disabled in the Edit menu.
- Unity: A workaround for toolbox menus disappearing in Unity was implemented.
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: GwyStringList has new functions for clearing and adding a string
  with taking the ownership.
- libgwyprocess: gwy_data_field_grains_get_distribution() no longer incorrectly
  includes the no-grains value in the resulting distribution.
- libgwyprocess: A function for removing grains by number was added.
- libgwydgets: Graph window shows reasonable cursor coordinates with
  logscale axes.
- libgwyapp: Functions for logging of data processing operations were added.
- libgwyapp: Missing brick containers items were added to validation and file
  merging operations.

Modules:
- Data processing, file and volume modules: Support for logging was added.
- Rank (new): Rank transform-based local contrast enhancement presentation.
- OME TIFF (new): Import Open Microscopy Environment (OME) TIFF files.
- Accurex II TXT (new): Imports Accurex II text data files.
- HDR image: 32bit and 64bit integer samples as well as 32bit and 64bit
  floating point samples are supported.  Plain BigTIFF images can be loaded.
- APE file: Metadata handling for different SPM modes was improved.
- NanoScanTech: Problems with loading 4d jumping mode spectroscopy fixed.
- NT-MDT: Hybrid mode is loaded with distance calibration,
  pre-calculated data fields are loaded from hybrid-mode data.
- Scale: Rounding of scaling ratio to some odd values was fixed.
- Pixmap export: Bad row padding for some BMP image widths was fixed.
- RHK SM4: PRM are imported to metadata.
- Igor file: Infinities and NaNs in the data are filled with a neutral value
  and masked upon import.
- NanoScan: Files with http://www.nanoscan.ch/SPM namespace are recognised.
- Merge: Bug causing occasional use of data outside of the operand images was
  fixed.


2.34 (2013-12-15)
Application:
- Tear-off menus: It is no longer possible to tear off toolbox submenus.  The
  tear-off menus were removed as they have been broken in Gtk+ for a long time.
- Toolbox: Seldom used functions (Rotate and Unrotate) were replaced with
  Dimensions & units and Arithmetic in the default toolbox.
- Toolbox: Menu ‘Meta’ in the toolbox was renamed to ‘Info’.
- OS X: Menu integration support in 64 bit OS X application.
- 3D view: Settings of 3D view labels are also stored when 3D defaults are
  saved.
- Translations updated: Czech, French, Italian, Russian.

Libraries:
- libgwyprocess: A function for affine transformation of data fields was added.
- libgwydgets: A function to test sensitivity group membership was added.
- libgwydgets: Pygwy stock icon was added.

Modules:
- Otsu's thresholding (new): Grain marking using Otsu's method.
- Affine distortion (new): Correction of affine distortion by matching image
  and expected lattice vectors.
- Lattice layer (new): Layer allowing selection of a two-dimensional lattice.
- LEXT: Can load colour images; R, G, B are imported as separate channels.
- OLS, LEXT: False colour gradients of colour channels are automatically set to
  RGB-Red, RGB-Green and RGB-Blue.
- Graph cut: Cutting other curves than the first actually works.  Memory leaks
  were fixed.
- Dimensions and Units: If image dimensions change selections are cleared.
- WSF file: All key-value pairs in the file header at placed to metadata.
- NetCDF: Support for multi-layer files was added.
- Volume show and extract: A possible crash was fixed.
- NT-MDT: Support for new spectroscopy frames was added, loading of 4D data
  from MDA frames improved: hybrid jumping mode, Raman images from 'new
  solver-next electronics’ era devices, external data storage, metadata parsing
  from XML.
- Pygwy: Console is persistent and only one can exist, it has a clear log
  button, gwy syntax highlighting was added, a number of leaks was fixed,
  Python wrappers for file loading and grain numbering were improved.
- Pixmap: Only edge false colour scale ticks are drawn for adaptive mapping.
- S94 file: Support for current images and metadata was added; scaling of
  topography images was corrected.
- Seiko: Files starting with SPIZ000STM are recognised and imported.  Data
  should be read with correct value offsets (i.e. not just scale) now.

Other:
- Resources: Three new false colour gradients were added, RGB-Red, RGB-Green
  and RGB-Blue, representing pure R, G and B channels.


2.33 (2013-10-17)
Application:
- Translations updated: Czech, French, Russian, Spanish.

Libraries:
- libgwyprocess: Speed of tip blind estimate was improved by not reporting
  progress too often.
- libgwyapp: Tools can remember and restore also position of the dialog,
  within one session.
- libgwyapp: Data choosers can be created also for volume data.
- libgwyapp: The data browser provides id lists and thumbnails also for volume
  data.

Modules:
- Zemax (new): Imports Zemax grid sag data files.
- Dimensions and Units: It is possible to set the pixel size to match exactly
  another channel.  Undo warnings were fixed.
- TIA SER: spectral arrays reimplemented as volume data.
- Volume show and extract: Crash for data with unequal resolutions in different
  dimensions was fixed.
- Merge: Pixel size of images created in ‘None’ merge mode correspond to
  pixel size of the merged images.
- Tip blind estimate: Estimate can be made for several horizontal stripes on
  the image and tip radius for each estimated.
- Pixmap: Loading of TIFFs on 64bit MS Windows was disabled because the
  system library crashes.
- Igor file: Units are correctly derived from channels starting with ‘DAC’.
- GWYXYZF: Compilation on big endian architectures was fixed.
- Arithmetic: Aspect ratio setting of result is taken from the first channel
  used in the expression.
- EZD file: Support for 32bit depth was added.


2.32 (2013-09-08)
Application:
- Translations updated: Czech, French, Russian, Spanish.
- Toolbox: Metadata browser is no longer present in Meta menu.  Access it via
  the right-click (Shift-F10) context menu of data (and volume) windows.

Libraries:
- libgwyprocess: Summary statistical functions for bricks were added.
- libgwyprocess: 2D ACF normalisation (off by 1/√xres) was corrected.
- libgwydgets: 3D view can display data overlays without any lighting.
- libgwydgets: Unwanted window dragging with KDE oxygen theme was hopefully
  fixed.
- libgwydgets: Graph PostScript tries to avoid some non-ASCII characters; the
  key position was corrected fixed.
- libgwydgets: Data window updates colour axis range also after resize, fixing
  range not being updated after an in-place Crop.
- libgwymodule: Volume data processing module management functions were added.
- libgwyapp: Support for volume data and functions were added to the data
  browser and menu constructors.
- libgwyapp: Toolbox items sensitivity corresponds to data available in the
  current file, not globally.  This fixes a long-standing bug when it was
  possible to run a module function for a type of data for which
  gwy_app_data_browser_get_current() did not actually give anything.
- libgwyapp: Public functions to display metadata browser were added.
- libgwyapp: Editing data titles in data browser can be invoked using mouse
  again (a double-click activation followed by a normal click).

Modules:
- Volumize (new): Create a simple 3D volume data from 2D data.
- Volumize_layers (new): Create 3D volume data from set of 2D data.
- Show and extract (new): Show 3D volume data and extract some projections.
- Volume invert (new): Invert value in a 3D volume.
- Tescan (new): Imports Tescan MIRA SEM images.
- S94 (new): Imports S94 STM files.
- Spectral synthesis: A ‘Lorentzian’ multiplier leading to exponential ACF
  was added.
- WSxM: Files with wrong ‘Image header size’ field are imported correctly.
- APE DAX: Metadata import was improved.
- LEXT: Tries to import image 0, even though its data type can be only
  estimated.
- Pixmap: Crashing when run from stand-alone python script was fixed.
- PSIA: Vertical flipping of data was corrected.
- Raw XYZ: User-selected resolutions are remembered.
- All synthesis: Fixed Critical warnings/crash when the current file has no
  channels.
- Dimensions and Units: Allow negative z calibration factor or range.
- Nanoscope: Basic support for Force Volume data was added.
- Points layer: Can draw point numbers.
- Spectro tool: Spectra points are numbered.
- Omicron: Positions of grid spectra points were corrected.
- Polynomial level: Coefficients are shown and can be exported to a file.
- Profile, Spectro tools: Curve colours are shown as small swatches in the
  table.
- Nanomagnetics: Support for version 5 files was added.
- Arithmetic: It is possible to use ‘x’ and ‘y’ in the expressions for real
  coordinates in the image.
- Dimensions and Units: Can create a new channel or modify the current one.
- AIST: Small fix of broken file parser in spectra loading.
- NT-MDT: Raman image loading was reimplemented as volume data.
- NanoScanTech: Basic 4D data loading was implemented.
- WiTec Project: Graph image loading was implemented.
- OLD MDA: Data loading was implemented as volume data.

Other:
- Dependencies: GLib 2.14 is now required.
- MS Windows: The Win64 package uses correct set of registry keys, installation
  paths and the shortcut name was differentiated, allowing parallel
  installation with Win32.


2.31 (2013-02-21)
Application:
- Translations updated: Czech, French, Russian, Spanish.

Libraries:
- libgwyprocess: Bogus normalisation/possible crash in gwy_data_field_area_dh()
  in presence of mask on non-square area was fixed.
- libgwyprocess: gwy_data_field_area_dh() returns a reasonable empty
  distribution if the area contains no data due to masking.
- libgwyprocess: Radial PSDF normalisation was corrected to be really
  sampling-independent and correspond to the formula in user guide.
- libgwyprocess: Double-free error if the initial Delaunay triangulation step
  fails was corrected.
- libgwyprocess: Swapped x and y coordinates of spectra in serialisation were
  fixed.
- libgwyprocess: Added brick (volume) data support backported from Gwyddion 3
  development branch.
- libgwyprocess: gwy_data_field_distort() actually works for destination
  field of different size than source.
- libgwydgets: Crashes upon clicking colour selection buttons were fixed.
- libgwydgets: 3D view false colour axis shows overlay, not height units in the
  overlay mode.
- libgwyapp: Visibility of false colour bar and mask are included in 3D view
  settings saved by ‘Set Defaults’.

Modules:
- APE DAX (new): Imports APE Research DAX files.
- Nanomagnetics (new): Imports Nanomagnetics NMI files.
- VTK export (new): Exports fields as VTK structured grid files.
- Magellan (new): Imports FEI Magellan SEM images.
- Extend (new): Extends a field by adding borders using several methods.
- Brickshow (new): Added a simple module for loading, visualising and data
  extracting from 3D volume data (Bricks)
- GWYXYZF (new): Imports and export Gwyddion Simple XYZ files.
- Seiko: Files starting ‘NPXZ000AFM’ are recognised and imported.  XQP phase
  files should be read with a correct value scale and units.
- Shimadzu: Files of different version than 2 are recognised and loaded.
- Omicron flat: Crash while reading files with up and down traces but no
  retrace was fixed.
- Createc: Conversion of raw data to physical values was corrected.
- Nanoeducator: Keep relative coordinates of data fields,
  Material description decoding from CP1251,
  Attempt to fix current scale in spectroscopy.
- Nanoscantech: Scan names of new standard (inside Attributes) supported,
  Units and scan names recoding from CP1251.
- Nanoscope: F-Z spectra are imported (experimental).
- Pixmap: Manual font size range is limited by zoom.  Inset bar length is
  remembered and used the next time if possible.
- Raw XYZ: Tolerance for ‘regular grid’ (which is not triangulated) was
  increased to 5% of pixel size to help people with poorly rounded data.
- Edge: New Sobel and Prewitt classic edge detection functions.
- Drift correction: Correction can be applied to all compatible channels
  and channels can be directly replaced with corrected ones.
- Line layer: Thick line end markers are drawn correctly to image targets.
- NetCDF: GXSM file metadata support was improved, images are flipped when
  appropriate.
- Fit sphere: Units of resulting quantities are set correctly.
- Omicron: Abscissae of single point spectra were corrected to match SCALA.
- Graph fit: It is possible to plot the difference between data and fit to
  a new graph.
- Graph fit, FD fit and Critical dimension: Curve and controls were switched,
  controls should no longer jump around, interfering with selection.
- Merge: ‘None’ merge mode which does not do any correlation search was
  actually implemented.  Critical warnings and wrong smooth merging for some
  image combinations were fixed.  ‘Second’ really means the image selected in
  the dialog now.

Other:
- MS Windows: Crash on Win32 while loading TIFF images was hopefully fixed.
- Dependencies: Compatibility with GLib older than 2.26, accidentally broken in
  2.30, was restored.
- Unix compilation: Desktop files in correct locations are updated with
  --enable-home-installation configure option.
- Python: Stand-alone gwy python module on Win32 no longer tries to load
  non-existent Gwyddion libraries.
- MS Windows: Executables are available also as 64bit.  They are still
  somewhat experimental and do not include Python scripting support.


2.30 (2012-09-21)
Application:
- Translations updated: Czech, French, Russian.
- MS Windows: Handling of files with non-ASCII characters in names on Win32 was
  improved.

Libraries:
- libgwyprocess: A new function to remove grains touching image borders.
- libgwyprocess: New grain quantities: Radius and position of maximum
  inscribed disc and minimum circumscribed circle, area of grain convex hull,
  mean radius.
- libgwyapp: Critical warning/crash if the last visible channel of a file is
  deleted and this channel has a mask.
- libgwyapp: Setting a channel or graph visibility key in a container
  actually shows or hides the corresponding data.

Modules:
- Neural network: Split to two functions: training and application.  Networks
  can be saved, trained on multiple data (sequentially), training signal can
  be masked, units of the output can be specified.
- APE file: Channel labelling for various modes was corrected.
- Createc: Dimensions and values of imported data was corrected, all channels
  are imported now.
- Igor file: Crash on files that contain no channel titles was fixed.
- Selection manager tool: Chosen selection is shown in the data window.
- Remove Grain by Threshold: Can also remove grains touching image borders.
- Grain Statistics: Select Inscribed Discs and Select Circumscribed Circles
  create circular selections visualising the corresponding discs/circles.
- Grain correlations: Really works when run non-interactively.

Other:
- Dependencies: Compatibility with newer version of GLib that deprecate various
  things was improved.
- MS Windows compilation: Win32 executables are built using MinGW-W64
  cross-compiler.


2.29 (2012-07-20)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyprocess: New function to calculate grain-wise rms.
- libgwymodule: gwy_file_get_data_info() sets its arguments to NULL if no file
  info is found, fixing a possible crash if newly generated data are saved.
- libgwyapp: Recent file names are compared canonicalized, fixing repetition
  of the same file in document history on MS Windows.

Modules:
- Pixmap: Scalebar ticks and label can be enabled/disabled.
- Grain statistics: Displays total projected boundary length.
- Median line correction: Masking is supported.
- TIA SER: Spectral data import is supported.
- Statistical quantities: New quantity was added: grain-wise rms.
- Omicron: Files created by SPIP are recognised and loaded.
- Nanoscope: Support for old files without @2:Z scale was improved.
- Object synthesis: A bug causing Critical warning/crash during the generation
  of non-square data was fixed.
- Seiko: The guesswork involved in loading of non-square files was somewhat
  improved.
- Neural network: Result model size can differ from source, miscellaneous small
  improvements.

Other:
- Python: Pygwy is packaged in the Win32 installer (it requires separate Python
  and PyGTK installation though).
- Python: Stand-alone python gwy module is available (experimental).
- Resources: Several icons were improved.


2.28 (2012-05-18)
Application:
- Translations updated: Czech, French, Russian.

Modules:
- Nanoscantech (new): Imports NanoScanTech .nstdat files.
- TIA SER (new): Imports FEI Tecnai imaging and analysis .ser files.
- DM3 (new): Imports Digital Micrograph DM3 TEM images (only greyscale data at
  present).
- PID (new): Simple simulation of PID loop effects during scanning.
- Lateral force (new): Simulation of lateral force from topography channel.
- Neural network (new): Neural network data processing.
- XY denoise (new): Data denoising based on horizontal and vertical scans.
- WIP: Spectral transformation for Raman data was fixed and swapped XY axes in
  datafields were really fixed.
- Zeiss: Files without key-value pairs in tag 34118 are recognised and loaded.

Other:
- Dependencies: Compatibility with libpng 1.5 was corrected.
- Utils: GNOME 3 thumbnailer file is installed, making gwyddion-thumbnailer
  work automatically in GNOME 3.
- Unix compilation: configure has an option --enable-home-installation to ease
  desktop integration if you compile from source code and install to your home.


2.27 (2012-04-16)
Application:
- Translations updated: Czech, French, Russian.

Library:
- libgwyddion: Parsing of units was improved to recognise some full names.
- libgwyprocess: Broken preserverms in 2D FFT was fixed.

Modules:
- Old MDA (new): Imports NT-MDT old MDA spectra data.
- NanoObserver (new): Imports NanoObserver NAO files.
- Pixmap: The font used for labels can be changed.
- Nanoscope: Images defined in ‘Image list’ header section are loaded now.
- 2D FFT: An option to preserve RMS was added.

Other:
- Dependencies: Compatibility with GLib 2.32 was corrected.


2.26 (2011-12-17)
Application:
- Translations updated: Czech, French, Italian, Russian, Spanish.
- Keyboard shortcuts: Can be modified by pointing to the menu item and pressing
  the new shortcut (after enabling this in the Edit menu).

Libraries:
- libgwyddion: New functions for case-insensitive string hashing.
- libgwyprocess: Kaiser 2.5 FFT window was fixed to avoid returning NaNs at
                 certain transform sizes (due to rounding errors).
- libgwyprocess: New function for asymmetrical outlier marking.
- libgwyprocess: Bug affecting calculation surface areas and volumes of grains
  on the lower edge of a non-square image was fixed.
- libgwydgets: Graph data can be exported to ASCII in a locale-independent way.
- libgwydgets: Graph window properly disconnects signals from the graph model
               when destroyed.
- libgwydgets: Labels on 3D view axes are rotated with the axes.
- libgwydgets: 3D view supports ‘overlay’ mode with secondary data or mask used
               for false colour mapping.
- libgwydgets: 3D view can show false colour scale.
- libgwydgets: Vertical graph measurement mode was added.
- libgwyapp: Possible crash due to wrong freeing of GBookmarkFile was fixed.
- libgwyapp: File chooser can plane- and/or row-level previewed data.
- libgwyapp: Critical warning/crash in file merging was fixed.
- libgwyapp: Data browser updates the thumbnail also when the mask changes.

Modules:
- Code V INT (new): Imports Code V INT grid interferograms.
- Zeiss (new): Imports Carl Zeiss SEM scans (TIFF).
- Hitachi SEM (new): Import Hitachi S-3700 and S-4800 SEM data.
- ISO28600 (new): Imports and exports ISO 28600:2011 SPM data transfer
  format.
- Alicona (new): Imports Alicona Imaging Al3D files.
- WITec ASCII (new): Imports WITec ASCII export files.
- RHK SM4: Support for spectra reading was added (as graphs).
- 1D FFT filter: Correct X-axis units of Fourier modulus are displayed.
- Level Grains: The sign of extracted background was corrected.
- LEXT: Crashing on systems lacking memrchr(), namely MS Windows, was fixed.
- Graph export ASCII: Can export floating point numbers in POSIX format.
- Pixmap: Scale bar are drawn (with the default length) even when the module
  is used non-interactively.
- Pixmap: Critical warning/crash ‘assertion text!=NULL failed’ was fixed.
- Nanoscope: Import of files with non-1:1 pixels was improved.
- Dumb: Builds on big-endian architectures.
- SDFile: Letter case of header fields is ignored.
- SDFile: Extra fields after the data are made available in metadata.
- WIP: Swapped x and y axes were corrected.
- Statistical functions tool: Height distribution can use masking.
- Roughness tool: The resulting curves are no longer automatically levelled.
- Unisoku: Import of files containing NUL characters in the header was fixed.
- Pattern synthesis: Real values of parameters are displayed immediately
  after a pattern type switch.
- Pygwy: Values are stored to GwyContainer as fundamental GObject types so they
  can be actually serialised.
- Pygwy: Load and save module functions can take an optional run mode argument.

Other:
- Dependencies: Compatibility with gcc 4.6 and autoconf 2.68 was improved.
- Utils: The thumbnailer permits specifying the channel used to create the
  thumbnail (if run manually).
- MS Windows: Drag'n'drop should work on Win32 again.
- Source code packages: Bzip2-compressed source code tarballs were replaced
  with xz-compressed.


2.25 (2011-06-06)
Application:
- New translation: Spanish.
- Translations updated: Czech, French, German, Italian, Russian.
- Keyboard shortcuts: Ctrl-H invokes Document History.
- Document history: The filter has a Clear button.

Libraries:
- libgwyddion: SI unit arithmetic, sometimes giving incorrect results if one of
  the operand was the same object as the result, was corrected.
- libgwyddion: New functions for conversion blocks of raw data to doubles.
- libgwydgets: Units with powers of subscripts are shown correctly in 3D view.
- libgwymodule: Macro GWY_MODULE_QUERY automatically adds extern "C" if
  compiled as C++.
- libgwymodule: New file load/save functions reporting the actual module
  function used to load/save the file.
- libgwyapp: File load/save error message boxes were improved.

Modules:
- CSM (new): Imports Benyuan CSM files.
- AMB (new): Imports Ambios AMB files (experimental).
- WIP (new): Imports WITec project files.
- NRRD (new): Imports and exports Nearly Raw Raster Data (NRRD).  To get
  support for compressed files, Gwyddion must be built with libz and/or libbz2.
- Robotics (new): Imports Automation and Robotics Dual Lens Mapped data.
- Dumb (new): Loads plug-in proxy's dumb dump files.
- HDR image (new): Exports data into OpenEXR files (requires libImf, currently
  used only on Unix).  Imports 16bit PNG and PGM images.
- Mask editor tool: Program termination upon attempt to draw in drawing mode
  was corrected (bun introduced in 2.24).
- NT-MDT: Slowness of MDA spectra loading was corrected, MDA frames are
  numbered similarly to other channels.
- All syntheses: Critical warning/crash upon clicking on Change units and the
  current units were unset was fixed.
- Pixmap: Colourful images can be imported as separate R, G, B channels and
  also as Luma.
- Pixmap: 16bit greyscale PNG and PGM images are exported with metadata bearing
  the physical units and scales as text comments or PNG sCAL and pCAL chunks.
- Pixmap: Images are displayed in file open dialogue preview.
- OPD: Workaround for weird AdjustVSI_* fields was added, making possible to
  open VSI files.
- OLS: Can load colour images; R, G, B are imported as separate channels.
- Merge: Calculation of physical dimensions of the merged image was corrected.
- RHK-SM3: Loading of multi-page files was corrected.
- Raw graph import: Possible crash if the file cannot be loaded was fixed.
- Omicron: Can load grid spectra files *.sf* and *.sb*.
- Nanonics: Newer files with long headers and raw sensor data following the
  image data can be imported.

Other:
- Utils: The KDE4 thumbnailer is not built by default.
- Source code packages: Line noise synthesis module, forgotten from the
  package, was reinstated.


2.24 (2011-04-08)
Application:
- Translations updated: Czech, French, German, Italian, Russian.

Libraries:
- libgwyprocess: gwy_data_line_new_alike(), gwy_data_line_duplicate() and
  gwy_data_line_clone() keep the offset.
- libgwydgets: GwyColorAxis is drawn correctly if the z-range is inverted.
- libgwyapp: Graph windows offer all graph functions in a context menu.
- libgwyapp: Memory leaks in the data browser were plugged.
- libgwyapp: The most recent 10 files can be opened using Ctrl-1 to Ctrl-0.

Modules:
- MUL file (new): Imports Aarhus MUL data files.
- Spectro tool: It is possible to average the selected spectra.
- Nanoeducator: Loading of multiple spectra per point was corrected.
- Nanoeducator: Z-range of I(z) spectroscopy was corrected.
- OPD file: Support for v5.0 data was added.
- Pixmap: False colour scale is drawn correctly if the z-range is inverted.
- Attocube: File detection is more liberal, accepting anything starting
  with ‘# Daisy’.
- 2D FFT filter: Image difference output type was added.
- Mask editor tool: Spurious drawing upon data/tool switch was corrected.

Other:
- Desktop integration: The list of MIME types Gwyddion declares it can open (on
  Unix) was updated and made to be updated automatically.


2.23 (2011-03-05)
Application:
- Translations updated: Czech, French, Russian.
- Command line: OpenGL can be completely disabled with --disable-gl to avoid
  provoking buggy graphics drivers.

Libraries:
- libgwyprocess: New classes GwyCalibration and GwyCalData representing
  instrument calibrations.
- libgwyprocess: Delaunay triangulation algorithms by Ross Hemsley were added.
- libgwyprocess: Added statistical functions for calculating uncertainties
  from calibration data.
- libgwyprocess: Small discrepancies in surface area calculated with mask
  were corrected.
- libgwyprocess: If grain minimum or maximum was requested without the other
  it has not been calculated (bug introduced in 2.22); this was corrected.
- libgwyprocess: Laplacian of Gaussians filter was added.
- libgwydgets: Bogus GwyNullStore virtual method iter_chilidren() was fixed.
- libgwyapp: Support for calibrations was added to Data Browser.
- libgwyapp: Data windows use a thumbnail of the image as the window icon.
- libgwyapp: Data browser shows the full file path as a tooltip of the file
  name.

Modules:
- WSF file (new): Imports WSF SPM data.
- MIF (new): Import of DME MIF files v1.7 (just topography).
- Level Grains (new): Subtract background that makes marked grains level.
- Mark grains by edge detection (new): Grain marking using edge-detection.
- Calibration, Load from text file (new): enables loading complex calibration
  data.
- Calibration, Create (new): enables defining simple calibration data for 3
  axes.
- Calibration, View (new): select, view and apply calibration for specific SPM
  data.
- Calibration, Simple error map (new): create simple calibration entry from
  grating measurement.
- Nanonis: Can open files containing a multi-pass configuration table.
- Pixmap: The set of importable formats was limited to BMP, GIF, ICNS, JPEG,
  JPEG2000, PCX, PNG, PNM, RAS, TARGA, TIFF and XPM that are known to work to
  avoid crashes whenever a new buggy loader appears in GdkPixbuf.
- MapVue: Support for old OptiCode files was added.
- Profile: Modified to display calibration data if present.
- Read value: Modified to display calibration data if present.
- Statistical quantities: Modified to display calibration data if present.
- Statistical functions: Modified to display calibration data if present.
- DOS spectrum: Calculates absolute value of (dI/dU)/(I/U) and does not
  removing the contact potential.
- Object synthesis: Object heights can be truncated.
- Pattern synthesis: Range calculations were corrected, removing problems with
  pattern occasionally ending prematurely.  Patterns with the same random seed
  will not be pixel-for-pixel identical to pre-2.23, just statistically.
- Pattern synthesis: New pattern type, two-dimensional grid of holes, was added.
- 2D FFT filter: It is possible to zoom in the central area of the Fourier
  space editor.  A Fill button was added.  Asymmetrical masking for odd-sized
  fields was corrected.

Other:
- MS Windows compilation: Compilation with MSVC6 toolchain on MS Windows is no
  longer supported, use MinGW32.  The recommended compilation method is
  cross-compilation on Linux.
- Linux compilation: Building of RPMs should work on any sufficiently
  RedHat-based distribution, not just Fedora.


2.22 (2010-12-06)
Application:
- Translations updated: Czech, French, Russian.
- Command line: Option --no-log-to-file disables redirection of messages to a
  log file (useful namely on Win32).

Libraries:
- libgwyddion: Portable isinf and insnan (gwy_isinf() and gwy_isnan()) were
  added.
- libgwyddion: gwy_math_curvature() calculating curvature parameters from a
  quadratic surface polynomial coefficients was added.
- libgwyddion: GwySIUnit works correctly if created with g_object_new().
- libgwyprocess: Odd behaviour of 1D convolution and Gaussian filters for
  kernels much larger than data were corrected to full mirroring.
- libgwyprocess: New grain quantities related to curvature were added.
- libgwyprocess: gwy_data_field_grains_get_quantitites() can calculate
  multiple built-in grain quantities at once, avoiding repeated work.
- libgwyprocess: Buffer overflow in gwy_data_field_correct_laplace_iteration()
  for thin masks touching the data field sides was corrected.
- libgwyprocess: Laplace basis for grain volume calculation that might not be
  sufficiently converged is now let to really converge to a stable surface.
- libgwyprocess: Slope-related grain quantities now fall back to 0 instead of
  becoming NaN for too small grains.
- libgwyprocess: Grain boundary minimum and maximum calculation considers
  pixels at edges of the image to be boundaries too.
- libgwyprocesss: New function for radially averaged ACF.

Modules:
- Anfatec (new): Anfatec data file import.
- Pattern synthesis (new): Creates regular patterns such as steps of ridges.
- Noise synthesis (new): Generates uncorrelated point noise.
- Line noise synthesis (new): Generates line noise (steps or scars).
- Particle synthesis (new): Generate (modify) surfaces by particle
  deposition using a simple dynamic model.
- Object synthesis: Objects can be placed onto an existing surface, two
  new shapes (diamond and Gaussian) were added, other small improvements.
- Spectral synthesis: Generated data can be added to an existing surface.
- Mask Editor tool: New editing tools were added: paintbrush, eraser,
  and bucket filling and unfilling.
- Statistical functions: Radially averaged ACF was added.
- Arithmetic: Has a preview, expressions can work with mask values, units of
  the result can be specified, the number of fields was increased to 8.
- Threshold: Renamed to Limit Range in the menus; can cut off outliers given
  by a multiple of RMS now.
- BCR: Z-axis scaling for non-topography floating point data was corrected.
- GDEF: Vertically flipped data was corrected.
- Colour Range tool: Critical warning/crash when Fixed mode is set default
  and the file is closed was fixed.
- Plug-in proxy: Channel title read from dump files is retained now.
- Grain distributions: The comment header option is remembered.
- Pygwy console: It can be run also if no data is loaded.

Other:
- Dependencies: Gwyddion tries to initialise thread support as the very first
  thing if it finds to be running with GLib 2.24 or newer.
- Unix compilation: If compiled by gcc and it accepts option
  -fexcess-precision=fast it is passed to the compile to be on the fast side.
- MS Windows compilation: It is possible to cross-compile Gwyddion for MS
  Windows using the MinGW32 cross-compiler.  The official executables are still
  made using MSVC6 though.


2.21 (2010-10-26)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyprocess: gwy_data_field_clamp() and gwy_data_field_invert() correctly
  update cached minimum and maximum field values.
- libgwyapp: It is possible to disable undo globally, undo/redo operations
  then become no-op.
- libgwyapp: It is possible to disable creation of windows by data-browser.
- libgwyapp: Channels, graphs and spectra can be searched using a GPatternSpec
  pattern.
- libgwyapp: GwyAppDataChooser channel chooser dynamically reflects the set
  of channels.

Modules:
- LEXT (new): Olympus LEXT 4000OLS data import.
- GDEF (new): DME GDEF data import.
- Mutual Crop (new): Crop two shifted channels to the common area (found using
  correlation search).
- Threshold (new): Limit data to specified range by cutting values outside it.
- Graph DOS spectrum (new): Calculates DOS spectrum from I-V tunnelling
  spectroscopy.
- Igor: Support for non-Asylum-Research files was improved.
- Pixmap export: The horizontal ruler always displays units now, even if the
  x-range does not include zero.
- Mask editor tool: New operation Fill Voids fills holes in masked areas.
- NT-MDT: Offset of x-axis in non-MDA spectroscopy frames was corrected.


2.20 (2010-06-30)
Application:
- Translations updated: French, Russian.
- 3D view: It is possible to export 3D as image also to other support pixmap
  formats, the format is determined by the extension.

Libraries:
- libgwyprocess: Deserialization of spectra when there are selected curves
  actually works now.
- libgwyprocess: gwy_data_field_fit_poly() and gwy_data_field_area_fit_poly()
  work without coeffs array preinitialized to zeroes.
- libgwyprocess: Radial PSDF calculation uses all necessary DFT coefficients,
  correcting the calculation for anisotropic images.
- libgwydgets: GwyColorAxis can show numbered ticks.

Modules:
- GSF (new): Gwyddion Simple Field single-channel file reading and exporting.
- SICM: Value scale was corrected and some more metadata fields are read now.
- Facet level: Bugs when masking was used were fixed, namely in Exclude mode.
- 1D FFT Filter, Colour Range tool: square root of the density is shown on
  graphs to visualize smaller peaks better.
- Nanonis: Files with multi-line comments can be imported, metadata support
  was added.
- Omicron: Metadata values are imported from parameter files.
- Quesant: Null file part offsets are ignored in the header, fixing import of
  some files.
- NT-MDT: Z value offsets are honoured in imported data.
- Shimadzu: Bogus warning that Z offset units differ from Z scale units was
  fixed.
- Nanoscope: Some import support for I-V spectra was added.
- JPK: Support for 32bit data was added.
- Pixmap export: False color scale ticks are numbered.
- Rotate: Rotation angle can be a fractional number.


2.19 (2009-12-11)
Application:
- Translations updated: Czech, French, Russian.
- Remote control: Not starting a new instance of Gwyddion with --remote-new on
  X11 when none is running (affecting most desktop launchers and menus) was
  fixed.
- Files: Thumbnails in recent file menu are shown even if menu icons are
  globally disabled in Gtk+.

Libraries:
- libgwyddion: GwySIUnit parser ignores starting multiplication sign in units.
- libgwydgets: Rotating and scaling 3D views with mouse works with Gtk+ 2.18.
- libgwyapp: Massive leaks of GwyDataField references and, consequently,
  memory in data browser thumbnail creation (introduced in 2.14) was fixed.

Modules:
- AIST-NT (new): Imports AIST-NT files.
- PT3 file (new): Imports PicoHarp 2.0 format as photon count image.
- Omicron flat (new): Import Omicron flat files.
- Line correction: New Median difference line correction method was added.
- NT-MDT: Curves frames are imported, point positions are still wrong though.
- Nanoeducator: I-Z spectra written by newer software are supported.
- BCR: Files with long header and header size specified within are supported.
- MI file: Wrong scaling of 32bit files was corrected.
- Igor: Support for Asylum Research files was improved.
- Profile: Wrong application of thickness in profiles different from
  horizontal or vertical direction corrected.


2.18 (2009-11-03)
Application:
- Translations updated: Czech, French, Russian.
- Files: Only file types that are not detected automatically are shown in the
  file open dialogue.
- Remote control: A new backend was added: LibUnique.

Libraries:
- libgwyddion: Gaussian fitting parameter b meaning was corrected to correspond
  to the formula.
- libgwyprocess: Delaunay triangulation and XYZ data interpolation functions
  were added.
- libgwyprocess: New area statistics functions can either include or exclude
  the masked area (previously only inclusive masking was possible).
- libgwyprocess: GwyMaskingType has a public GwyEnum.
- libgwydgets: gwy_radio_buttons_create() accepts also implicitly terminated
  value-name tables.
- libgwyapp: Functions to parse typical text headers of SPM files were added.

Modules:
- Attocube (new): Imports Attocube Systems ASC files.
- NanoScan (new): Imports NanoScan XML files.
- PLT (new): Imports Nanosurf PLT files.
- Raw XYZ (new): Imports XYZ data and regularizes them to a grid.
- Igor: Support for Asylum Research files was substantially improved.
- NT-MDT: MDA frame support was improved.
- NetCDF: Can read GXSM files with data in ‘FloatField’ instead of ‘H’.
- Statistical quantities: The masked area can also be excluded.
- Seiko: Supports more file types (with magic header SPIZ000AFM).
- Nanonis: Missing data, represented by NaNs in the SXM files, are masked and
  replaced with a neutral value upon import.
- Pixmap export: TIFFs are written in binary mode, fixing broken exported
  images on MS Windows.
- Pixmap export: It is possible to export data as 16bit greyscale images (at
  present for TIFF, PNG and PNM).
- ASCII export: It is possible to set precision of exported values.
- Object synthesis: Cone, box and tent shapes were added.
- Mark With: Marking result sometimes not corresponding to selected options
  was fixed.

Other:
- OS X compilation: Inclusion of wrong OpenGL header when building with Quartz
  backend was fixed.
- OS X compilation: Inclusion of gdkquartz headers when building for X11 on Mac
  was corrected.


2.17 (2009-09-22)
Application:
- Translations updated: Czech, French, Russian.
- OS X integration: menu bar, language selection, opening files from Finder.
- MS Windows: The language falls back to system language if gwy_locale is unset
  on Win32.

Libraries:
- libgwyprocess: Real length of extracted profiles was corrected for very
  short lines and different vertical and horizontal measures.
- libgwyprocess: gwy_data_field_area_fit_poly() really works with NULL mask.
- libgwyprocess: FFT functions no longer unpredictably lose input data with
  FFTW3 -- they now use the FFTW_ESTIMATE planner that preserves the input
- libgwydgets: Resource selection windows can be closed with Esc.

Modules:
- Curvature (new): Calculates global curvature of second-order surfaces.
- RHK-SM4 (new): Imports RHK Technology SM4 files.
- Igor (new): Imports Igor Pro binary waves (highly experimental).
- Nanonics (new): Imports Nanonics NAN files (highly experimental).
- FFT synthesis (new): Generates random surfaces by spectral synthesis.
- Object synthesis (new): Generates random surfaces by object placement.
- Arithmetic: New quantities bx1, by1, bx2, ..., by5 represent the local x-
  and y-derivatives.
- Arithmetic: History of previously used expressions is remembered.
- Omicron MATRIX: Possible crash was fixed.
- Createc: Support for floating-point files was added, including compressed
  data.  Module is more robust with respect to broken files.
- NT-MDT: Support for MDA frames was added.
- Olympus: Value scales of imported data were corrected.
- APE file: Support for newer 2.x files was implemented, some units and scales
  corrected; channels have meaningful names now.
- MI file: Support for 32bit binary files was added.
- MicroProf: Can read binary FRT files (the first channel only).
- Profile: The profile resolution is no longer limited by the data dimensions.
- Nanoscope: Files broken by line-end transformations are detected and an
  explanatory error message is given.

Other:
- Source code packages: Forgotten @LIBTIFF@ was removed from gwyddion
  pkg-config file.
- Linux compilation: Building RPMs hopefully works on Mandriva again, including
  working around the utterly broken enforcement of -Werror=format-security in
  2009.1.


2.16 (2009-06-25)
Application:
- Translations updated: Czech, French, Russian.
- Toolbox: About dialogue shows optional features compiled into the specific
  build.

Libraries:
- libgwyddion: Lorentzian fitting preset parameter estimator was corrected.
- libgwyprocess: Missing data field invalidation after Laplace iteration was
  added, fixing wrong colour scales after Laplace interpolation data removal.
- libgwyprocess: Broken Fourier transformations of large prime sizes with
  stride larger than one were fixed in simpleFFT (does not affect FFTW).
- libgwydraw: GwySelection has a new virtual method crop().
- libgwydraw: Function for filtering objects in GwySelection was added.
- libgwydgets: GwyDataView provides real offsets of displayed data field.
- libgwydgets: Truncated logarithmic axes were really fixed.
- libgwyapp: Layout of previews in file dialogues, broken by Gtk+ 2.16, was
  corrected.

Modules:
- Selection manager tool (new): Copies selections to other channels and files.
- FFT profile (new): Reads radial FFT modulus profiles.
- PSIA: Format version 1.0.2 is supported.
- OLS, JPK: GwyTIFF is used instead of libTIFF for file loading.  This should
  fix a number of TIFF-related problems, namely on MS Windows.
- RHK-SM3: Bug that prevented loading of some SM3 files was fixed.
- WSxM: Files produced by Nanonics AFM are supported.
- Pixmap export: libTIFF is no longer used, TIFF files are written directly.
- Rawfile: Support for 64bit integer built-in types was added.
- Rawfile: Updating the preview with Alt+U uses the new value of just-edited
  field.
- Layer modules: Support for crop() method was added.
- Point layer: Can display selection as vectors from the origin (new property
  "draw-as-vector").

Other:
- MS Windows: Win32 installer offers to choose the language to use.
- Dependencies: Gwyddion no longer directly uses libTIFF on any platform (it
  used to be optionally linked with libTIFF).


2.15 (2009-05-20)
Application:
- Translations updated: Czech, French, Russian.

Libraries:
- libgwyddion: Crash in gwy_memem() after failed partial match was fixed.
- libgwydgets: Initial state of widgets in GwySensitivityGroup might not be set
  properly if they were added during a queued update.  This was fixed.
- libgwydgets: 3D view unqueues full-size redraw when it is unrealized, fixing
  crashes when the widget is destroyed before the redraw occurs.
- libgwydgets: Rendering of GwyRuler with Quartz Gtk+ (native OS X) was fixed.
- libgwydgets: 3D view axes lengths and positions for data with non-square
  pixels were corrected.
- libgwydgets: More translatability problems were fixed.
- libgwyapp: Critical warnings/crashes in data browser when a new object was
  added was fixed.
- libgwyapp: Data browser window has wm role set to "gwyddion-databrowser".

Modules:
- Nanoeducator (new): NT-MDT Nanoeducator file import.
- OLS: Module omitted in the MS Windows builds was added.
- OPD file: Import of integer data was corrected.
- Pygwy: module load() methods are run with the real filename, not with "test".
- Calibrate: It is possible to shift the data by a numerically entered value.
- Pixmap export: Inset scale bar is now antialiased.
- MapVue: Lateral dimensions of imported data were corrected, value scale was
  possibly fixed.
- DME file: Flipped data was fixed, calibration factors are taken into
  account now.
- Scale: Occasional weird range of permitted scaling ratios was fixed.


2.14 (2009-03-18)
Application:
- Translations updated: Czech, Russian.

Libraries:
- all libraries: forgotten strings were made translatable and gettext() was
  applied to some to actually translate them.
- libgwyddion: GwyNLFitPreset estimators always assign some reasonable values
  to the parameters even if the estimation in fact fails.
- libgwyprocess: Profile extraction auto number of samples always corresponds
  to the number of pixels for horizontal and vertical lines.
- libgwydgets: Wrong x-axis value reported for mouse selection in GwyGraph in
  x-axis logarithmic mode was corrected.
- libgwydgets: 3D view shows data with non-square pixels with the physical
  aspect ratio.
- libgwydgets: 3D window has a button to set the z-scale to physically 1:1.
- libgwydgets: GwyAxis no longer enters an infinite resize loop when it
  encounters completely bogus data such as undefined values and/or infinities.
- libgwydgets, libgwyapp: 3D view axes drawing can be globally disabled with
  "/app/3d/axes/disable" boolean True
  line in ~/.gwyddion/settings to work around broken OpenGL implementations.
- libgwyapp: Data browser displays channel thumbnails.
- libgwyapp: A helper function for interpolation of bad pixels upon data import
  was added.

Modules:
- Mark With (new): Create or modify a mask using another mask, data or
  presentation.
- Sensolytics (new): Imports Sensolytics file format.
- SPIP ASC (new): Imports text SPM files that look like exported from SPIP.
- MapVue (new): Imports MapVue data files (highly experimental).
- Gradient: New function for local slope azimuth presentation was added.
- BCR: Possible crash was fixed.
- Raw graph import: Two-column text files are automatically detected and
  offered for raw graph import.
- Mask operations: Attach Mask was removed, superseded by Mark With.
- Profile, Roughness tools: Subsampling of the profile for some directions of
  purely horizontal/vertical lines was fixed.
- Distance, Profile and Path level tools: The maximum number of lines was
  increased to 1024.
- Crop tool: Mask on cropped channels is properly redrawn now.
- PNI file: Vertical flipping was removed.
- Many modules: Translation problems were corrected.


2.13 (2009-02-09)
Application:
- Translations updated: Czech, French, Russian.

Modules:
- Raw graph import (new): Imports simple two-column text files as graphs.
- Distance, Stats and Roughness tools: Copy to clipboard buttons actually work
  (in 2.12 Save button did both actions and Copy did not do anything).
- Nanoscope: Physical y-size is recalculated to conserve the pixel
  y-size/x-size ratio in all files now.  This affects non-square images.
- Statistical quantities: Angles are exported in degrees as stated, instead of
  radians.
- HDF4 file: PSI files are flipped vertically to follow the convention.
- All tools: Somewhat inconsistent conversion between pixel and real
  coordinates were unified.

Other:
- Utils: File gwydion-thumbnailer.schemas is no longer distributed with paths
  from the packager's system, it is created on the build system with the
  correct paths.
- MS Windows compilation: Outdated MSVC makefiles released in 2.12 were
  corrected.


2.12 (2009-01-04)
Application:
- New translations: Russian.
- Translations updated: Czech.
- Toolbox: Tips of the day were added, accessible in Meta → Tip of the Day.

Libraries:
- libgwyddion: New macro gwy_clear() zeroes memory in a sizeof-safe way.
- libgwyddion: New function gwy_memmem() that wraps or emulates GNU memmem().
- libgwyprocess: Some grain corners had not been counted as described in grain
  boundary length calculation.  This was corrected.
- libgwyprocess: New grain quantities boundary minimum and maximum were added.
- libgwyprocess: GwyMaskingType enum was added.
- libgwyprocess: DataField methods such as gwy_data_field_set_val() check the
  type of the data field argument.
- libgwydgets: GwyColorAxis uses two-line labels if number and units do not fit
  on one line together.
- libgwyapp: gwy_get_foo() binary data functions were changed into a form that
  hopefully works with strict aliasing rules.

Modules:
- Pygwy: Is enabled by default (on Unix).
- Polynomial level: Possible crash when no mask is present was fixed (bug
  introduced in 2.11).
- Calibrate: No longer mangles units of the original data, Reset button works
  again, some user interface corrections.
- Pixmap export: Inset scale bar position and length can be adjusted.
- Facet level: If a mask is present, offers a choice to exclude/include data
  under mask.
- Lines layer: ‘Random’ line number sizes in pixmap export were fixed.
- Level and Level Rotate: Previously selected masking type is honoured when
  re-run with Ctrl-F (if a mask is present).
- Distance, Stats and Roughness tools: Button copying results table to the
  clipboard was added.
- Drift, Polynomial distortion: Mask and presentation are transformed too.
- Burleigh BII, Quesant: Botched modules were completely rewritten.
- Sensofar: Module was completely rewritten, fixing crashes on 64bit systems.
- RHK-SM3: Limited support for line data import was added.
- Fit sphere: Critical message caused by failed assertions was fixed.
- Scale, Rotate, Unrotate: Masks are always transformed with rounding
  interpolation, i.e. output pixels are either fully masked or not at all.
- Grain statistics: Can save the statistics table or copy it to clipboard.
- Grain distributions: Can add an header comment describing the columns.
- Mask of outliers: No longer creates empty masks.  Should the mask be empty,
  it is removed/not created instead.
- Arithmetic: Knows the constant pi.
- Arc revolution: Cluttered labels were fixed.
- Row/column statistics: Average value was moved from Options to a place where
  it is always visible and it is properly reset when no data is loaded.
- Polynomial distortion, 1D FFT filter: Update button is insensitive when
  automatic updates are enabled.

Other:
- Utils: New utility gwyddion-thumbnailer creates SPM file thumbnails for
  desktop environments.  In this release, GNOME, XFce and KDE4 are fully
  supported with thumbnails created on-the-fly.  In other TMS-conforming
  environments the thumbnailer must be run manually to batch-create the
  thumbnails.
- Unix compilation: configure options --enable-python, --enable-perl,
  --enable-ruby and --enable-pascal were canonicalized to the with-form:
  --with-python, etc.
- Desktop integration: Registered MIME types were updated, generic extensions
  such as *.dat or *.xml are no longer used for file format recognition.
- Unix compilation: If ‘make install’ is run with non-empty DESTDIR,
  freedesktop databases are not updated, i.e. configure
  --disable-desktop-file-update is no longer needed.
- Unix compilation: Flag -fno-strict-aliasing is no longer added to gcc
  compilation options.
- Unix compilation: Missing RPM dependencies on Mandriva were fixed.
- MS Windows compilation: Missing header gwyconfig.h was added to the Win32
  packages.


2.11 (2008-12-16)
Application:
- Translations updated: Czech, French, Italian.

Libraries:
- libgwyprocess: Median line statistics no longer crashes when area width is
  larger than its height.
- libgwyprocess: Several column line statistics taking data subarea always from
  the left edge instead the given column were fixed.
- libgwyprocess: Wrong calculation of mean row statistics was fixed.
- libgwyprocess: New line statistics (Rt, Rz, Ra, Skew and Kurtosis) added.
- libgwyprocess: Bug in integer erosion (and certainty map therefore) present
  in 2.9 and 2.10 was fixed.

Modules:
- Omicron MATRIX (new): Omicron MATRIX file import support.
- SPMLabF (new): SPMLab floating-point format (.flt) import support.
- OPD (new): Wyko Vision OPD file import support.
- Tilt (new): Tilt data using numerically specified coefficients.
- SPMLab: Can import R7 files now.
- Pixmap: Image import broken by too hungry jpeg2000 pixbuf loader was fixed.
- ECS file: Import works also in locales that use decimal comma.
- Line selection: Can draw orthogonal endpoint markers expressing line width.
- Omicron: Flipped spectra y-coordinates were fixed.
- Polynomial level: Can exclude/include mask when fitting the data.
- Grain statistics: Exports the (previously omitted) last grain too.
- Row/column statistics: Displays the mean value of selected statistics.
- Row/column statistics: Added Ra, Rt, Rz, Skew and Kurtosis
- Facet level: Behaviour for surfaces with very large or small ratio of
  height range to lateral dimensions was considerably improved.


2.10 (2008-06-26)
Libraries:
- libgwyddion: New FD curve fitting functions.

Modules:
- Queasant (new): Added import module
- OLS (new): Olympus LEX 3000 file import support.
- Sensofar (new): Added Sensofar PLu file import module.
- SICM (new): Added IonScope SCIM file import module.
- Burleigh BII (new): Added read support for Burleigh BII binary file format.
- Indentor analyze: Module was re-added.
- Grain distributions: Possible crashes or bogus resolutions in graph
  plotting mode were fixed.
- Graph fitting: It is possible to plot the curve over the full range even
  when only a subrange is fitted.
- RHK SPM32 (SM2): Support for spectra was added.
- MI file: Reading of ASCII image files was actually implemented.
- Plugin-proxy: Memory overflow in dump file reading was fixed.
- Surffile: Surf files can be exported.
- STP file: Improved support for extended source modes.


2.9 (2007-10-19)
Application:
- New translation: French.
- Translations updated: Czech, Italian.

Libraries:
- libgwyddion: GwySIUnit recognizes ‘Ang’ as an Angstroem abbreviation.
- libgwyddion: libgwyddion/gwymathfallback.h is the preferred header to
  define the maths fallback functions now, for compatibility
  libgwyddion/gwymath.h works too.
- libgwyddion: All the maths fallback functions are public inline functions (not
  macros) named gwy_math_fallback_foo(), so it's possible to take their
  addresses if necessary.
- libgwyddion: Defining GWY_MATH_NAMESPACE_CLEAN before including
  gwymathfallback.h prevents the definition of unprefixed aliases such as
  cbrt for maths functions not provided by the platform
  (gwy_math_fallback_cbrt() remains available).  Use in the case of possible
  name clash.
- libgwydgets: Gwy3DView uses PangoCairo instead of Pango FT2 for label
  rendering now.
- libgwydgets: Zoom of negative parts of graphs (broken in 2.8) works again.
- libgwydgets: Graph distance measuring dialog uses the correct precision
  for x-distances (instead of y-precision) and no longer displays (bogus)
  angles when x and y are different physical quantities.
- libgwydgets: Automatic range (distribution tails cut off) works with
  presentations, fixed range is ignored for presentations.
- libgwyapp: A new set of functions for checking the consistency of a data
  file (not thorough at this moment).

Modules:
- Shimadzu (new): Shimadzu SPM file version 2 file import.
- Pygwy: Widgets and more data types are supported, miscellaneous bugs were
  fixed.
- Nanonis: Version 2 files claiming to be MSBFIRST are imported.
- Nanonis: Slices extracted from 3D data are imported.
- NetCDF: GXSM files that use ‘var_unit’ instead of ‘unit’ for the unit string
  are imported with correct scales.
- Nanoscope: Crash on data channels that do not refer to any soft scale in
  their ZScale and use the raw hard scale was fixed.
- Line layer: Crashes on Win32 while drawing line numbers were fixed, it
  uses PangoCairo instead of Pango FT2 now.
- Basic operations: Function to null horizontal offsets, moving the origin
  to the upper left corner, was added.
- Pixmap export: Can draw an inset scale bar.

Other:
- Dependencies: Gtk+ 2.8 and Pango with Cairo rendering support is now
  required.
- Dependencies: Compilation failure with GLib older than 2.10 (introduced in
  2.8) was fixed.
- Dependencies: Compilation failure with FFTW3 in a non-standard location was
  fixed.


2.8 (2007-08-31)
Application:
- Toolbox: Layout can be customized to certain extent by editing
  ~/.gwyddion/ui/toolbox.xml (manually, there is no GUI for this).

Libraries:
- libgwyprocess: gwy_fft_simple() can handle transforms of arbitrary size.
- libgwyprocess: Resampling was removed from integral transform functions as
  all sizes are always transformable directly now.
- libgwyprocess: New grain quantity area at grain half-height.
- libgwyprocess: New class GwyGrainValue representing built-in and
  user-defined grain properties.
- libgwydgets: Icons in Gwyddion user directory (~/.gwyddion/pixmaps) are
  registered, allowing to install modules with new icons to home.
- libgwydgets: When basic Gwy3DWindow controls are shown, it is possible to
  select the mode with keys R(otation), S(cale), V(alue scale), L(ight).
- libgwydgets: Functions to display and operate with a grain value tree view.
- libgwydgets: Graph axes can be set to logarithmic regardless of the data.
  For the abscissa, display is limited to positive values.  For the ordinate,
  the absolute value is plotted.

Modules:
- JPK: A typo causing failure to load any JPK file was fixed.
- Omicron: Empty spectroscopy files are ignored instead of crashing on them.
- FFT, CWT, FFT filters: Data are no longer resampled, images of all
  dimensions are transformed as they are.
- DWT, DWT anisotropy: Possibly bogus output on data with dimensions not
  being powers of 2 was fixed.  They honour the selected interpolation type
  instead of always using linear.
- DWT: The output resampling option was removed.
- Grain measure, Grain distributions, Grain correlations: Grain area at
  half-height was added.
- Grain correlations, Grain distributions: the selectors now use tree views.
- Tip operations: Tips with non-matching measures are offered too, with a
  resampling notice.
- Grain mark by threshold and remove by threshold: Also display the real
  threshold height next to the percentage.

Other:
- Dependencies: Autoconf 2.60 is required to build from svn checkout and/or for
  development.
- Unix compilation: It builds with builddir != srcdir.
- Unix compilation: libpython should be properly detected on FreeBSD now.
- Unix compilation: Configure option --enable-library-bloat, enforcing linking
  of libraries (including modules) with all their dependencies, was added.
- Unix compilation: Configure option --enable-gtk-doc behaves as is usual in
  other packages (enabling build documentation as a part of ‘all’ target).
- Unix compilation: Some more build system clean-ups.


2.7 (2007-06-26)
Application:
- Metadata browser:  It is possible to save the metadata.
- Remote control: Infinite startup notification after remote file opening was
  fixed.
- Toolbox: The Tools toolbox was reorganized from a more or less chronological
  tool order to functionality-based groups.
- Metadata: Crash in Metadata browser upon metadata edit when it was repeatedly
  closed and reopened was fixed.
- Files: It is possible to merge data from other files into a loaded file.
- Translations updated: German, Italian.

Libraries:
- libgwyddion: New class of curve fitting presets: GwyFDCurvePreset.
- libgwyddion: New maths function to test whether a point is inside a polygon.
- libgwyddion: New NL fitter presets Gaussian and Exponential RPSDF.
- libgwyddion: Exponential PSDF normalization factor was corrected, the
  wrong one gave about 6% lower σ.
- libgwyddion: Initial parameter value estimators for ACF and PSDF functions
  were improved.
- libgwyddion: GwyContainer has methods to obtain all keys.
- libgwyprocess: New GwySpectra object representing single point spectra.
- libgwyprocess: gwy_fft_simple() FFT backend can handle transform sizes of form
  2^n 3^m 5^k.
- libgwyprocess: Bogus complex 2D FFT transform in the case of
  gwy_fft_simple() backend was fixed.
- libgwyprocess: Fractal interpolation works with Microsoft floating point
  implementation.
- libgwyprocess: New grain distribution quantities x and y centre position,
  inclination theta ϑ and φ.
- libgwyprocess: Wrong type assertions in gwy_data_line_fft_raw() were fixed.
- libgwyprocess: Complex one-dimensional transforms actually work with FFTW3.
- libgwyprocess: Elliptic area functions invalidate data field properly.
- libgwyprocess: gwy_data_field_circular_area_extract_with_pos() actually
  extracts positions with origin in the central pixel.
- libgwyprocess: Possible array bad memory access in
  gwy_data_field_get_autorange() was fixed.
- libgwyprocess: DataField cache is not serialized any more and serialized
  caches are ignored on deserialization.
- libgwyprocess: New methods to calculate 2D autocorrelation function.
- libgwydgets: 3D view shows value units in z labels (instead of lateral).
- libgwydgets: gwy_data_view_export_pixbuf() honours realsquare setting.
- libgwydgets: Impossibility to edit graph selection boundaries when it was
  drawn the ‘wrong’ direction was fixed.
- libgwydgets: Invisible graph label (key) getting in the way of selection was
  fixed.
- libgwydgets: GwyLayerBasic has a new "default-range-type" property for color
  range mapping type used when none is set in the data.
- libgwydgets: Logarithmic axes sometimes starting at values larger than the
  minimum were fixed.
- libgwydgets: GwyGraph's model is registered as property "model".
- libgwydgets: GwyGraphWindow ‘logarithmic scale’ buttons initial state
  is set properly and it reflects graph model changes.
- libgwymodule: Module browser displays also modules that failed to load,
  with the failure reason.
- libgwydgets: Strange display when physically but not pixel-wise square data
  were rotated by 90 degrees in physically square display mode was corrected.
- libgwyapp: Data browser acquired a Spectra tab and its API some SPS related
  functions.
- libgwyapp: Up to date thumbnails are no longer overwritten.
- libgwyapp: Possible crash in Document history when a file is saved under a
  new name was fixed.

Modules:
- Path level tool (new): Levels rows along arbitrary lines.
- Spectro tool (new): Visualize and extract single point spectra.
- Grain measure tool (new): Calculate characteristics of individual grains.
- Rougness tool (new): ISO roughness parameters evaluation.
- Cut Graph (new): Extracts parts of graph curves.
- FD Curve Fit (new): Fits force data curves.
- ACF 2D (new): Calculates two-dimensional autocorrelation function.
- Pygwy: Scripts much closer to first-class data processing and file modules
  are possible now if the script is written a Python module exporting
  appropriate interface.
- Pygwy: It is possible to build on MS Windows (not enabled by default, the
  module status is still experimental).
- Pygwy: Various changes to how the Python interpreter is embedded, more
  not automatically generated functions were added.
- Pixmap import: It is possible to set arbitrary units, the preview is bigger.
- Pixmap export: Text size can be set independently, zoom can be specified by
  desired width and height, cases of wrong preview scaling were fixed.
- Edge: New Step step detection function.
- 2D FFT: Limitation to rectangular images was removed.
- Omicron: Imports single point spectra.
- PSIA: It does not require libTIFF any more, crashes due to PSIA files not
  being proper TIFF files were fixed.
- Rawfile: Critical messages on Reset were fixed.
- Gwyfile: It does not remap channel and graph ids upon load and save.
- ASCII export: It has options to enforce dot as the decimal separator and to
  add a comment header with some channel information.
- SDfile: Can export too (text format only).
- Nanoscope: The z-scale of imported version 4.x files was corrected and
  their channel types are used for channel titles now.
- Nanoscope: Supports Nanoscope III STM files.
- Nanonis: Supports version 2 files.
- WSxM: Flipped data was fixed.
- Polynomial distortion: GtkEntry errors when instant update took too long
  were fixed.
- Facet level: Data with undefined inclinations due to incompatible units are
  rejected now, convergence test was corrected.
- Grain distributions: New Correlate function to plot one grain quantity as
  a function of another.
- Convolution filter: Divisor value is actually used for normalization
  instead of being ignored.
- Point layer: Radius indicator scales properly when the layer is scaled.
- Calibrate: The precision of scale spin buttons was increased.
- Graph fit, Critical dimensions: Disambiguating ‘prefixes|’ left visible in
  user interface labels were fixed.
- File modules: Some sanity checks were added.
- Distance tool: It is possible to save the table.
- Grain distributions: Grain positions and inclinations were added.
- Slope distribution: Inclination theta distribution was added.
- 2D FFT filter: Resampled vertical resolution is displayed properly (instead
  of displaying horizontal resolution again).
- Read Value, Level3: Show selection check button initial state is set
  properly.
- Color Range tool: It is possible to set default color mapping type applied
  when none is specifically set. Manual range setting was enabled.
- Statistical functions: Radial PSDF was added.
- Mask editor tool: New option to prevent merging of grains by growing mask.
- Read Value: Can shift data values to make the currently selected point lie
  on the zero plane.
- Level3: New option to make the fitted plane the zero value plane.
- Mask editor tool: Thin lines were added to the set of possible shapes.
- User interface: Symbol of theta which often rendered wrong on Win32 was
  replaced with another glyph.
- Read Value: It no longer displays 123456 as the x pixel coordinate when no
  data is loaded.
- Edge: Local Non-linearity and Inclination output is less blocky as the
  calculations use circular neighbourhoods now.
- Nanoscope: Can loads files with ‘Scan Size’ in place of ‘Scan size’ field.
- 2D FFT filter: Exchanged lateral resolutions and units of FFT output and
  filtered image were corrected.
- Graph level: Emits curve data change notification so that the graph can
  redraw itself properly.
- RHK-SM2 and RHK-SM3: Horizontally flipped images were corrected.
- Basicops: Square samples function uses Round interpolation for masks now.
- Drift compensation: Garbage mask that was briefly displayed on the first
  update do not appear any more.
- Crop: Physically square display mode is honoured on the new cut channel.
- Grain mark, watershed, scars, drift correction, polynomial distortion,
  FFT filters: physically square display mode is honoured in previews.
- 1D FFT filter: Various odd effects of the vertical filter on non-square data
  were corrected.

Other:
- Desktop integration: Freedesktop MIME types conflicting with existing types
  were removed or otherwise corrected.
- Unix compilation: RPM spec file removes .la files manually again as certain
  distros aggressively re-generate all autotools files.
- Development: Distributed API documentation links to on-line versions of other
  documentation (Gtk+, GLib, ...) instead of random local locations.
  Packagers are recommended to rebuild the documentation to obtain local
  links appropriate for their systems.
- Development: API documentation look and feel matches gwyddion.net, more or
  less.


2.5 (2007-03-10)
Application:
- Remote control: Options for opening files in an already running instance of
  Gwyddion were added (--remote-new, --remote-existing).
- Files: It is possible to save a file with graphs only.
- Files: Drag'n'drop of files onto toolbox actually works now with modern
  file managers and on Win32.
- User interface: It's possible to copy (compatible) curves among graphs by
  Drag'n'drop from
  graph Curves, and delete them by pressing Delete key in Curves.
- Translations updated: Czech, German, Italian.

Libraries:
- libgwyddion: NL fitter presets can derive parameter units from the units
  of fitted curves.
- libgwyddion: gwy_math_humanize_numbers() tries harder to make numbers
  around 1 be written without 10^3/10^-3 multipliers.
- libgwyddion: ROUND() was deprecated, use namespace-clean GWY_ROUND().
- libgwyddion: New SI Unit function to take root of a unit.
- libgwyprocess: New function for general xy plane transform/distortion
  gwy_data_field_distort().
- libgwyprocess: Critical dimension evaluator can derive parameter units from
  the units of fitted data.
- libgwyprocess: Skewed gwy_data_field_area_fit_local_planes() output for
  even plane sizes was fixed.
- libgwydgets: New GwyGraphCurves widget showing the curve list with
  properties, it's used in GwyGraphWindow.
- libgwydgets: Light source ϑ and φ determined by the same mouse
  coordinate were fixed.
- libgwydgets: A few more graph symbols were added, useless ‘double dash’
  line style was removed (from GUI selectors, it remains in the Gdk enum).
- libgwydgets: Numeric scale and value scale entries in GwyGraphWindow allow
  non-integer values.
- libgwyapp: Document history Prune button bug causing Critical Gtk+ messages
  was fixed.
- libgwyapp: Drag'n'drop is really possible also with data browser graph list,
  not just with channels.
- libgwyapp: Data and graph windows not getting keyboard focus were fixed.

Modules:
- Polynomial Distortion (new): Distorts (or corrects distortion) in xy plane.
- Nanoscope II (new): Old Nanoscope II file import.
- Intematix (new): Intematix SDF file import.
- Pygwy (new): Direct python scripting support.  Currently highly experimental
  (and disabled by default) and Unix-only.
- Graph fit, Critical dimension: User interface was improved, fitted parameters
  have units, fitted curve can be added to the original graph, results saving
  was integrated into the dialogue.
- Raw file import: It's possible to set arbitrary units, the preview is
  bigger, user interface improvements.
- Profile tool: Tool settings are remembered.
- Omicron: Imported images flipped upside down were fixed.

Other:
- Desktop integration: Freedesktop file type associations were extended to many
  more file types.
- Desktop integration: File associations created now run ‘gwyddion
  --remote-new’ instead of just ‘gwyddion’ therefore files are opened in
  running instances by default.
- Desktop integration: Gwyddion icon is now installed to the corresponding
  hicolor icon theme directory instead to the top-level icon directory.
- Unix compilation: Flag -fno-strict-aliasing is now automatically added to
  CFLAGS when compiled with gcc to prevent miscompilation.
- Dependencies: Gtk-doc 1.8 or newer is required to rebuild the API reference.


2.4 (2007-02-01)
Application:
- Unix compilation: Build failure due to the missing #include <unistd.h> in
  gwymoduleutils.c (from 2.3) was fixed.
- Translations updated: Italian, Czech.

Libraries:
- libgwyddion: New unit arithmetic function gwy_si_unit_power_multiply() was
  added.
- libgwyprocess: 1D convolution and Gaussian filters were added.
- libgwyprocess: 3x3 convolution filters are more efficient due to a
  specialized implementation.
- libgwyprocess: Height and angle distribution y-units are x-units^-1 now,
  so that the full integral is 1 also unit-wise.
- libgwydgets: GwyAxis sometimes using too low precision (from 2.3) was fixed.
- libgwyapp: Miscellaneous binary data file import problems caused by the
  new floating point data getters were fixed by reverting to the old
  implementation.
- libgwyapp: Fixed crash when a mask or presentation was added to a channel in
  a multi-channel file and then the channel was immediately deleted.
- libgwyapp: Changing file type in file open dialog when filtering is enabled
  updates the list of displayed files to match the new file type.

Modules:
- Edge: Zero crossing edge detector was added.
- Grain statistics: Can calculate total grain volumes.
- Filters tool: Gaussian smoothing filter was added.
- Nanonis: Import of non-square images was hopefully fixed.
- Convolution filter: Minor user interface fixes.
- Edge: Laplacian no longer clears border lines of pixels of output.
- Statistical functions: The labels on x and y axes match how the quantities
  are denoted in the user guide.

Other:
- Unix compilation: Confusion between AM_FOO and FOO variables in makefiles was
  resolved, user variables such as CFLAGS, LIBS can be really used for
  overriding now.


2.3 (2007-01-21)
Application:
- Translations updated: Italian, Czech.

Libraries:
- libgwyprocess: Function gwy_data_field_get_grain_bounding_boxes() finds
  bounding boxes of all grains.
- libgwyprocess: Volume and grain volume calculation functions were added.
- libgwyprocess: Slightly wrong grain surface area estimate calculation was
  fixed.
- libgwyprocess: Possible write out of array borders due to rounding errors
  in gwy_data_field_area_dh() was fixed.
- libgwydgets: Data view checks xreal, yreal changes when updating and
  recalculates measures.
- libgwydgets: GwyNullStore iter_nth_child() method sets the iter properly,
  fixing use in as a combo box model.
- libgwydgets: Ctrl-C to copy graph image to clipboard actually works.
- libgwydgets: Truncated logarithmic axes were fixed.
- libgwydgets: Formatting of both logarithmic and linear axis ticks was
  improved.
- libgwydgets, libgwyapp: Miscellaneous small memory leaks were fixed.
- libgwyapp: Application 3D windows have ‘Set Defaults’ button that makes
  the current view parameters defaults for new views.
- libgwyapp: Document history view can be filtered by name.
- libgwyapp: A set of utility functions for file modules was added.
- libgwyapp: A set of utility functions for saving reports and other auxiliary
  data was added.
- libgwyapp: Convenience functions to set ‘waiting’ cursor on windows were
  added.
- libgwyapp: File is loaded for preview is reused for the real load instead
  of throwing it away and loading again.
- libgwyapp: Wrong graph and data process toolbox sensitivity after closing
  a graph was fixed.
- libgwyapp: File previews were disabled for Gtk+ 2.6 because GtkIconView
  implements GtkCellLayout only since 2.8.  The version check is run-time,
  an executable compiled with Gtk+ 2.6 will display previews when run with
  a newer Gtk+.

Modules:
- MicroProf (new): MicroProf FRT data file import.
- Slope distribution: Coordinates of output were corrected to be really the
  derivatives, not just proportional to them.
- Pixmap: Crash with fixed gdk-pixbuf which properly closes pixbuf loaders
  on failure was fixed.
- Calibrate: Crash when presentation is present on data was fixed.
- Merge: Possible crashes and wrong output size on certain input data sizes
  were fixed.
- Facet analysis: φ calculation was unified with other modules, the size of
  neighbourhood used to calculate local inclinations can be controlled.
- Mark scars: Instant updates option is available.
- Fit Sphere: Swapped x and y was fixed, radii smaller than data size work,
  data offsets are honoured, palette and other attributes are copied to the
  result
- RHK SPM32 (SM2): Support for semi-broken files probably written by Nova
  software was added.
- JEOL: Support for more data subtypes was added.
- Read value tool: Can display the selection marker with averaging radius.
- Rawfile: Skipping fields works when delimiter is ‘any whitespace’.
- Mark scars, Mark grains by threshold, Mark grains by watershed, Remove
  grains by threshold, Drift, Facet analysis, Immerse: Colour mapping settings
  from the data window are honoured in the preview.
- Grain watershed: Initial mask drawing artefacts were fixed.
- Grain distributions: Grain volumes were added.
- NT-MDT: Frame title is used for channel title (if present), some more
  metadata was added.
- NetCDF: Attribute long_name is used for channel title of GXSM files.
- Fit Sphere, Graph Fit, Graph CD: Use the new Gtk+ file chooser dialogues
  instead of GtkFileSelection.
- Statistical quantities: Export that could become confused over whether
  lateral and value units are identical by data window switch during the
  export dialogue was fixed.
- Pixmap: Possible hang in preview was fixed.

Other:
- Unix compilation: ./configure warning about too old FFTW3 version should be
  printed only on really 64bit systems now.


2.2 (2006-12-15)
Application:
- Files: File open dialogues have a preview (showing all channels in the file).
- 3D view: Export uses the new Gtk+ file dialog (as everything else).
- Translations updated: Italian, Czech.

Libraries:
- libgwyprocess: Broken B-spline and Omoms interpolations were made identical
  to Key where they could not be fixed.  A new set of interpolation functions
  that work with non-interpolating basis too was added.
- libgwyprocess: Interpolation and convolution filters use mirror-extension
  for outside data values instead of various kluges.
- libgwyprocess: Cubic Schaum interpolation was added.
- libgwyprocess: New functions to get row/column statistics.
- libgwyprocess: New functions to get mean root square of derivatives of data
  lines.
- libgwydgets: Several reference leaks, namely in graph widgets, were fixed
  and proper chaining of destroy() and finalize() method added.
- libgwydgets: GwyLayerBasic disconnects from previous container item
  properly when presentation key is changed.
- libgwydgets: Artifical limitations on possible data view zooms were
  removed.
- libgwydgets: GwyDataWindow title displays initial zoom correctly when the
  window is autosized to fit to the screen.
- libgwyapp: Menu construction hang when two identical items occurred was
  fixed.
- libgwyapp: Crash in tools using rectangular selection when no data was
  present and the selection was modified manually was fixed (it is not
  possible to modify the selection when there's no data now).

Modules:
- DME file (new): DME Rasterscope data file import.
- JEOL file (new): JEOL SPM data import.
- NetCDF (new): NetCDF file import, currently only GXSM files.
- Convolution filter (new): General convolution filter with user-defined
  matrix.
- Row/column statistics tool (new): Calculates characteristics of each row
  or column in selected area.
- Drift compensation (new): Simple correction of drift seen in the slow
  scanning axis.
- Mask operations: It is possible to copy mask from one channel to another.
- PNI file: Missing value endian conversion was added (affected big-endian
  machines).
- Rotate: Units lost with enabled expansion were fixed.
- Read value tool: Displays local plane inclination angles too.
- Edge: New method Inclination visualizes local slope angle.
- Distance: φ value convention matches other tools and functions now.
- 2D FFT: Transform output has the origin of coordinates in the centre, as
  it should be. Transform input is no more normalized and output has proper
  normalization with respect to input.
- STMPRG: Import of metadata was fixed.
- Graph export ASCII: Export crash bug was fixed.
- Miscellaneous process modules: The look and labels of preview updating
  buttons were unified.
- Pixmap: Export honours data field coordinate origin offsets.

Other:
- Compilation: Build errors on big-endian systems (from 2.1) were fixed.


2.1 (2006-11-05)
Application:
- Translations updated: Italian, Czech.
- Toolbox: Style was modernized a bit.

Libraries:
- libgwyddion: Function gwy_memcpy_byte_swap() to copy memory swapping bytes
  along according to given pattern was added.
- libgwyprocess: Correlation iterators sometimes reporting progress (slightly)
  higher than 1.0 were fixed.
- libgwyprocess: A set of raw FFT functions, that however still abstract the
  FFT backend, was added.
- libgwyprocess: gwy_data_line_new_resampled(), similar to
  gwy_data_field_new_resampled() was added.
- libgwyprocess: gwy_data_field_fft_filter_1d() actually works.
- libgwyprocess: Functions to get median of data lines added.
- libgwydgets: Value formatting in graph distance measure window was
  improved.
- libgwydgets: Graph area problems (broken selection, zoom) on Gtk+ 2.6 was
  fixed.
- libgwydgets: gwy_graph_model_remove_curve_by_description() disconnecting
  wrong signal handlers was fixed.
- libgwydgets: Graph selections have per-class headers, gwygraphselections.h
  includes them all.  They also have standard gwy_selection_graph_foo_new()
  constructors now.
- libgwydgets: A convenience function to pack a radio button group to a table
  was added.
- libgwymodule: It is possible to get the score corresponding to the detected
  file type with gwy_file_detect_with_score().
- libgwyapp: File name in data browser is properly updated when a file is
  saved under a different name.
- libgwyapp: File type selection user interface was improved, filtering by
  file type is possible.
- libgwyapp: Repeat Last menu item behaving identically to Re-Show was fixed.

Modules:
- PSIA (new): Imports PSIA data files.
- HDF4 (new): Imports HDF4 files, currently only PSI HDF.
- 1D FFT filter: Was ported to version 2.x and restored.
- BCR file: Supports a new file subtype with UTF-18 encoded text header.
- Immerse: User interface was rewritten and speed was improved by several
  orders so that the module is actually usable now.
- JPK scan: It's no longer built when too old libtiff is detected.
- Profile, Distance tools: Individual lines can be deleted by selecting them
  in the list and pressing Delete key.
- Graph ASCII (text) export: Crashes on check button changes and broken
  Close button were fixed.
- Grain and Scars: Mask colour dialogue hiding under the main dialogue on Win32
  was fixed.
- Colour Range tool: Fixed range is not lost upon switch to another data and
  back.
- Graph fit, Critical dimension: Graphs can be resized by resizing the
  dialogue.
- Fractal: Saving of parameters to data instead of settings was fixed.
- Gwyfile: Metadata left out in bogus places in the container on save was
  fixed.
- 2D FFT filter: Was fixed for non-nice data field sizes, displays resampling
  information in the dialogue.
- Scale: It is possible to scale width and height differently.
- Filters: New Dechecker filter for checker pattern removal.
- Nanoscope: Tries harder to import something from files with strange
  dimensions.

Other:
- Compilation: Missing file utils/genmarshal.mk was added to distribution.
- Unix compensation: Private header files installed by mistake are no longer
  installed.
- Source code packages: Intermediate gtk-doc files are no longer distributed
  (the resulting HTML API documentation is present in the source tarball as
  usual).
- Compilation: Building and portability problems were fixed (mainly on
  non-GNU/Linux and from Subversion checkout).
- Development: Module tutorial was brought up to date and expanded.


2.0 (2006-09-30)
Application:
- Toolbox: Edit/Mask colour menu item and similar right-click menu item are
  sensitive only when a mask is present (fixing crashes when they were
  activated without a mask).
- User interface: Data browser window can be closed, Meta/Show Data Browser
  displays it again and/or raises and deminimizes it.
- User interface: Data browser UI was reorganized.
- User interface: It is possible to copy channels and graphs to new or other
  open files (using data browser buttons and/or drag'n'drop).
- 3D view: The 3D window reflects channel title changes.
- Translations updated: Czech.

Libraries:
- all libraries: library base names was changed to libgwyfoo2 with versions
  starting from 0 again. Unix shared library versioning was switched from
  hardcoded versions back to normal.
- libgwydgets: GwyColorAxis behaviour for bad ranges was improved.
- libgwydgets: Set Curve Colour dialogue is updated properly upon switch to
  another curve.
- libgwydgets: Curve titles are no longer reset to empty upon switch to
  another curve.
- libgwydgets: Wrong position of the bottom axis label on exported pixmaps was
  fixed.
- libgwydgets: Possibility to move invisible graph legend was fixed.
- libgwydgets: Graph widget updates are really model-driven now, various
  refresh functions were removed.
- libgwydgets: GwyAxis makes a clear difference between requested and
  actually used range, the latter no longer affects the former.  Graph axis
  range API was reworked.
- libgwydgets: Most getters and setters were removed from GwyGraphModel and
  GwyGraphCurveModel interfaces in favour of properties.
- libgwydgets: GwyGraphModel and GwyGraphCurveModel can calculate axis range
  request themselves and cache the results.
- libgwydgets: Questionable GwyGraphModel signal "layout-updated" was
  removed, graph model properly emits notifications on property changes,
  it has new "curve-data-changed" and "curve-notify" signals that simplify
  notifications of curve changes.
- libgwydgets: Auxiliary graph dialogue user interface was improved.
- libgwydgets: Graph vector export crash when on unimplemented point symbol
  types was fixed.
- libgwydgets: Dashed line style really works in graphs.
- libgwydgets: Miscellaneous changes in the graph API with bogus functions or
  function arguments removed, misnamed functions renamed and argument
  handling sanitized.
- libgwyapp: gwy_app_copy_data_items() was renamed to
  gwy_app_sync_data_items(), it can synchronize more items and deletion is
  optional now.

Modules:
- Shade: Crash on Mix check button click was fixed.
- Color Range tool: Crash upon tool switch when there was already a selection
  was fixed.
- Assing AFM: Crash on import introduced in 1.99.9 was fixed.
- Revolve arc, Median background: Bugs causing subsequent application crashes
  were fixed.
- Fit sphere: Was ported to 2.0 and re-enabled.
- SPMLab: Channel type is imported and used as the channel title.
- Crop, Colour Range, Filters, Mask editor, Statistical function, Statistical
  quantities: Wrong selection boundaries when it was drawn ‘backwards’ were
  fixed.
- Graph exports: User interface was made more consistent, memory leaks were
  fixed.
- Mark Grain by Threshold: Instant updates option is available.
- Remove Grain by Threshold: Instant updates option is available.

Other:
- Unix compilation: Source files dependent on ./configure-set installation
  paths are properly rebuilt when ./configure is re-run.


1.99.9 (2006-09-07)
Libraries:
- libgwydgets: Always insensitive 3D window light position controls were
  fixed.
- libgwydgets: 3D window controls not always reflecting 3D view's state were
  fixed.

Modules:
- File modules: Many ‘Unknown channel’s were replaced with meaningful channel
  names, disabled metadata import was restored for most file types.
- Statistical quantities: Initial sensitivity of Save was fixed, preventing
  attempts to save non-existent statistics that led to crashes.
- SPML import: Miscellaneous small fixes and improvements.
- Gwyfile: Rectangle, point and line selections are imported from 1.x files.
- ASCII export: Exports the current channel instead of always the first one.
- Shade: Mixing GUI was improved.


1.99.8 (2006-08-10)
Application:
- Files: Crash on app exit when Document history is open was fixed.
- Files: Recent files menu items have thumbnails.
- Data browser: Miscellaneous bugs were fixed.
- Data browser: Channel and graph titles are editable.
- User interface: Colour axis does not display ticks/values when they are not
  applicable.
- Files: Metadata more or less work again (although most modules have their
  creation still disabled).
- Translations updated: Czech.  New translations started: German.

Libraries:
- libgwyddion: Version information is now available.
- libgwyprocess: Functions to check data field and line compatibility.
- libgwyprocess: Laplace interpolation speed was improved.
- libgwyprocess: Grain numbering speed was improved.
- libgwyprocess: Non-FFT correlation speed was improved.
- libgwyprocess: Watershed and correlation iterative interfaces were improved.
- libgwyprocess: Inclusion mask argument added to
  gwy_data_field_area_fit_plane().
- libgwydgets: Gwy3DSetup is a new object which holds 3D scene settings, 3D
  widgets were updated to use it.
- libgwydgets: GwyVectorLayer can disable selection editability.
- libgwydgets: GwyShader is a no-window widget now.
- libgwydgets: GwyVectorLayer no longer automatically instantiates selections.
- libgwydgets: GwyColorAxis ticks and label style is more controllable.
- libgwydgets: Many more GwyAxis properties are user-controllable.
- libgwydgets: Graph and axis size requests and allocations work much more
  like normal widgets.
- libgwydgets: Miscellaneous graph fixes and rectifications.
- libgwymodule: Crash when a module did not register any function was fixed.
- libgwyapp: Data browser can be used without window creation and its window
  can be controlled.
- libgwyapp: Long broken window-list option menu was superseded by
  GwyDataChooser and removed.
- libgwyapp: Settings file manipulation function report problems via GError.
- libgwyapp: gwy_app_init_common() for simpler initialization of Gwyddion
  applications.
- libgwyapp: Miscellaneous deprecated functions were removed, some were
  replaced with similar data-browser based functions.
- libgwyapp: 3D view was integrated to data-browser, it can display any
  channel and crashes were fixed.
- libgwyapp: Enum types are registered to the GObject type system.

Modules:
- PNI file (new): Pacific Nanotechnology PNI file import.
- Nanonis (new): Nanonis SXM file import.
- Shade: Can mix shaded and original data.
- Burleigh: Scaling of physical dimensions and values was corrected.
- Tip dilation, reconstruction and certainty map were merged to one: tipops
  (but it still provides three distinct functions).
- 2D FFT Filter: Ported from 1.x, interface reworked to use masks instead of
  bulky custom marker code, and non-square data is now supported.
- 2D FFT: fft output now defaults to DFit gradient and "Auto" color range for
  improved visibility.
- Level, Level rotate: Option to exclude/include mask area in calculation
  (only offered if a mask exists).
- Level3: Instant apply is possible.
- Crop: Create new channel losing original data information was fixed.
- Correlation and tip modules: Ported to multi-data and enabled again;
  idiosyncratic source data choosers were removed, only suitable data fields
  are offered as tips/kernels.
- Layer modules: Updated to support disabling of editability.
- Plug-in proxy: Ported to multi-data (it passes the current data channel to
  the plug-in).

Other:
- MS Windows compilation: MSC nmake compilation rules include proper
  dependencies.
- Unix compilation: Confusion of host and target systems in configure, breaking
  for example FreeBSD ports build, was fixed.
- Unix compilation: Problem with installation of translations affecting for
  instance FreeBSD was fixed.


1.99.7 (2006-05-28)
Application:
- User interface: It is possible to switch between pixel-wise square and
  physically-square display modes (via upper left data window corner menu).
- User interface: There were some tool GUI behaviour changes, generally towards
  more explicit control by the user.

Libraries:
- libgwydddion: Memory corruption on big-endian machines in serialization and
  deserialization was fixed (bug #73).
- libgwyddion: gwy_math_humanize_numbers() behaves reasonably for zero values
  (bug #70).
- libgwydddion: New GwyStringList class (forward compatibility stub).
- libgwyprocess: Remaining data field area functions were converted to
  (col, row, width, heigh) rectangle specification.
- libgwyprocess: Pixel-wise statistical functions and surface area gained a new
  argument: mask of pixels to take into account.
- libgwyprocess: Fitting of polynomials with limited total degree was added.
- libgwyprocess: New elliptic and circular region functions.
- libgwyprocess: Grain statistics interface is more general and powerful,
  a few new grain characteristics were added.
- libgwydgets: Gwyradiobuttons functions no longer use the arbitrary key
  parameter.
- libgwydgets: GwyGraphData works with arbitrary number of curves.
- libgwydgets: GwyNullStore ‘virtual’ GtkTreeModel class.
- libgwydgets: GwyColorAxis draws ticks instead of just the middle marker.
- libgwydgets: Graph selections are GwySelection based now.
- libgwydgets: All graph property dialogues apply changes instantly.
- libgwydgets: Miscellaneous graph fixes and clean-up.
- libgwymodule: Unification and clean-up, all module types have for-each
  functions, headers are includeable individually.
- libgwyapp: New classes GwyTool and GwyPlainTool for tool implementation.
- libgwyapp: Rectangular selection info table was reworked and it allows direct
  user input.
- libgwyapp: Tool dialogues can be hidden with Escape and by clicking on the
  tool button in toolbox.
- libgwyapp: Unitool is finally gone.
- libgwyapp: Thumbnail creation/update works again (they show the first data
  channel).
- libgwyapp: Miscellaneous deprecated functions were removed.

Modules:
- Disabled modules: Several, namely multi-data related, processing modules were
  temporarily disabled due to excessive brokeness.
- Omicron (new): Omicron (Scala) file import.
- SEIKO (new): Seiko XQD file import.
- Burleigh (new): Burleigh IMG v2.1 file import.
- ECS (new): ECS IMG file import.
- Surffile (new): Surf file import.
- Nanotop (new): Nanotop SPM file import.
- MetroPro (new): Binary Zygo MetroPro file import.
- SPML (new): SMPL file import.
- Hitachi AFM: Import of another strain of Hitachi AFM files was added.
- BCR file: Void pixel handling was improved (bug #67).
- RHK SPM32: Value offsets are respected.
- RHK-SM3: Can import newer files (XPMPro 1.1.0.9) (bug #71).
- Nanoscope: Import of format versions 3 and 4 was improved (or made possible
  at all).
- Polynomial level: Fitting of polynomials with limited total degree is
  possible.
- Grain distribution: Reworked; offers selection from several grain quantities,
  allows to explicitly set sampling, can export raw data to a file (bug #69
  made irrelevant).
- Line correction: Step correction function (new, experimental).
- Read Value, Level3: Value averaging uses circular neighbourhood instead of
  a square.
- Distance, Profile: The number of allowed lines was increased.
- Crop: Can crop image in place or create a new image.
- Mask Editor: Can remove, invert, fill, grow, and shrink masks; the editor
  functions work with elliptic selections too.
- Spot Remove: Only zoom center is selected on data windows, the area to
  interpolate is selected on zoomed view.
- Statistical quantities: Can calculate values only from pixels under mask
  into account, save results to a text file, switch off instant calculation.
- Statistical functions: Can switch off instant calculation.
- Mask grow/shrink: Removed, superseded by the new Mask Editor.
- Filters: Instant apply was removed, it caused more troubles than it worths.

Other:
- Dependencies: Gtk+ 2.8 is required on MS Windows.
- Dependencies: Gwyddion now depends on libxml2 used for SPML import
  (optionally, if you compile it from source code).
- Compilation: gwyconfig.h no longer requires to include math.h first.
- Unix compilation: The sample C++ plug-in is not built (but still distributed)
  and the build should no longer require a C++ compiler.


1.99.6 (2006-02-26)
Application:
- Files: Support for more data channels in one file was added (not finished).
- Files: New file selection dialogues, with embedded file type options
  (replacing File Export and Import menus) and possibility to select several
  files.
- Toolbox: Icons are now larger and colourful.
- Files: Loading/saving errors are reported in the GUI instead of being printed
  to console.
- Files: When gwyddion is run with a directory argument, it opens a file
  selector in this directory.
- Files: Metadata is editable.
- Resources: Color Gradient Editor allows control point snapping

Libraries:
- libgwyddion: gwy_container_rename() actually works.
- libgwyprocess: FFT functions offer more levelling choices, line-wise
  levelling was fixed.
- libgwyprocess: Polynomial leveling using Legendre polynomials was added.
- libgwydgets: API to focus one selection object added to vector layers.
- libgwydgets: GwySensitivityGroup flag-based widget sensitivity manager.
- libgwydgets: GwyDataWindow can resize when dimension of the displayed data
  field change.
- libgwydgets: GwyDataView supports 1:1 aspect ratio in real dimensions.
- libgwydgets: GwyCurve support snapping to control points positions.
- libgwydgets: Miscellaneous graph fixes.
- libgwymodule: Feature registration and some module function signatures have
  changed, graph and process modules provide icon and tooltip information
  now, there were some other interface changes.
- libgwymodule: Save operations were split to save and export, the latter
  does not cause file name change.
- libgwymodule: File modules report errors via GError, have interactive/
  /noninteractive run modes.
- libgwymodule, libgwyapp: Run modes was changed to match reality.
- libgwymodule, libgwyapp: Construction of menus from registered modules was
  moved to app.
- libgwyapp: A data browser was added, taking over most of app.h
  functionality.
- libgwyapp: A class of undo functions that accept quarks was added.
- libgwyapp: Module functions with untranslated menu paths are properly
  merged into translated menus.
- libgwyapp: Process function usage statistics are gathered (no effect on
  GUI yet).

Modules:
- Immerse (new): Immerse higher-resolution detain into an image.
- Merge (new): Merge (join) images together.
- All: Feature registration has changed, more, less, or different information
  is provided for particular function types during registration.
- File modules: Import all (importable) data present in files instead of
  presenting channel choosers.  Metadata were temporarily disabled in most
  modules.
- Rawfile: It is possible to switch off automatic import of unknown files as
  raw data, presets are stored in external files, a few GUI fixes.
- BCR file: Handling of void pixels was improved (bug #67).
- Polynomial level: It has a preview now, maximum degree was increased.
- FFT: Subtract mean value preprocession option was added, correct resampled
  image size is displayed also when FFTW is used.
- Rotate 90 deg CW, Rotate 90 deg CCW: Data are changed in place now.
- Mark, remove scars: It is possible to mark positive and negative at once.
- Layer modules: Support for focusing one object was added, nearest object
  search in ellipse and rectangle was fixed.
- Pixmap: Odd preview of images with an alpha channel was fixed, full support
  for alpha channel added.
- Presentationops: Logscale presentation was added.


1.99.5 (2005-12-20)
Application:
- Unix compilation: Installations are relocatable via environment variables.
- Resources: Colour gradient and GL material editors actually work.
- Translations updated: Italian, Czech.
- Files: Names of files drag-and-dropped onto toolbox are preserved.

Libraries:
- libgwyddion: Serialization is two stage now (calculate size, then
  serialize), fixing repeated memory reallocations.
- libgwyddion: Exponential (PSDF) fitting preset was fixed, Power,
  Lorentzian, sinc function presets added.
- libgwyprocess: FFTW integration was finished, all integral transform methods
  can use FFTW backend now (with some API changes to accommodate that).
- libgwyprocess: GwyDataLine now carries units, like GwyDataField.
- libgwyprocess: Default GwyDataField and GwyDataLine units are empty
  (unitless) instead of meters now.
- libgwyprocess: Methods to copy units between GwyDataLine and GwyDataField
  were added, most functions creating GwyDataLines from GwyDataFields set
  correct units on the target.
- libgwydgets: Broken graph curve removal was fixed.
- libgwydgets: Crashes and other problems with multiple 3D views were fixed
  (bug #53).
- libgwydgets: Ruler tick formatting was improved, it can use non-integer
  formats when they are suitable.
- libgwydgets: Just moving mouse over data windows should consume much less
  CPU.
- libgwydgets: Changes in data view and vector layers to enable drawing
  selections on exported images.
- libgwydgets: Miscellaneous graph widget improvements.
- libgwydgets: GwyHMarkerBox widget, a horizontal box with movable markers,
  with GwyMarkerBox base class.
- libgwydgets: GwyValUnit was finally removed.
- libgwydgets: Gwy3DView now takes container keys instead of direct objects
  for some properies, but not for all yet.
- libgwyapp: Unitool rectangular selection info supports lateral offsets.
- libgwyapp: Utility GwyResourceEditor base class resource editors are based
  on now.
- libgwyapp: Too long file names are ellipsized in tool headers, full file
  name is shown in a tooltip.

Modules:
- RHK-SM3 (new): RHK Technology SM3 file import.
- WITfile (new): WITec WIT file import.
- SDFile (new): Surfstand Surface Data File (SDF) import.
- Hitachi AFM (new): Hitachi AFM file import.
- Unisoku (new): Unisoku HDR + DAT file import.
- EZDfile: Explict support for NID files was added, some bugs fixed.
- MI file: Updated to reflect format changes.
- Rawfile: Always black preview was fixed.
- Pixmap: Can draw selection on exported image, checkboxes for mask and
  selection were added.
- BCR file: Wrong y scale on files that do not have explicit units was fixed.
- Lines layer: Jagged line number edges were fixed.
- Layer modules: Support for exporting selections to pixmap images.
- Level3, Read value: Display properly lateral offsets.
- Crop: Allows to either keep lateral offsets where the data was cut, or
  reset them to zero.
- Calibrate: Can set lateral offsets now.
- Tip blind estimate, Tip model: Broken controls work again.
- Basicops: Can resample data in one direction to make samples square.
- Plugin-proxy: Missing byte reordering on big-endian machines was added
  (bug #65).
- Statistical functions: Resolution can be automatic too, as before.
- Graph function fit: Result param values can be easily copied to initial.
- Plug-in proxy: No longer writes metadata (but still accepts it back).
- Grain distribution: Simple grain statistics (count, mean area, ...).

Other:
- Dependencies: FFTW3 is recommended now.
- Development: Developer documentation was moved from tmpl files to source
  code.


1.99.4 (2005-10-06)
Application:
- System: chdir() is no longer used, so that e.g. core is always dumped to the
  directory where app was started, otherwise directory behaviour has not
  changed.
- Resources: Color gradient and GL material editors, the only functionality
  that actually works now is Set default.

Libraries:
- libgwyddion: New GwyInventory uniform hash-and-array-like container class.
- libgwyddion: New GwyResource abstract base class for gradients, materials,
  and other goodies.  Resources can be loaded from and saved to external
  files.
- libgwyddion: GwyEnum was split from gwyutils, a some functions added,
  GwyInventory support was added.
- libgwyddion: gwywin32unistd.h was removed, use gstdio wrappers.
- libgwyddion: Text entities are in a GwyInventory instead of a raw array.
- libgwyddion, libgwydgets: GwyWatchable was finally removed.
- libgwyprocess: All interpolation is pixel-like instead of function-like now.
- libgwyprocess: GwyEnum tables of standard enumerations are available in
  public API.
- libgwyprocess: Memory leaks in DWT were fixes and it was sped up.
- libgwyprocess, libgwydgets: Data field and line interpolation was changed to
  centered data value style.
- libgwyprocess: Real line length calculation method was added, too small
  calculated area was fixed.
- libgwyprocess: Overloaded gwy_data_line_get_stat_function() was replaced
  with individual statistical functions, several of them are faster now.
- libgwyprocess, libgwydgets: GwyDataField and GwyDataLine support
  presentational offsets of coordinates origin, widgets support them to some
  extent.
- libgwyprocess: Minkowski volume, boundary, and connectivity (Euler
  characteristics) statistical functions were added.
- libgwyprocess: FFT backend argument was removed from FFT functions.
- libgwydraw: GwyGradient is based on GwyResource, API reworked.  Gradients
  were un-hardcoded and are distributed as stand-alone text files now.
- libgwydraw, libgwydgets: GwyGLMaterial was moved from libgwydgets to
  libgwydraw, based on GwyResource, and more or less reimplemented.
  GL materials were unhardcoded.  Material pixbuf samples are nicer.
- libgwydraw, libgwydgets: Experimental adaptive color mapping mode was added.
- libgwydraw, libgwydgets: GwySelection data selection abstract base class,
  GwyVectorLayer reworked to use it.
- libgwydgets: New gradient and GL material selection and tree view
  constructors.  It's possible to set which gradients are directly displayed
  in data window colour axis right-click menu.
- libgwydgets: GwySciText uses table-like layout for symbol combo box
  (bug #60) and was otherwise improved.
- libgwydgets: New class GwyInventoryStore wraps GwyInventory in GtkTreeModel
  interface.
- libgwydgets: Option menus were replaced with combo boxes.
- libgwydgets, libgwyapp: A one global GtkTooltips object is used now,
  API added to widgets to accommodate this.
- libgwydgets: Crashes when mask/presentation is removed were fixed.
- libgwydgets: 3D Window crash on Export from small toolbar was fixed.
- libgwydgets: It's possible to get real GwyDataView zoom, GwyDataWindow
  displays that in window title instead of requested zoom.
- libgwydgets: Vertical rulers look like rotated horizontal rulers now.
- libgwydgets: Graph: API cleaned, logarithmic axis reworked and enabled,
  offsets introduced, GwySelection implemented, signals properly implemented,
  set/get properties implemented, export GUI moved to modules, graph selection
  can be moved while creating it.
- libgwyapp: Undo bug that might cause crashes was fixed.
- libgwyapp: Undo was generalized to work with arbitrary item types; it also
  exports lower-level functions usable for undo outside main app windows.

Modules:
- MI file (new): PicoView MI data file import.
- BCR file: Unit support was improved, support for zmin added.
- Profile: Maximum profile width was increased to 100.
- Statistical functions, Profile: Allow to select number of sampling points.
- Profile: Minkowski functionals were added.
- Facet analysis: Improvements were merged from 1.12.
- Layer modules: Reworked to use GwySelection, "pointer" and "points" merged,
  various other changes, all support selection setting now as a side effect.
- Rectangular selection: Hold Shift to select exact squares.
- Line selection: Hold Shift to select lines in ‘nice’ directions.
- Ellipses layer (new): Elliptic (circular) selections.
- Slope and grain distribution: Ported to the new graph API.
- Distance: Displays value difference too.
- Pixmap: The same unit selection/formatting is used for false color scale
  as on data windows (bug #63).
- Graph export vector, ascii and bitmap: functionality moved from Graph
  (within bugs) moved here
- Graph level: Simple line levelling by 1st order polynomial.

Other:
- Unix compilation: Modules are built with libtool, so it should be possible to
  build Gwyddion on more systems, but it's impossible to run Gwyddion
  uninstalled again.
- MS Windows compilation: MSVC makefile templates (.gwt) are distributed in
  source code tarball, allowing to re-generate makefile.msc files.
- Resources: Missing Italic stock icon was added.
- Resources: A few new colour gradients and GL materials were added.


1.99.3 (2005-07-11)
Application:
- Sync: Bugfixes were merged from 1.11 (bug #49, bug #54) and some from 1.12.
- System: Running uninstalled is supported now (with caution).
- User interface: Metadata browser closes with corresponding data window; if a
  browser for some data already exists, it's presented instead of creating a
  second one.

Libraries:
- all libraries: Bug fixes were merged from 1.11.
- libgwyddion: GwyContainer emits a signal "item-changed::/item/key" when
  a item changes.
- libgwyddion: Deprecated gwy_math_SI_unit_prefix() was removed,
  gwy_si_unit_get_format_for_pow10() should replace it.
- libgwyddion: A quicksort function specialized for doubles was added.
- libgwyddion: Marquardt-Levenberg NL fitter derivation function can avoid
  derivations by fixed parameters, and the default numeric one avoids it.
- libgwyddion: Support for optional component serialization and
  desetialization.
- libgwyddion: Expression evaluator allows definition of user constants,
  adds constant folding and vectorized expression execution.
- libgwyddion, libgwyprocess: SI Unit value formats styles were exposed in the
  API, each value format get function now has an addition style parameter.
- libgwyddion, libgwyprocess, libgwydgets: GwyWatchable interface was
  deprecated, and will be removed in 1.99.4.  Some previous implementors have
  their own "value-changed" signal, some have different signal(s), or none.
- libgwyprocess: GwyDataField and GwyDataLine have "data_changed" signal.
- libgwyprocess: gwy_data_field_resize() calculates new physical dimensions
  correctly.
- libgwyprocess: Surface area calculation was reimplemented with a faster and
  more precise method, and it's cached now.
- libgwyprocess: Basic statistics function on data field parts are diverted
  to full-field statistics if part is actually complete data field, allowing
  better cache utilization.
- libgwyprocess: DataField stats cache is serialized and deserialized.
- libgwydgets: GwyPixmapLayer can display data field identified by arbitrary
  key (actually it requires to set a key now) and reacts on its
  "data_changed" signal.
- libgwydgets: Shader widget has rudimentary support for insensitive state.
- libgwydgets: gwy_option_menu_metric_unit() takes a SI Unit instead of
  a string now.
- libgwydgets: DataView can resize when base data field size changes.
- libgwydgets: Unused DataWindow zoom mode setting was removed.
- libgwydgets: Former GwyGraph was replaced with new widget (called GwyGrapher
  in previous versions). The new graph widget is constructed to draw
  directly GwyGraphModel data, is able to handle multiple selections
  and is constructed to be easily exported to various formats.
- libgwydgets: GwyGraphWindow is now being constructed as a result
  of any processing module creating graphs. This widget supports graph zooms
  and graph measuring that was previously in several graph modules.
  It is also possible to see the data values directly as a table.
  GwyGraphWindow currently handles also exports to bitmap, text and postscript,
  which will be probably moved to modules in next version.
- libgwydgets: GwyLayerBasic and GwyLayerMask no longer have their own
  properties, they take all values directly from container.
- libgwydgets, libgwyprocess: GwyLayerBasic colour range mode are explicit now,
  auto-range mode was implemented.
- libgwydgets, libgwyapp: Explicite updates gwy_data_view_update() and
  gwy_app_data_view_update() were removed as view updates are now triggered
  by signals.
- libgwydmodule, libgwyapp: ‘Interactive’ data processing run type was
  removed.
- libgwyapp: Data processing module return value is ignored, functions have
  to emit "data_changed" on changed data fields.
- libgwyapp: All undo functions work on Containers now, some were renamed to
  accommodate that; object-data trickery was replaced with a proper API.

Modules:
- JPK Scan (new): JPK data file import (bug #57).
- Facet Analysis (new): Visualizes, marks and measures facet orientations
  (not fully forward-ported from 1.12).
- All: Updated for data (view) notification changes.
- Files: File import modules use auto-range mode for preview, that should
  improve preview of data with outliers.
- Color range tool: Supports auto-range mode.
- Points layer: Supports set_selection(), if selection is one point it does
  not have to be dragged, click is enough to move it.
- Pixmap: Import from TIFF images was enabled on MS Windows too.
- Sync: Bug fixes were merged from 1.11 (bug #44, bug #46, bug #42, bug #52,
  others).
- Graph points, measure, zoom, unzoom: Removed as this functionality is now in
  the GwyGraphWindow widget directly.

Other:
- Dependencies: GLib and Gtk+ 2.6 is required now.
- Dependencies: Can optionally use FFTW v3 library (currently only for a few
  operations).
- Dependencies: It's possible to build Gwyddion without OpenGL support.
- Sync: Bugfixes were merged from 1.11 (bug #51).
- MS Windows compilation: It should build on Win32 again.


1.99.2 (2005-04-18)
Libraries:
- all libraries: bug fixes were forward-ported from 1.10
- libgwyddion: GwySerializable has a new method clone to transform an
  object to duplicate of an existing one.
- libgwyddion: SI Unit GwyWatchable interface actually works.
- libgwyddion: Marquardt-Levenberg NL fitter supports linked parameters (API
  changed).
- libgwyprocess: Data field stats caching was implemented.
- libgwyprocess: Proper types and enmus were defined for FFT functions.
- libgwyprocess: GwyDataLine clean-up, including removal of some bogus
  interfaces.
- libgwyprocess, libgwydgets, libgwymodule: All enum types are registered in
  GObject type system, enum class properties were changed from guints to real
  enums.
- libgwydgets: A function to maintain one global PangoFT2Map was introduced,
  3DView uses it now.
- libgwydgets: Vector layer cursor ref/unref helpers were renamed and moved to
  utils, as they are used elsewhere.
- libgwymodule: File detection functions now get a struct with various file
  information instead of filename as first argument.

Modules:
- Sync: New file modules and improvements were forward-ported from 1.10
  (apefile, assing-afm, bcrfile, ezdfile, pixmap, rhk-spm32, spmlab, stpfile,
  wsxmfile).
- Sync: Nanoindentation modules were forward-ported from 1.10.
- Pixmap: False colour scale export is disabled when presentation is shown.
- Rectangular selection layer: Dot left on image after deselection was fixed.
- Sync: Bugfixes were forward-ported from 1.10

Other:
- Unix compilation: A platform info header gwyconfig.h was introduced, similar
  to glibconfig.h.


1.99.1 (2005-03-22)
Application:
- System: Support for long deprecated binary settings file was removed

Libraries:
- libgwyddion, libgwyprocess, libgwydgets: non-widget object constructors
  (Container, SIUnit, DataField, ...) return particular types instead of
  GObject*
- libgwyprocess: Circular dependency between datafield.h (dataline.h) and
  specialized method headers have been broken: datafield.h no longer includes
  specialized headers.
- libgwyprocess, libgwydgets, libgwymodule: Enum definitions were extracted to
- libgwyprocess, libgwydgets: Many deprecated/unimplemented functions were
  removed, some unimplemented function arguments were removed.
- libgwyprocess: Angle arguments in degrees were changed to radians.
- libgwyprocess: GwySIUnit internal representation changed from plain string to
  structured.
- libgwyprocess: Broken conservative filter was fixed.
  a separate header; enums are registered as GObject types.
- libgwydraw: GwyPaletteDef, GwyPalette were removed (replaced by
  GwyGradient).
- libgwydgets: GwySphereCoords and GwyGradSphere were removed (replaced by
  GwyShader), GwyVectorShade was removed (no replacement).
- libgwydgets: GwyVMenubar, GwyToolbox were removed (no replacement).
- libgwydgets: Gwy3DLabels were replaced by (conceptually different)
  Gwy3DLabel, other changes in Gwy3DView data types.
- libgwydgets: Headers no longer directly depends on GL headers,
  GwyGLMaterial uses ordinary gdoubles.
- libgwydgets, libgwyapp: 3D windows are properly destroyed when closed.
- libgwymodule: Module names are derived from module file names, they were
  removed from module ABI.

Modules:
- Gwyfile: Saves the new file format (can be read by version 1.7+), loads both.


1.16 (2006-04-18)
Application:
- Translations updated: Czech.

Libraries:
- libgwydddion: Memory corruption on big-endian machines in serialization and
  deserialization was fixed (bug #73).
- libgwyddion: gwy_math_humanize_numbers() behaves reasonably for zero values
  (bug #70).
- libgwyprocess: Grain statistics were fixed.
- libgwydgets: Gwy3DView displays correct units on all axes.

Modules:
- Omicron (new): Omicron (Scala) file import.
- Surffile (new): Surf file import.
- Nanotop (new): Nanotop SPM file import.
- SPML (new): SMPL file import.
- MetroPro (new): Binary Zygo MetroPro file import.
- Burleigh (new): Burleigh IMG v2.1 file import (experimental).
- SDFile: Import support was significantly improved.
- BCR file: Void pixel handling was improved (bug #67).
- Grain distribution: Height distribution was added (bug #69).
- RHK-SPM32: Value offsets are respected.
- RHK-SM3: Can import newer files (XPMPro 1.1.0.9) (bug #71).
- Line correction: Step correction function (new, experimental).
- Nanoscope: No longer crashes when channel name is missing.

Other:
- Dependencies: Gwyddion now depends on libxml2 used for SPML import
  (optionally, if you compile it from source code).
- MS Windows: JPK import module previously omitted in Win32 binaries was added.


1.15 (2006-01-02)
Application:
- OS X compilation: Compilation on Mac OS X was fixed (bug #64).
- Translations updated: Italian.

Modules:
- BCR file: Wrong y scale on files that do not have explicit units was fixed.
- Hitachi AFM file: Reading raw data as signed instead of unsigned was fixed.
- Plugin-proxy: Missing byte reordering on big-endian machines was added
  (bug #65).
- Basicops: Can resample data in one direction to make samples square.
- Grain distribution: Simple grain statistics (count, mean area, ...).
- Rawfile: Message dialogues forced above main dialogue (bug #66).


1.14 (2005-11-07)
Application:
- System: Unix installations are relocatable via environment variables.
- Translations updated: Czech.

Libraries:
- libgwydgets: Crashes and other problems with multiple 3D views were fixed
  (bug #53).
- libgwydgets: ‘Invalid UTF-8 string...’ messages in 3D view were fixed
  (not sure about bug #28 connection).
- libgwydgets: Just moving mouse over data windows should consume much less
  CPU.

Modules:
- RHK-SM3 (new): RHK Technology SM3 file import.
- WITfile (new): WITec WIT file import.
- SDFile (new): Surfstand Surface Data File (SDF) import.
- Hitachi AFM (new): Hitachi AFM file import.
- Unisoku (new): Unisoku HDR + DAT file import.
- EZDfile: Explict support for NID files was added, some bugs fixed.
- MI file: Updated to reflect format changes.
- Pixmap: The same unit selection/formatting is used for false color scale
  as on data windows (bug #63).


1.13 (2005-09-19)
Application:
- Translations updated: Italian.

Libraries:
- libgwyprocess: Minkowski functionals were added to line stat. function.

Modules:
- MI file (new): PicoView MI data file import.
- 2D FFT filtering: Drawing artefacts were fixed, color range was fixed, zoom
  option added, "Original" and "Difference" display modes added,
  inclusion/exclusion behaviour fixed (more user friendly).
- SFunctions: Minkowski volume, boundary, and connectivity (Euler
  characteristics) functionals were added.
- BCR file: Unit support was improved, support for zmin added.
- STP file: Channel labels fixed.
- Statistical functions, Profile: Allow to select number of sampling points.
- Profile: Maximum profile width was increased to 100.

Other:
- Unix compilation: Modules are built with libtool, fixing portability problems
  to Mac OS X.
- Resources: Missing Italic stock icon was added.


1.12 (2005-07-15)
Application:
- Translations updated: Italian, Czech.
- 3D view: Invisible keyboard focus in 3D windows was fixed.

Libraries:
- libgwyddion: Possible crash in expression evaluation was fixed.
- libgwydgets: Colour axis crash when data minimum and maximum were both 0 was
  fixed (bug #56).
- libgwyapp: It is possible to apply a filter to data window option menu
  items.

Modules:
- JPK Scan (new): JPK data file import (bug #57).
- 2D FFT filter (new): Filtering in the 2D frequency domain.
- Facet Analysis (new): Visualizes, marks and measures facet orientations.
- Assing AFM: Wrong z scale in import and export was fixed.
- NT-MDT: Bogus data import when x and y resolution differs was fixed.
- Colour Range tool: ‘Instant apply’ aggressivity was somewhat reduced (bug
  #58).
- Presentation operations: Can attach one data to another as presentation.
- Points layer: Supports set_selection(), if selection is one point it does
  not have to be dragged, click is enough to move it.
- Pixmap: Import from TIFF images was enables on MS Windows too.
- Nanoindent analyse: Useless controls were removed from the dialog.


1.11 (2005-06-03)
Application:
- User interface: Markup works in metadata browser (bug #49).
- Toolbox: Is not restored to off-screen position after quitting app minimized
  (bug #54).
- Translations updated: Italian, Czech.

Libraries:
- libgwyprocess: Grain size distribution x-scale was corrected.

Modules:
- RHK-SPM32: Supports multi-page files.
- SPMLab: Imports data with correct units (bug #44).
- NT-MDT: Incorrect data import was fixed (bug #46).
- STPFile: Incorrect height data import was fixed.
- NT-MDT: GUI problems with files containing too many channels were mitigated
  (bug #42).
- Assing AFM: compilation failure on big endian architectures was fixed
  (bug #52).
- Fix zero, zero mean value: Move fixed colour range together with data
  (if it exists).

Other:
- Unix compilation: Wrong libtool detection in autogen.sh was fixed (bug #51).


1.10 (2005-04-07)
Application:
- Translations updated: Czech, Italian.

Libraries:
- libgwyddion: Marquardt-Levenberg NL fitter fixed parameters actually work
  now.
- libgwyddion: gwy_si_unit_get_unit_strings() recomposes the string from
  internal representation so that works for non-trivial units too.
- libgwyprocess: Rotation correction mysteriously broken on Win32 was no less
  mysteriously fixed.
- libgwyprocess: Nanoindentation functions.
- libgwydgets: 3D view reflected with respect to 2D was fixed.

Modules:
- APEfile (new): Applied Physics and Engineering data file import.
- BCRfile (new): Image Metrology BCR data file import.
- RHK-SPM32 (new): RHK SPM32 data file import.
- WSxM (new): Nanotec WSxM data file import.
- EZDFile (new): Nanosurf EZD data file import.
- Nanoident analyse (new): Analyses nanoindent structures (volume, surfaces,
  etc.).
- Nanoindent adjust (new): Adjusts images of two indentor prints.
- Pixmap: False colour scale is correct when explicit colour range is set
  (bug #43).
- Assing AFM: Supports also save.
- SPMLab: Supports R6 file format import.
- Calibrate: Applying calibrating ratios squared was fixed.


1.9 (2005-03-09)
Application:
- System: Startup time was improved.
- New translation: Italian (partial).

Libraries:
- libgwyddion: Simple arithmetic expression evaluator.
- libgwyprocess: Local rms filter, Kuwahara filter, local plane fitting
  functions.
- libgwydgets: Shader can focus and is keyboard-controllable.
- libgwymodule: Public functions for obtaining module list and detailed module
  information.

Modules:
- Assing AFM (new): Imports Assing AFM data files.
- 1D FFT Filter (new): Filtering in the frequency space (1D).
- Mark, remove scars: Can remove negative scars too.
- Edge detection: Experimental RMS, RMS Edge, and Local Non-linearity filters
  were added.
- Rotate: Preview showing wrong angle was fixed.
- Presentation operations: Extract presentation was added.
- Filter: Kuwahara filter was added.
- Stats: Displays inclination angles too.
- Createc: Supports more format versions.
- Rawfile: Warning message when adding a new preset was fixed, shows only
  file basename in Info tab.
- Line correct: Another experimental Median line correct method.

Other:
- Unix compilation: Build system fixes and clean-up.
- Compilation: Compilation and run-time problems on AMD64 were fixed.


1.8 (2005-01-24)
Application:
- Command line: Option --no-splash recognized anywhere in command line,
  --debug-objects added.
- Files: Document history now displays physical dimensions too, starts faster,
  and remembers more files.

Libraries:
- libgwyddion: Better SI unit parsing, multiplication, division and powers.
- libgwyddion: Value formatting bug causing data ranges consisting entirely
  of negative values to be displayed as (NaN, NaN) was fixed
- libgwyddion, libgwyprocess: Convenience macros and methods for duplication,
  creation of similar data fields and lines.
- libgwyprocess: Minumum and maximum filters.
- libgwydraw: New GwyGradient class that will replace GwyPalette and
  GwyPaletteDef.
- libgwydgets: 3D View not honouring data aspect ratio was fixed
- libgwydgets: New GwyShader widget that will replace GwyGradSphere and
  obsolete GwySphereCoords.

Modules:
- NT-MDT (new): NT-MDT file format import.
- CreaTec STM (new): CreaTec STM file format import.
- Omicron STMPRG (new): Omicron STMPRG file format import.
- Spmlab (new): Spmlab R4 and R5 data import.  Note the closed-source plug-in
  io_tm_common provides better support than this rudimentary reverse-engineered
  module.
- Local contrast (new): Local contrast enhancement presentation.
- Fit sphere (new): Fits sphere on the surface.
- Blind tip estimate: Insensitive OK button when full estimate was run without
  partial estimate first was fixed.
- DWT Anisotropy: Undo and data corruption were fixed.
- Nanoscope, Statistical quantities, FFT: SI unit handling improved.
- FFT, CWT, DWT modules: Display non-square data error immediately.
- FFT module: data are rescaled to unit range before fitting for more stable
  results.
- Unrotate, Rotate: have a preview now.
- Profile: Corrupted graph titles for separate profiles were fixed.
- Grain mark by threshold, watershed, and remove by threshold: Option to use
  inverted surface, GUI reworked.
- Manual grain removal tool: It is possible to remove underlying data or both
  now.
- Mask grow, shrink: Always growing (shrinking) down (up) only one pixel was
  fixed.
- Manual grain removal tool: Crash after switch to Pointer tool was fixed.
- Rawfile: Crash after Reset was fixed.
- Arithmetic: Not recalling that an operand is scalar was fixed.
- Crop tool: Slightly skewed new physical dimensions were corrected.
- All modules: GUI improvements, namely addition of scale controls.

Other:
- Desktop integration: Freedesktop compliance improvements, SPM data MIME type
  definitions.
- Unix: Simple gwyddion(1) manual page was added.


1.7 (2004-12-12)
Application:
- Graphs: Are associated with their data window, it's possible show/hide them
  and they are saved with data.  Note version 1.4 and older may fail to load
  files containing graphs due to forward compatibility bugs.
- User interface: Crashing Metadata browser was fixed.
- Translations: Work on Win32 too.
- Translations updated: Czech.

Modules:
- Mask editor tool (new): Simple mask editor with basic operations.
- Revolve arc (new): Background removal by arc revolution.
- Median background (new): Median-based background removal.
- DWT (new): Discrete wavelet transform.
- Wavelet denoise (new): Wavelet-based denoising module)
- Wavelet anisotropy (new): Wavelet-based anisotropy detection.
- Nanoscope: Import was significantly improved, most files should be read
  with correct value ranges now (bug #16).
- Pixmap: ‘Same resolution’ option really works and its value is remembered.
- Manual grain removal: Undo works.
- Statistical quantities: Area computation was fixed; minimum, maximum and
  median values added.
- Calibrate: GUI was reworked.
- Level: Zero mean value function (similar to fix zero).
- Arithmetic: Broken ‘Physical dimensions differ’ check was fixed.
- Grain mark by watershed: Cancellation behaviour was fixed.
- Grain mark by threshold: Uses data computed in preview for the final
  result, if possible.

Libraries:
- libgwyddion, libgwyprocess: Median calculation functions.
- libgwyddion: Serialization packer and unpacker for hash-like objects, new
  primitive types: string list, object list.
- libgwyprocess: Data field arithmetic functions.
- libgwyprocess: various functions related with discrete wavelet transform.
- libgwyprocess: Speed of most grain methods was considerably improved.
- libgwydgets: 3D View light position marker was fixed to reflect actual light
  position
- libgwydgets: Graph colours consistent between different visuals (bug #22)

Other:
- Unix source packages: pkg-config file broken by 1.6 build system clean up was
  updated.


1.6 (2004-10-26)
Application:
- User interface: Crash when a top-level menus is detached was fixed (bug #30).
- Translations: Internationalization support (gettext) was added, currently
  works only on Unix.

Libraries:
- libgwyddion: Choleski decomposition and solution functions.
- libgwyprocess: Two-dimensional polynomial fitting.
- libgwyprocess: Tip convolution, deconvolution, certainty map analysis,
  modelling and blind tip estimation routines added.
- libgwydgets: Gwy3DWindow switching from palette to material for the first
  time no longer displays all-black data.
- libgwydgets: Gwy3DWindow allows to switch between full and basic controls.
- libgwyapp: Helper functions to manage rectangular selections in tools.
- libgwyapp: Bug #7, Filters confused by tools switch, was fixed.

Modules:
- Color range tool (new): Interactive color range adjustment.
- Distance tool (new): Measure distances and angles in the data (bug #32).
- Polynomial background (new): Subtraction and extraction of polynomial
  background.
- Tip convolution, erosion, modelling, blind tip estimation and certainty map
  analysis (new): Tip modules based on algorithms published by J. Villarrubia.
- Laplacian, Sobel, Prewitt: Moved from Filters tool to separate display
  modules, Canny edge detector was added.
- Filters tool: Wrong selection boundaries was fixed (bug #35).
- Pointer and Level3: Units in table header are updated on data update
  (bug #37).
- Plug-in proxy: Dump files are always written with POSIX real number format
  (bug #31).
- Crop, Filters, Polynom, Statistics, and Spot remove tools: Also display
  dimensions in pixels.
- Unrotate: Fixed displayed rotations being 2Pi multiplies of the real ones.
- Rotate: Fixed crashing on interpolation type change and wrong expanded
  rotations.
- Layers: Fixed not redrawing when number of objects (lines, points, etc.)
  property changes.
- Lines layer: Identifies lines by numbers.
- Statistical function, Profiles, Fractal, Grains size distribution, Slope
  distribution: Graph windows are given meaningful titles (bug #23).
- All modules: GUI unification and fixes.

Other:
- Development: New sample plug-ins in Ruby: invert_ruby and invert_narray.
- Unix compilation: Various build time problems on FreeBSD were fixed.
- Development: Sample C++ plug-in mangling units was fixed (bug #36).
- Development: Installation paths of Gwyddion::dump, Gwyddion.dump, and
  gwyddion/dump were fixed and their import unified via GWYPLUGINLIB
  environment variable (bug #33).
- Development: gwyddion/dump Ruby module implementing plug-in proxy dump
  format.


1.5 (2004-09-21)
Application:
- 3D view: It is possible to display a 3D view of the data.
- Files: Document history (File → Open Recent → Document History) with much
  more remembered files, thumbnails, and additional information.  File
  thumbnails are TMS-compliant and any TMS-aware file manager should display
  them too.
- User interface: Position of main window is remembered between sessions.
- System: Settings that cannot be parsed are no longer silently overwritten and
  user is informed.
- Toolbox: Miscellaneous GUI improvements.

Libraries:
- libgwyddion: MD5 digest, file path canonicalization, and some unistd
  emulation on Win32 functions were added.
- libgwyddion: Deserialization made more robust with regard to future
  extensions and truncated files.
- libgwyprocess: Fractal interpolation added.
- libgwydgets: Gwy3DView, Gwy3DWindow, GwyGLMaterial, Gwy3DLabels -- new
  OpenGL 3D data display widgets.
- libgwydgets: GwyDataView, GwyGradSphere expose event handling improved,
  making them much more usable over network.
- libgwydgets: GwyDataView not displaying the image until resized with
  Gtk+-2.4.6 and newer was fixed.
- libgwydgets: New GwyVMenuBar vertical menu widget.

Modules:
- Calibrate: Crash on startup was fixed (Bug #25).
- Spot remove tool: Can use Laplace solver, fractal interpolation for data
  removal.
- Select layer: Full widget redraws were eliminated, making it much more
  usable over network.
- Nanoscope: Basic metadata support was added (see Metadata Browser).
- Nanoscope: Adds particular data name to window title.
- Rawfile: Allows to select decimal point or decimal comma in ASCII import.

Other:
- Dependencies: GtkGLExt for the new 3D data display capabilities.


1.4 (2004-08-04)
Application:
- MS Windows: Forgetting settings was fixed.
- User interface: Rudimentary Drag'n'Drop support (drag a file to toolbox to
  load it).
- Tools: Show a thumbnail of active data window beside its name.
- User interface: Splash screen no longer screens eventual initial file open
  dialogs.

Libraries:
- all libraries: Explicite functions initializing deserializable classes.
- libgwyddion: gwydebugobjects -- an aid in leaking objects debugging.
- libgwyprocess: gwy_data_line_get_modus() and gwy_data_line_part_get_modus()
  approximate modus functions.
- libgwyprocess: unrotate functionality available as a function
  gwy_data_field_unrotate_find_corrections()
- libgwydgets: GwyValUnit -- value with unit and selection of unit prefix

Modules:
- Calibrate (new): Change XYZ axis real dimensions
- Graph CD (new): Critical dimension measurements.
- SIS (new): SIS data file format import.
- ASCII export (new): Simple export to ASCII data matrix.
- Line correct (new, experimental): Line corrections, currently featuring
  modus based step correction.
- Scars (new, experimental): Scar (line defects) detection and removal.
- Nanoscope, Pixmap, Rawfile, SIS: Import dialog shows a preview.
- Pixmap: Export dialogue shows a preview.
- Rawfile: Fixed Load preset damaging file information.
- Nanoscope, Rawfile: Fixed failure to load data when locale real number
  format differs from POSIX.
- Shade: A preview was added.
- Rotate: Can make the result large enough to show all data after rotation.
- Mask of Outliers: Broken undo was fixed.
- Graph Measure Distances: Selected points are shown in correct position
  after window resize (bug #21).
- Plug-in proxy: Random insensitive plug-in menu items were fixed.
- Plug-in proxy: Alternate plug-in registration method using RGI files
  (without running the plug-ins).
- Grain mark, watershed, remove: Discrepancy between colour button colour and
  actual mask colour when first used was fixed.
- Grain mark, watershed, Spot remove: Memory leaks were fixed.

Other:
- Development: New example plug-ins using Gwyddion::dump, Gwyddion.dump.
- Development: New example plug-ins in C++ and Pascal.
- Development: Gwyddion::dump (Perl) and Gwyddion.dump (Python) modules
  implementing plug-in proxy dump format.
- Development: Dump plug-in allowing to load and save plug-in proxy dump files
  is available on MS Windows too.
- Development: Standard vector layers were documented.


1.3 (2004-06-02)
Application:
- Compatibility: This version is binary and source incompatible with previous
  ones.  Modules have to be recompiled and, in some cases, updated.
- System: Modules and plug-ins are searched also in user directory
  (~/.gwyddion).
- Command line: Option --no-splash disables splash screen.
- User interface: Mask colour changes are immediately previewed on corresponding
  data views.

Libraries:
- libgwyddion: GwySerializable and GwyWatchable borken interface definitions
  fixed; GwySerializable uses GByteArray now.
- libgwyprocess, libgwyapp: Some functions with typos in names and functions
  that should have never been public were removed from API.
- libgwydraw: GwyRGBA conversion and container helper functions, it is
  registered as a GType type.
- libgwydgets: GwyColorButton reduction to a simple dialogue-less button using
  GwyRGBA instead of Gdk colours.  Mask colour selector helper
  gwy_color_selector_for_mask().
- libgwymodule: Processing modules sensitivity flags moved directly to
  GwyProcessFuncInfo.
- libgwyapp: Data window option menus directly display thumbnails.

Modules:
- All modules: State of controls is remembered also on Cancel.
- Remove by threshold: Has a mask colour change button too.
- Graph fit: beeping and too small From and To entries were fixed.
- Mask by correlation: Undo works.
- Mask by correlation and Cross-correlation: Misleading placement of ‘Please
  wait' window was fixed.
- Filters: Controls for values that don't make sense are insensitive.

Other:
- Dependencies: Gtk+-2.4 compatibility issues were fixed (namely crashes and
  ugly palette menu layout).


1.2 (2004-05-21)
Application:
- Command line: Options --version and --help work.
- User interface: Data window zoom is keyboard controllable (+, =, -, z).
- Resources: Settings are finally stored in a human readable text file,
  conversion from the binary dump should be automatic and smooth (however, do
  backup).
- User interface: Last Used processing function was differentiated to Repeat
  Last and Re-Show Last, with Ctrl-F and Ctrl-Shfit-F shortcuts.
- User interface: Right click on data window brings a very simple context menu.

Libraries:
- libgwyddion: Text dump/restore of GwyContainer.
- libgwyddion: Presets for common fitting functions for GwyNLFitter, fitting
  with some parameters fixed is possible.
- libgwyprocess: Several area functions were given more logical names and
  ‘cros’ was corrected to ‘cross’ in names; old function names will continue
  to work.
- libgwydgets: Radio button group constructor from GwyEnum.
- libgwyapp: Option menu of data windows.

Modules:
- Unrotate (new): Automagically correct rotation in xy plane.
- Graph fit (new): Fit common functions to graph data.
- Basic mask operations (new): invert, extract, grow, shrink masks.
- Filters: Speed of mean and median filters was dramatically improved.
- Slope distribution: Optionally can use local plane fitting for slopes,
  can create graph of angular slope distribution.
- Angle distribution: Optionally can use local plane fitting.
- Data arithmetic, Cross-correlation, and Mask by correlation: Are regular
  modules now.
- Rawfile: Does not forget presets and settings on Cancel and allow easily
  specify Tab as delimiter.
- Crop: Properly crops masks and presentations.
- Mark by threshold, Mark by watershed, Remove grains by threshold, and
  Laplace: Undo works properly (bug #17, bug #18, bug #19, bug #20).
- Filters: More cases of bug #7 (preview confused by tool switch) were fixed,
  preview properly reflects changes in data.
- Statistical functions: X axis scale was fixed for height and slope
  distributions, PSDF output improved using windowing properly.
- Profile selection: profile "thickness" introduced - up to 20 pixel thick
  averaged profile can be interactively selected and processed.
- All modules: Dialogues have standard (HIG) button orders.

Other:
- Unix compilation: Icons in API documentation should be properly installed on
  install.
- Resources: Several new palettes were added.


1.1 (2004-04-13)
Application:
- Create mask by correlation (new): This can be useful for searching
  for specific patterns on the surface, for example on interferometric
  grids.
- Cross-correlation (new): Matching between two slightly different images
  of the same feature can be found.
- User interface: A bug preventing new windows from appearing in Data
  Arithmetic and correlations in some window managers was fixed.
- User interface: modules not changing data (and creating new windows instead)
  never became ‘Last used’.
- System: Undo/redo memory leak was fixed.

Libraries:
- libgwyddion: Marquardt-Levenberg non-linear least square fitter was
  added (GwyNLFitter).
- libgwyddion: Specific functions for storing enums in GwyContainer were
  added.
- libgwyddion: gwy_strkill() and gwy_strreplace() string utility functions
  were added.
- libgwyprocess: Functions for computing fractal dimension and surface area
  added. Functions for correlation, cross-correlation, outlier detection
  and data correction by Laplace solver added.
- libgwyprocess: Vertical PSDF computation fixed. Some minor bugs having
  no specific influence on results corrected and code cleaned.
- libgwymodule: Data process modules can specify sensitivity of their
  menu entries.

Modules:
- Fractal (new): Fractal dimension of the rough surface can be
  evaluated using partitioning, cube counting, triangulation and power
  spectrum method.
- Laplace (new): Removal of data under mask (of any shape). It uses
  iterative method similar to solving Laplace equation.
- Outliers (new): Create mask by outlier detection using 3σ criterion.
- Pixmap: Can also import data from common bitmap image formats.
- Rawfile: Supports named presets of import parameters.
- Rawfile: No longer resets text/binary parameters when switching to
  the other type.
- Watershed: It is possible to change mask colour.
- Facet-level: shows progress bar and is cancellable.
- Filters tool: Bug #7 (preview confused by tool switch) was mostly fixed.
- Graph points: Bug #15 (bad value formatting) was mostly fixed.
- Shade: Bug #11 (not undoable) was fixed.
- Many modules: Memory leaks fixed.

Other:
- Development: The license of plug-in proxy as a reference dump format
  implementation was clarified.


1.0 (2004-03-10)
Gwyddion:
- Files: Data can be exported to bitmaps with rules, units, scale, etc.
- User interface: Physical unit handling was improved.
- Everywhere: Tons of bug fixes.


0.99.1 (2004-03-02)
Gwyddion:
- First public version: Release candidate 1 for v1.0.

